// ApercuView.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "ApercuView.h"

#include "Options.h"
#include "Decomp.h"
#include "IOFichier.h"

#include "Fichier.h"
#include "MuzipArc.h"
#include "MuzipDoc.h"
#include "MuzipView.h"
#include "BitmapView.h"

#include <GUnicode.h>


class CApercuTexte : public CApercu
{
public:  // Hritage
	
	CApercuTexte(CApercuView* pView, bool fRTF);
	
	UINT GetToolBarID() const { return IDR_APERCUTXT; }
	
	void MAJ();
	void GetInfoText(CString& s);
	void OnSetFont();
	
	bool m_fRTF;
	
	
protected:  // Interne
	
	static DWORD CALLBACK prcMAJTexte(CApercuView* pView, BYTE* pbBuffer, long len, long* plen);
};


class CApercuBitmap : public CApercu
{
public:  // Hritage
	
	CApercuBitmap(CApercuView* pView);
	
	UINT GetToolBarID() const { return IDR_APERCUBMP; }
	
	void GetInfoText(CString& s);
};


class CApercuPerso : public CApercu
{
public:  // Hritage
	
	CApercuPerso(CApercuView* pView) : CApercu(pView) {}
	
	void Init();
};


class CApercuIcoCur : public CApercuPerso
{
public:  // Hritage
	
	CApercuIcoCur(CApercuView* pView, bool fCurseur);
	
	bool m_fCurseur;
};


class CApercuPolice : public CApercu
{
public:  // Hritage
	
	CApercuPolice(CApercuView* pView);
	~CApercuPolice();
	
	UINT GetToolBarID() const { return IDR_APERCUPOLICE; }
	
	void MAJ();
	void GetInfoText(CString& s);
	void OnSetFont() {}
	void OnSetPoliceFont();
	
	
protected:  // Donnes
	
	CFont m_fnt;
	
	static WORD  Swap(WORD&  w);
	static DWORD Swap(DWORD& dw);
};



IMPLEMENT_DYNCREATE(CApercuView, CFormView)
BEGIN_MESSAGE_MAP(CApercuView, CFormView)
	//{{AFX_MSG_MAP(CApercuView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_BN_CLICKED (IDCLBL_MAJ, OnMAJ)
	ON_EN_SETFOCUS(IDCRTF,     OnRtfSetFocus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Indicateurs sur la barre d'tat
static const UINT s_StatusBar[] =
{
	ID_APERCUINDIC_FICHIER,
	ID_APERCUINDIC_INFO,
};


// Constructeur
CApercuView::CApercuView() : CFormView(IDD), m_pBmpView(NULL)
{
	m_pApercu  = NULL;
	m_fRetour  = true;
	m_fDOS     = false;
	m_fRedim   = false;
	m_pFichier = NULL;
	m_idTlb    = 0;
	
	//{{AFX_DATA_INIT(CApercuView)
	//}}AFX_DATA_INIT
}

// Destructeur
CApercuView::~CApercuView()
{
	CloseApercu();
}


// Contrles
void CApercuView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CApercuView)
	DDX_Control(pDX, IDCLBL_MAJ, m_lblMAJ);
	DDX_Control(pDX, IDCRTF,     m_rtf);
	//}}AFX_DATA_MAP
}


// Processus de cration
BOOL CApercuView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
	m_fSelOK = false;
	
	// Crer la vue
	if (!CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
		return FALSE;
	
	// Pas de dfilement
	SetScrollSizes(MM_TEXT, CSize(0,0));
	
	// Crer la vue pour l'aperu des bitmaps
	CCreateContext cc;
	ZeroMemory(&cc, sizeof(cc));
	cc.m_pCurrentDoc = GetDocument();
	m_pBmpView = new CBitmapView(this);
	m_pBmpView->Create(NULL, NULL, WS_CHILD | WS_VISIBLE,
		CRect(0,0,0,0), this, 0, &cc);
	
	return TRUE;
}

// Cration
int CApercuView::OnCreate(CREATESTRUCT* pcs)
{
	if (CFormView::OnCreate(pcs)==-1)
		return -1;
	
	SetScrollSizes(MM_TEXT, CSize(0,0));
	
	// Barre d'outils
	if (!m_tlb.Create(this, WS_CHILD | CBRS_TOOLTIPS | CBRS_FLYBY |
	     CBRS_ALIGN_TOP | CBRS_SIZE_FIXED))
		return -1;
	
	// Barre d'tats
	if (!m_stb.CreateEx(this, SBT_TOOLTIPS) ||
	    !m_stb.SetIndicators(s_StatusBar, nbArray(s_StatusBar)))
		return -1;
	
	// Passer la vue au document
	GetDocument()->m_papr = this;
	
	return 0;
}

// Initialisation
void CApercuView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	
	// Pas d'aperu au dbut
	// On passe (DWORD)-1 pour forcer la fermeture de l'aperu
	SetApercu((CFichier*)(DWORD)-1);
}



// Destruction
void CApercuView::OnDestroy()
{
	CFormView::OnDestroy();
	
	GetDocument()->m_papr = NULL;
}


// Redimensionnement
void CApercuView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);
	Redimensionner();
}
void CApercuView::Redimensionner()
{
	if (::IsWindow(m_rtf)) {
		// Redimensionner les contrles:
		
		CRect rcClient, rc;
		GetClientRect(rcClient);
		rc = rcClient;
		
		// Label de mise  jour
		m_lblMAJ.MoveWindow(rc);
		
		// Barre d'outils
		rc.top    = 0;
		if (m_idTlb) {
			rc.bottom = m_tlb.CalcFixedLayout(TRUE, TRUE).cy;
			m_tlb.MoveWindow(rc);
			m_tlb.RecalcLayout();
		}else
			rc.bottom = 0;
		
		// Barre d'tat
		rc.top    = rc.bottom;
		rc.bottom = rc.top + m_stb.CalcFixedLayout(FALSE, TRUE).cy;
		m_stb.MoveWindow(rc);
		
		// Contrles divers
		rc.top    = rc.bottom+2;
		rc.bottom = rcClient.bottom;
		m_rtf.MoveWindow(rc);
		m_pBmpView->MoveWindow(rc);
	}
}


// Mettre  jour l'aperu
void CApercuView::OnMAJ()
{
	GetDocument()->m_plst->OnApercu();
}

// Initialiser l'apercu
// Passer (DWORD)-1 quivaut  passer NULL et permet de forcer
// la fermeture de l'aperu
void CApercuView::SetApercu(CFichier* pFichier)
{
	m_lblMAJ.ShowWindow(SW_HIDE);
	
	if (pFichier==m_pFichier)
		// Pas de changement
		return;
	
	// (DWORD)-1 quivaut NULL
	// mais on ne fait la conversion qu'aprs la comparaison pFichier==m_pFichier
	if (pFichier==(CFichier*)(DWORD)-1)
		pFichier = NULL;
	
	CloseApercu();
	m_pApercu  = NULL;
	m_pFichier = pFichier;
	
	// Masquer tout
	m_tlb.ShowWindow(SW_HIDE);
	m_stb.ShowWindow(SW_HIDE);
	m_rtf.ShowWindow(SW_HIDE);
	m_pBmpView->ShowWindow(SW_HIDE);
	
	if (pFichier) {
		
		// Mettre  jour la barre d'tat
		m_stb.SetPaneText(m_stb.CommandToIndex(ID_APERCUINDIC_FICHIER),
			pFichier->m_pszNom);
		
		// Dcompresser le fichier
		if (OpenApercuFile()) {
			
			const LPCTSTR pszNom = pFichier->m_pszNom;
			
			if (PathMatchSpec(pszNom, _T("*.bmp")))
				// Image bitmap
				m_pApercu = new CApercuBitmap(this);
				
			else if (PathMatchSpec(pszNom, _T("*.ico")))
				// Icne
				m_pApercu = new CApercuIcoCur(this, false);
				
			else if (PathMatchSpec(pszNom, _T("*.cur")))
				// Curseur
				m_pApercu = new CApercuIcoCur(this, true);
				
			else if (PathMatchSpec(pszNom, _T("*.rtf")))
				// Texte RTF
				m_pApercu = new CApercuTexte(this, true);
				
			else if (PathMatchSpec(pszNom, _T("*.ttf")))
				// Police TrueType
				m_pApercu = new CApercuPolice(this);
				
			else if (e_opt.m_fApercuDefautTexte ||
				       PathMatchSpec(pszNom, _T("*.txt")))
				// Par dfaut: texte
				m_pApercu = new CApercuTexte(this, false);
			
			if (m_pApercu) {
				
				// Afficher la barre d'tat et masquer le label
				m_stb   .ShowWindow(SW_SHOW);
				m_lblMAJ.ShowWindow(SW_HIDE);
				
				// Afficher la barre d'outils
				m_idTlb = m_pApercu->GetToolBarID();
				m_tlb.ShowWindow((m_idTlb) ? SW_SHOW : SW_HIDE);
				m_tlb.LoadToolBar(m_idTlb);
				m_pApercu->MAJ();
				
				// Remplir la zone d'informations dans la barre d'tat
				CString s;
				m_pApercu->GetInfoText(s);
				const int nIndex = m_stb.CommandToIndex(ID_APERCUINDIC_INFO);
				m_stb.SetPaneStyle(nIndex,
					(s.IsEmpty()) ? SBT_NOBORDERS : SBPS_STRETCH);
				m_stb.SetPaneText(nIndex, s);
				
				
				// Remettre tout  jour
				oApp.OnIdle(0);
			}
			oApp.m_fMsg = true;
			
			CloseApercuFile();
		}
	}
	Redimensionner();
	
	RedrawWindow();
}

// Il est possible d'afficher l'aperu,
// mais on ne le fait pas pour l'instant
void CApercuView::PeutApercu()
{
	SetRedraw(FALSE);
	
	// Masquer tout sauf le label "Cliquez ici pour afficher l'aperu"
	m_tlb      .ShowWindow(SW_HIDE);
	m_stb      .ShowWindow(SW_HIDE);
	m_rtf      .ShowWindow(SW_HIDE);
	m_pBmpView->ShowWindow(SW_HIDE);
	m_lblMAJ   .ShowWindow(SW_SHOW);
	
	SetRedraw();
	RedrawWindow();
}

// Ouvrir le fichier de l'aperu dans m_fr
bool CApercuView::OpenApercuFile()
{
	if (m_fr!=INVALID_HANDLE_VALUE)
		return true;
	
	// Dcompresser le fichier
	return
		m_pFichier->CacheAddRef(m_sFileCache) &&
		m_fr.Open(m_sFileCache, FILE_SHARE_ALL);
}

// Fermer le fichier de l'aperu
void CApercuView::CloseApercuFile()
{
	if (m_fr==INVALID_HANDLE_VALUE)
		return;
	
	// Fermer le fichier et le cache
	m_fr.Close();
	m_pFichier->CacheRelease();
}


// Fermer l'aperu courant
void CApercuView::CloseApercu()
{
	delete m_pApercu;
	m_pApercu = NULL;
	
	CloseApercuFile();
}


//*** CApercuTexte

// Constructeur
CApercuTexte::CApercuTexte(CApercuView* pView, bool fRTF)
	: CApercu(pView), m_fRTF(fRTF)
{
	m_pView->m_rtf.ShowWindow(SW_SHOW);
}

// Mettre  jour
void CApercuTexte::MAJ()
{
	m_pView->OpenApercuFile();
	
	EDITSTREAM es;
	es.dwCookie    = (DWORD)m_pView;
	es.pfnCallback = (EDITSTREAMCALLBACK)prcMAJTexte;
	
	CRichEditCtrl &rtf = m_pView->m_rtf;
	rtf.SetWindowText(NULL);
	rtf.SetTargetDevice(NULL, !m_pView->GetDocument()->m_papr->m_fRetour);
	rtf.SetFont(&oApp.m_fntVoir);
	rtf.StreamIn((m_fRTF) ? SF_RTF : SF_TEXT, es);
	
	m_pView->CloseApercuFile();
}

// Rcuprer les informations
void CApercuTexte::GetInfoText(CString& s)
{
	s.Format(IDS_APERCU_TEXTE, m_pView->m_rtf.GetLineCount());
}

// Dfinition de la police
void CApercuTexte::OnSetFont()
{
	if (!m_fRTF)
		CApercu::OnSetFont();
}

// Lecture de fichier RTF
DWORD CALLBACK CApercuTexte::prcMAJTexte(CApercuView* pView, BYTE* pbBuffer, long len, long* plen)
{
	// Remplir le tampon
	*plen = pView->m_fr.ReadLen(pbBuffer, len);
	if (!*plen && !pView->m_fr.IsEOF())
		return 1;   // Erreur
	
	// Convertir de OEM en ASCII si ncessaire
	if (pView->m_fDOS)
		OemToCharBuffA((LPSTR)pbBuffer, (LPSTR)pbBuffer, *plen);
	
	return 0;
}



//*** Visualiseurs

// Destructeur
CApercu::~CApercu()
{
}

// ID de barre d'outils
UINT CApercu::GetToolBarID() const
{
	return IDR_APERCU;
}

// Dfinir la police
void CApercu::SetFont(CFont* pFont)
{
	CRichEditCtrl &rtf = m_pView->m_rtf;
	
	// Dfinir la police
	rtf.SetFont(pFont, FALSE);
	
	// Redessiner le contrle RTF en le redimensionnant deux fois
	// (une fois pour redessiner, une autre fois
	// pour rendre au contrle sa taille d'origine)
	// Cela est ncessaire car le contrle doit refaire la justification
	CRect rc;
	rtf.GetWindowRect(rc);
	m_pView->ScreenToClient(rc);
	rc.right--;
	rtf.MoveWindow(rc, FALSE);
	rc.right++;
	rtf.MoveWindow(rc, TRUE);
}

// Dfinition de la police
void CApercu::OnSetFont()
{
	SetFont(&oApp.m_fntVoir);
}



//*** CApercuBitmap

// Constructeur
CApercuBitmap::CApercuBitmap(CApercuView* pView) : CApercu(pView)
{
	CBitmapView &bmp = *m_pView->m_pBmpView;
	bmp.DeleteBitmap().Attach((HBITMAP)::LoadImage(oApp.m_hInstance,
		m_pView->m_sFileCache, IMAGE_BITMAP, 0,0, LR_LOADFROMFILE));
	bmp.InitBitmap();
	bmp.ShowWindow(SW_SHOW);
}

// Bitmap
void CApercuBitmap::GetInfoText(CString& s)
{
	// Rcuprer les infos sur la bitmap
	CBitmap &bmp = m_pView->m_pBmpView->m_bm;
	BITMAP bm;
	if (!(HBITMAP)bmp || !bmp.GetBitmap(&bm))
		return;
	
	// Formatter les infos
	s.Format(IDS_APERCU_BITMAP,
		bm.bmWidth,bm.bmHeight, bm.bmBitsPixel,
		(bm.bmBitsPixel<=24) ? 1L<<bm.bmBitsPixel : 1L<<24);
}



//*** CApercuPerso

// Initialisation
void CApercuPerso::Init()
{
	m_pView->m_pBmpView->ShowWindow(SW_SHOW);
}

// Icnes
CApercuIcoCur::CApercuIcoCur(CApercuView* pView, bool fCurseur)
	: CApercuPerso(pView), m_fCurseur(fCurseur)
{
	// Compter et charger les icnes grandes et petites
	const UINT nbIcone = ExtractIconEx(m_pView->m_sFileCache,
		-1, NULL, NULL, 0);
	HICON *const phiG = new HICON[nbIcone];
	HICON *const phiP = (fCurseur) ? NULL : new HICON[nbIcone];
	ExtractIconEx(m_pView->m_sFileCache, 0, phiG,phiP, nbIcone);
	
	// Crer la bitmap et dessiner dedans les icnes des deux tailles
	// Pour les curseurs on ne dessine que les grandes
	
	const int cEspace = 10;
	const int cxG = GetSystemMetrics(SM_CXICON);
	const int cyG = GetSystemMetrics(SM_CYICON);
	const int cxP = GetSystemMetrics(SM_CXSMICON);
	const int cyP = GetSystemMetrics(SM_CYSMICON);
	const int cx  = ((fCurseur) ? cxG+cEspace : cxG+cEspace+cxP+cEspace)*nbIcone - cEspace;
	const int cy  = cyG;
	
	CBitmapView &bmp = *m_pView->m_pBmpView;
	CBitmap &bm = bmp.DeleteBitmap();
	bm.CreateBitmap(cx,cy, 1,bmp.m_dc.GetDeviceCaps(BITSPIXEL), NULL);
	bmp.InitBitmap();
	
	// Dessiner les icnes
	bmp.m_dc.FillSolidRect(0,0, cx,cy, RGB(255,255,255));
	int x = 0;
	for (UINT iIcone=0; iIcone<nbIcone; iIcone++) {
		::DrawIconEx(bmp.m_dc, x,0, phiG[iIcone], cxG,cyG, 0, NULL, DI_NORMAL);
		x += cxG + cEspace;
		::DestroyIcon(phiG[iIcone]);
		if (!fCurseur) {
			::DrawIconEx(bmp.m_dc, x,0, phiP[iIcone], cxP,cyP, 0, NULL, DI_NORMAL);
			x += cxP + cEspace;
			::DestroyIcon(phiP[iIcone]);
		}
	}
	
	delete [] phiG;
	delete [] phiP;
	
	Init();
}



//*** CApercuPolice


// Destructeur
CApercuPolice::~CApercuPolice()
{
	RemoveFontResource(m_pView->m_sFileCache);
}


// Transformation de MSB en LSB
// (les fichiers TTF sont en ordre Motorola)
WORD CApercuPolice::Swap(WORD& w)
{
	return w = (WORD)(((w & 0x00FF)<<8) | (w>>8));
}
DWORD CApercuPolice::Swap(DWORD& dw)
{
	return dw =
		((dw & 0x000000FF)<<24) |
		((dw & 0x0000FF00)<< 8) |
		((dw & 0x00FF0000)>> 8) |
		( dw              >>24);
}


// Constructeur
CApercuPolice::CApercuPolice(CApercuView* pView) : CApercu(pView)
{
	// Installer la police
	if (AddFontResource(m_pView->m_sFileCache) < 1)
		return;
	SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0,0);
	
	LOGFONT lf;
	ZeroMemory(&lf, sizeof(lf));
	
	if (!m_pView->OpenApercuFile())
		return;
	CFileRead &fr = m_pView->m_fr;
	
#pragma pack(push,1)
	
	struct FONT_HEADER
	{
		DWORD ver;
		WORD  nbTable;
		WORD  searchRange;
		WORD  entrySelector;
		WORD  rangeShift;
	};
	
	struct FONT_TABLE
	{
		DWORD tag;
		DWORD dwCheckSum;
		DWORD off;
		DWORD len;
	};
	
	struct FONT_NAME
	{
		WORD wFormat;
		WORD nbRec;
		WORD off;
	};
	
	struct FONT_NAMEREC
	{
		WORD idPlatform;
		WORD idPlatformSpecific;
		WORD idLanguage;
		WORD idName;
		WORD len;
		WORD off;
	};
	
	struct FONT_OS2
	{
		WORD   version;
		SHORT  xAvgCharWidth;
		WORD   usWeightClass;
		WORD   usWidthClass;
		SHORT  fsType;
		SHORT  ySubscriptXSize;
		SHORT  ySubscriptYSize;
		SHORT  ySubscriptXOffset;
		SHORT  ySubscriptYOffset;
		SHORT  ySuperscriptXSize;
		SHORT  ySuperscriptYSize;
		SHORT  ySuperscriptXOffset;
		SHORT  ySuperscriptYOffset;
		SHORT  yStrikeoutSize;
		SHORT  yStrikeoutPosition;
		SHORT  sFamilyClass;
		PANOSE panose;
		DWORD  aulUnicodeRange[4];
		CHAR   achVendID[4];
		WORD   fsSelection;
#if 0      // Les donnes qui suivent ne nous servent  rien
		WORD   usFirstCharIndex;
		WORD   usLastCharIndex;
		WORD   sTypoAscender;
		WORD   sTypoDescender;
		WORD   sTypoLineGap;
		WORD   usWinAscent;
		WORD   usWinDescent;
		DWORD  aulCodePageRange[2];
#endif
	};
	
#pragma pack(pop)
	
	WORD  i;
	DWORD offStorage;
	FONT_HEADER hdr;
	FONT_TABLE  tab;
	FONT_NAME   name;
	FONT_OS2    os2;
	DWORD offName, offOS2;
	
	if (!fr.Read(&hdr, sizeof(hdr)))
		goto Fin;
	Swap(hdr.nbTable);
	
	// Chercher les offset des tables 'name' et 'OS/2'
	offName = offOS2 = 0;
	for (i=0;; i++) {
		if (i==hdr.nbTable)
			goto Fin;
		
		if (!fr.Read(&tab, sizeof(tab)))
			goto Fin;
		
		if (tab.tag=='eman')
			offName = tab.off;
		else if (tab.tag=='2/SO')
			offOS2 = tab.off;
		else
			continue;
		
		if (offName>0 && offOS2>0)
			break;
	}
	
	
	//*** S'occuper de la table 'name'
	//*** Il faut trouver le nom de la police
	
	// Table 'name' trouve, maintenant il faut numrer les chanes
	if (!fr.Seek(Swap(offName), FILE_BEGIN) ||
	    !fr.Read(&name, sizeof(name)))
		goto Fin;
	Swap(name.nbRec);
	offStorage = fr.Tell() + Swap(name.off)-sizeof(name);
	
	// numrer les chanes disponibles
	// On prend la premire venue qui contient le nom complet de la police
	for (i=0;; i++) {
		if (i==name.nbRec)
			goto Fin;
		
		// Lire le record
		FONT_NAMEREC rec;
		if (!fr.Read(&rec, sizeof(rec)))
			goto Fin;
		if (rec.idName!=0x0100)
			continue;
		
		// On n'accepte que les chanes du bon format: ASCII ou UNICODE
		// selon la compilation en cours
#ifdef UNICODE
		if (!(rec.idPlatform==0x0300 && rec.idPlatformSpecific==0x0100))
#else
		if   (rec.idPlatform==0x0300 && rec.idPlatformSpecific==0x0100)
#endif
			continue;
		
		Swap(rec.len);
		BYTE *const pb = new BYTE[rec.len+sizeof(TCHAR)];
		if (!fr.Seek(offStorage+Swap(rec.off), FILE_BEGIN) ||
		    !fr.Read(pb, rec.len)) {
			delete [] pb;
			goto Fin;
		}
		
		// OK, on a le nom de la police
#ifdef UNICODE
		((LPWSTR)pb)[rec.len/2] = 0;
		for (LPWSTR wsz=(LPWSTR)pb; *wsz; wsz++)  Swap(*wsz);
#else
		((LPSTR)pb)[rec.len] = 0;
#endif
		lstrcpyn(lf.lfFaceName, (LPTSTR)pb, nbArray(lf.lfFaceName));
		delete [] pb;
		
		break;
	}
	
	
	//*** S'occuper de la table 'OS/2'
	//*** Il faut rcuprer les flags  mettre dans LOGFONT
	
	// Table 'name' trouve, maintenant il faut numrer les chanes
	if (!fr.Seek(Swap(offOS2), FILE_BEGIN) ||
	    !fr.Read(&os2, sizeof(os2)) ||
	     Swap(os2.version)<1)  goto Fin;
	
	lf.lfWeight = Swap(os2.usWeightClass);
	lf.lfWidth  = Swap(os2.usWidthClass);
	Swap(os2.fsSelection);
	lf.lfItalic    = ToBool(os2.fsSelection & (1<<0));
	lf.lfUnderline = ToBool(os2.fsSelection & (1<<1));
	lf.lfStrikeOut = ToBool(os2.fsSelection & (1<<2));
	
	
Fin:
	fr.Close();
	
	
	// Utiliser le nom de la police pour la charger
	// et pour composer le texte
	if (*lf.lfFaceName) {
		lf.lfCharSet = DEFAULT_CHARSET;
		
		// Initialiser le contrle RTF, mode passage  la ligne automatique
		CRichEditCtrl &rtf = m_pView->m_rtf;
		
		// Rcuprer la hauteur de la police
		// car on ne peut pas l'imposer  LOGFONT
		m_fnt.CreateFontIndirect(&lf);
		rtf.SetFont(&m_fnt);
		CDC *const pdc = rtf.GetDC();
		TEXTMETRIC tm;
		pdc->GetTextMetrics(&tm);
		rtf.ReleaseDC(pdc);
		lf.lfHeight = -tm.tmHeight;
		m_fnt.DeleteObject();
		m_fnt.CreateFontIndirect(&lf);
		
		// Raffecter la police au contrle RTF
		// puis afficher ce dernier
		rtf.SetFont(&m_fnt);
		rtf.SetTargetDevice(NULL, 0);
		rtf.ShowWindow(SW_SHOW);
	}
}

// Mettre  jour le texte
void CApercuPolice::MAJ()
{
	LOGFONT lf;
	m_fnt.GetLogFont(&lf);
	
	// Nom de la police
	CString s;
	s.Format(_T("%s\n\n"), lf.lfFaceName);
	
	// Jeu de caractres
	if (e_opt.m_fApercuPoliceTout) {
		for (int c=32; c<256; c++) {
			if (!(c % 32) && c>32)
				s += '\n';
			s += (TCHAR)c;
		}
		s += _T("\n\n");
	}
	
	// Texte supplmentaire
	s += e_opt.m_sApercuPolicePlus;
	m_pView->m_rtf.SetWindowText(s);
}

// Rcuprer les informations
void CApercuPolice::GetInfoText(CString& s)
{
	LOGFONT lf;
	m_fnt.GetLogFont(&lf);
	s = lf.lfFaceName;
}


// Demander les attributs de la police d'affichage
void CApercuPolice::OnSetPoliceFont()
{
	CRichEditCtrl &rtf = m_pView->m_rtf;
	
	// Rcuprer police et couleur du texte
	CHARFORMAT cf;
	rtf.GetDefaultCharFormat(cf);
	LOGFONT lfOrig;
	m_fnt.GetLogFont(&lfOrig);
	
	LOGFONT lfTemp = lfOrig;
	CFontDialog dlgFont(&lfTemp, CF_EFFECTS | CF_BOTH);
	dlgFont.m_cf.rgbColors = (cf.dwEffects & CFE_AUTOCOLOR)
		? GetSysColor(COLOR_WINDOWTEXT) : cf.crTextColor;
	if (dlgFont.DoModal()==IDOK) {
		
		// Recrer la police
		LOGFONT lf;
		dlgFont.GetCurrentFont(&lf);
		lstrcpy(lf.lfFaceName, lfOrig.lfFaceName);
		lf.lfWeight = lfOrig.lfWeight;
		lf.lfItalic = lfOrig.lfItalic;
		m_fnt.DeleteObject();
		m_fnt.CreateFontIndirect(&lf);
		
		// Affecter la police et la couleur
		SetFont(&m_fnt);
		rtf.GetDefaultCharFormat(cf);
		cf.dwMask     |= CFM_COLOR;
		cf.crTextColor = dlgFont.GetColor();
		if (cf.crTextColor==GetSysColor(COLOR_WINDOWTEXT))
			cf.dwEffects |=  CFE_AUTOCOLOR;
		else
			cf.dwEffects &= ~CFE_AUTOCOLOR;
		rtf.SetDefaultCharFormat(cf);
		rtf.SendMessage(EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cf);
	}
}


// Focus reu
// Contourner un petit bug agaant: la totalit du contrle
// est slectionn la premire fois qu'il reoit le focus
void CApercuView::OnRtfSetFocus()
{
	if (!m_fSelOK) {
		m_fSelOK = true;
		m_rtf.SetSel(0,0);
	}
}
