// ApercuView.h


#ifndef _APERCUVIEW_H_
#define _APERCUVIEW_H_
#if _MSC_VER>1000
#pragma once
#endif

#define TOOLBAREX_REG
#include "AppResource.h"
#include <ToolBarEx.h>
#include <FileBuf.h>

class CMuzipDoc;
class CApercu;
class CBitmapView;


class CApercuView : public CFormView
{
	DECLARE_DYNCREATE(CApercuView)
	
public:  // Fonctions
	
	CApercuView();
	~CApercuView();
	
	CMuzipDoc* GetDocument() { return (CMuzipDoc*)m_pDocument; }
	
	void SetApercu(CFichier* pFichier);
	void PeutApercu();
	
	bool OpenApercuFile();
	void CloseApercuFile();
	
	
protected:  // Interne
	
	void CloseApercu();
	void Redimensionner();
	
	
public:  // Donnes
	
	//{{AFX_DATA(CApercuView)
	enum { IDD = IDD_APERCUVIEW };
	CStatic       m_lblMAJ;
	CRichEditCtrl m_rtf;
	//}}AFX_DATA
	
	CApercu     *m_pApercu;    // Interface
	CBitmapView *m_pBmpView;   // Vue pour la bitmap
	CFichier    *m_pFichier;   // Fichier concern
	CString      m_sFileCache; // Chemin physique du fichier
	CFileRead    m_fr;         // Pas toujours valide !
	
	
	CToolBarEx m_tlb;          // Barre d'outils
	CStatusBar m_stb;          // Barre d'tat
	UINT       m_idTlb;        // ID de la barre d'outils
	
	//*** Mode Texte
	bool m_fRetour;            // Retour  la ligne automatique
	bool m_fDOS;               // Texte DOS
	bool m_fSelOK;             // Correction du bug de slection effectue
	
	//*** Mode Bitmap
	bool m_fRedim;             // Redimensionnement automatique
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CApercuView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CApercuView)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMAJ();
	afx_msg void OnRtfSetFocus();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


class CApercu
{
protected:  // Interne
	
	CApercu(CApercuView* pView) : m_pView(pView) {}
	
	CApercuView *m_pView;
	
	
public:  // Hritage
	
	virtual ~CApercu();
	
	virtual UINT GetToolBarID() const;
	
	virtual void MAJ() {}
	virtual void GetInfoText(CString& s) { s; }
	virtual void OnSetFont();
	virtual void OnSetPoliceFont() {}
	
	void SetFont(CFont* pFont);
};


//{{AFX_INSERT_LOCATION}}
#endif
