// ArboView.h


#ifndef _ARBOVIEW_H_
#define _ARBOVIEW_H_
#if _MSC_VER>1000
#pragma once
#endif


#include "MuzipDrop.h"
class CMuzipDoc;


class CArboView : public CTreeView
{
	DECLARE_DYNCREATE(CArboView)
	
public:  // Fonctions
	
	      CMuzipDoc* GetDocument()       { return (CMuzipDoc*)m_pDocument; }
	const CMuzipDoc* GetDocument() const { return (CMuzipDoc*)m_pDocument; }
	
	CTreeCtrl *m_ptrv;
	
	void ArchiveNouveauDossier(CDossier* pDossier);
	
	void AttachArc(CMuzipArc* pArc) { m_pArc = pArc; }
	
	
protected:  // Donnes
	
	CMuzipArc *m_pArc;
	
	CDossier* GetSelDossier() const;
	CDossier* GetSelDossierEx() const;
	
	CMuzipDropTarget m_mdt;          // Cible du glisser-dplacer
	bool             m_fRenommage;   // TRUE si un item est en cours de renommage
	
	
protected:  // Hritage
	
	//{{AFX_VIRTUAL(CArboView)
	public:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD      dwKeyState, CPoint pt);
	virtual DROPEFFECT OnDragOver (COleDataObject* pDataObject, DWORD      dwKeyState, CPoint pt);
	virtual void       OnDragLeave();
	virtual BOOL       OnDrop     (COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint pt);
	virtual BOOL OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll = TRUE);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CArboView)
	afx_msg int  OnCreate(CREATESTRUCT* pcs);
	afx_msg void OnDestroy();
	afx_msg void OnRClick        (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGetDispInfo   (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeyDown       (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChanged    (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpanding (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDrag     (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginLabelEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndLabelEdit  (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnArchiveMoins();
	afx_msg void OnArchiveDecomp();
	afx_msg void OnArchiveRenommer();
	afx_msg void OnArchiveProprietes();
	afx_msg void OnArchiveTester();
	afx_msg void OnArchiveNouveauDossier();
	afx_msg void OnUpdateFautSel              (CCmdUI* pCmdUI);
	afx_msg void OnUpdateFautSelModif         (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveRenommer      (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveNouveauDossier(CCmdUI* pCmdUI);
	afx_msg void OnArchiveRecomp();
	afx_msg void OnArchiveCacher();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
