// BitmapView.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "BitmapView.h"

#include "ApercuView.h"


IMPLEMENT_DYNAMIC(CBitmapView, CScrollView)
#if 0
BEGIN_MESSAGE_MAP(CBitmapView, CScrollView)
	//{{AFX_MSG_MAP(CBitmapView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Constructeur
CBitmapView::CBitmapView(CApercuView* papr) : m_papr(papr)
{
	m_dc.CreateCompatibleDC(NULL);
	m_pbmOld = m_dc.GetCurrentBitmap();
}

// Destructeur
CBitmapView::~CBitmapView()
{
	DeleteBitmap();
	m_dc.DeleteDC();
}


// Initialisation
void CBitmapView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	
	SetScrollSizes(MM_TEXT, CSize(1,1));
}


// Dessin
void CBitmapView::OnDraw(CDC* pDC)
{
	if (m_papr->m_fRedim) {
		// Redimensionnement automatique
		
		CRect rc;
		GetClientRect(rc);
		CSize sz = m_sz;
		
		if (sz.cx>rc.right || sz.cy>rc.bottom) {
			int div, mul;
			if (rc.right*sz.cy < rc.bottom * sz.cx) {
				mul = rc.right;
				div = sz.cx;
			}else{
				mul = rc.bottom;
				div = sz.cy;
			}
			sz.cx = MulDiv(sz.cx, mul, div);
			sz.cy = MulDiv(sz.cy, mul, div);
		}
		pDC->StretchBlt(0,0, sz.cx,sz.cy, &m_dc, 0,0, m_sz.cx,m_sz.cy, SRCCOPY);
		
	}else
		// Pas de redimensionnement automatique
		pDC->BitBlt(0,0, m_sz.cx,m_sz.cy, &m_dc, 0,0, SRCCOPY);
}


// Dtruit la bitmap
CBitmap& CBitmapView::DeleteBitmap()
{
	if ((HBITMAP)m_bm) {
		m_dc.SelectObject(m_pbmOld);
		m_bm.DeleteObject();
	}
	return m_bm;
}

// Dfinir la bitmap
void CBitmapView::InitBitmap()
{
	if (!(HBITMAP)m_bm)
		return;
	
	BITMAP bm;
	m_bm.GetBitmap(&bm);
	m_sz.cx = bm.bmWidth;
	m_sz.cy = bm.bmHeight;
	m_dc.SelectObject(&m_bm);
	
	MAJRedim();
}


// Met  jour les dimensions du dfilement
// selon si on est en mode redimensionnement automatique
void CBitmapView::MAJRedim()
{
	if (m_papr->m_fRedim)
		SetScrollSizes(MM_TEXT, CSize(0,0));
	else
		SetScrollSizes(MM_TEXT, m_sz);
}
