// Dossier.h


#ifndef _DOSSIER_H_
#define _DOSSIER_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
#include "PlusItem.h"

class  CMuzipArc;
struct DECOMP;

class  CFileRead;
class  CFileWrite;
class  CDlgLister;

class CLstFichierDecomp;


typedef void (*PFN_ONFICHIERTROUVE)(CFichier* pFichier);

enum GETDOSSIER
{
	gdCreer,       // Crer le dossier dfinitivement s'il n'existe pas
	gdCreerTemp,   // Crer le dossier temporairement s'il n'existe pas
	gdGet,         // Ne pas crer le dossier s'il n'existe pas
};

class CDossier
{
public:  // Fonctions
	
	CDossier(CDossier* pParent, LPCTSTR pszNom);
	~CDossier();
	
	void Clean();
	
	
	CDossier* GetDossier(LPCTSTR psz, GETDOSSIER gd, bool fFichier=false);
	
	UINT GetNbFichier() const;
	UINT GetNbDossier() const;
	
	void ListerFichier(CLstFichier& lstFichier) const;
	void MAJPath();
	
	void SetFichierFautPasComp();
	void AvantRecherche(bool fTemp);
	void SetNonTrouveFautSupprimer();
	void SupprimerSiTempVide();
	
	bool DossierDecomp(LPCTSTR pszDest, const DECOMP* pdec=NULL);
	
	void Supprimer();
	void SupprimerEtParentSiVide();
	bool SupprimerSiVide();
	bool Renommer(LPTSTR pszNom);
	
	void Rechercher(const RECHOPTIONS& rch, PFN_ONFICHIERTROUVE pfnOnFichierTrouve);
	void RechercherSuivant(int nItem=-1) const;
	
	void trvLister() const;
	void trvLister(HTREEITEM hti) const;
	
	bool FichierCopier(CFileRead& fr);
	
	void GetCacheDir(CString& sDir) const;
	bool CacheAddRef(DWORD* pdwTaille=NULL, CFichier* pFichierIgnorer=NULL);
	void CacheAddRef(CString& sFiltre);
	void CacheRelease();
	
	void ListMacro(CLstFichier& lstFichierMacro);
	
	
public:  // Donnes
	
	CMuzipArc  *m_pArc;
	
	CDossier   *m_pParent;      // Dossier parent
	LPTSTR      m_pszNom;       // Nom du dossier sans chemin d'accs
	LPTSTR      m_pszPath;      // Chemin d'accs complet
	CLstDossier m_lstDossier;   // Liste des sous-dossiers
	CLstFichier m_lstFichier;   // Liste des fichiers
	
	CTempsDHS   m_dtM;          // Date de modification
	
	bool        m_fTemp;        // Dossier  supprimer s'il est non-vide
	                            // aprs la requte de compression
	
	// Arborescence
	        bool      m_fOuvert;// TRUE si le dossier est ouvert
	mutable HTREEITEM m_hti;    // ID de l'item
	
	
	// Zip
	DWORD       m_offLoc;       // Offset du rpertoire local
	
	
private:  // Interne
	
	struct RECH : public RECHOPTIONS
	{
		PFN_ONFICHIERTROUVE pfnOnFichierTrouve;     // Callback
		DWORD               mskAttrO;               // Ncessaires
		DWORD               mskAttrN;               //  exclure
	};
	
	
	bool DossierDecompSuite(CLstFichierDecomp& lstFichierDecomp, LPCTSTR pszDest, const DECOMP* pdec, CLstStr1& lstRep);
	void RechercherSuite(const RECH& rech);
	bool RenommerSuite();
};


#endif
