// FichierPlus.h


#ifndef _FICHIERPLUS_H_
#define _FICHIERPLUS_H_
#if _MSC_VER>1000
#pragma once
#endif



#include "Fichier.h"

class CFichier;
class CDossier;
class CPlusItem;

class CFichierPlus;
typedef CListePtr1<CFichierPlus*> CLstFichierPlus;


// Les CFichierPlus constituent un arbre
// Chaque parent est situ entre ses deux fils
// (la comparaison porte sur le nom des fichiers)
// Exemple:
//
//    B
//   / \
//  A   C


class CFichierPlus
{
	friend class CRecherche;
	
public:  // Fonctions
	
	CFichierPlus(CFichier* pFichierOld, POS posFichierOld);
	
	void Supprimer();
	
	bool Finaliser();
	void Detruire();
	
	
	LPTSTR GetNomES() const { return (m_pszNomES) ? m_pszNomES : m_pFichier->m_pszNomES; }
	
	
public:  // Donnes
	
	CFichier  *m_pFichier;        // Nouveau fichier
	CFichier  *m_pFichierOld;     // Ancien fichier
	POS        m_posFichierOld;   // Position de l'ancien fichier
	CPlusItem *m_ppi;             // Options de compression
	
	
protected:  // Uniquement en mode arbre
	
	void ArbreLister(CLstFichierPlus& lstFichierPlus, int& iLimite);
	
	// Nom du fichier au cas o le nud a t supprim
	// Dans ce cas le nud n'est pas un vrai nud, il ne sert
	// qu' assurer l'intgrit de l'arbre
	LPTSTR        m_pszNomES;
	
	CFichierPlus *m_pfpGauche;    // lment  gauche dans l'arbre
	CFichierPlus *m_pfpDroite;    // lment  droite dans l'arbre
};


#endif
