// GZip/GZipFichier.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "GZipFichier.h"
#include "../Muzip.h"
#include "GZipArc.h"

#include "../Decomp.h"
using namespace SPACE_DECOMP;

#include "../Z/UnZ.h"
#include "../Z/Cons.h"
#include "GZip.h"


// Dcompresser le fichier (spcifique  l'extraction de dossiers)
bool CGZipFichier::DecompInterne(LPCTSTR pszDest)
{
	return UNZ::DecompGZip(this, pszDest);
}


// Renommage
bool CGZipFichier::OnRenommer()
{
	// On ne fait rien du tout car le nom du fichier GZip
	// n'est pas enregistr dans l'archive
	return true;
}

// Modification des proprits
bool CGZipFichier::OnModifProp()
{
	// crire l'en-tte
	e_fw.Seek(0, FILE_BEGIN);
	PutHeader();
	
	return true;
}


// crire l'en-tte
bool CGZipFichier::PutHeader()
{
	GZIPHEADER gzh;
	gzh.wID      = gzipID;
	gzh.nMethode = zmDeflate;
	gzh.nFlags   = gzfNom;
	gzh.nFlags2  = 0;
	gzh.dtM      = GetUnixDate(m_dtM);
	gzh.nOS      = gzipOS;
	
	CGZipArc *const pArc = (CGZipArc*)m_pArc;
	
	if (pArc->m_pszCom)
		gzh.nFlags |= gzfComment;
	
	// En-tte
	VERIF(e_fw.Write(&gzh, sizeof(gzh)));
	
	// Nom du fichier
	VERIF(e_fw.Write(m_pszNom, lstrlen(m_pszNom)+1));
	
	// Commentaires
	if (pArc->m_pszCom)
		VERIF(e_fw.Write(pArc->m_pszCom, lstrlen(pArc->m_pszCom)+1));
	
	m_off = e_fw.Tell();
	return true;
}

// crire l'en-tte final
bool CGZipFichier::PutFooter() const
{
	const DWORD aFooter[] = { m_nCRC, m_dwTailleN };
	return e_fw.Write(aFooter, sizeof(aFooter));
}


// Copier l'entre d'un fichier  un autre
// s_nbFichier et s_nFichier doivent tre valides
bool CGZipFichier::FichierCopierInterne(CFileRead& fr)
{
	fr.Seek(m_off, FILE_BEGIN);
	VERIF(PutHeader());
	
	// crire le fichier
	oApp.ShowStatusAvance2(m_dwTailleC);
	VERIF(FichierCopierHelper(fr, m_dwTailleC, true));
	
	VERIF(PutFooter());
	
	if (s_nbFichier)
		oApp.AddStatusAvance(0);
	
	return true;
}
