// MuzipDoc.h


#ifndef _MUMUZIPDOC_H_
#define _MUMUZIPDOC_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
#include "Fichier.h"


class CMuzipArc;
class CInterf;
class CMuzipView;
class CArboView;
class CApercuView;
class CDlgResRech;


class CMuzipDoc : public CDocument
{
	DECLARE_DYNCREATE(CMuzipDoc)
	
public:  // Fonctions
	
	CMuzipDoc();
	virtual ~CMuzipDoc();
	
	UINT GetIdType() const;
	
	void OuvrirDossier(const CDossier* pDossier, bool fDebut=true);
	void SelFichier(const CFichier* pFichier);
	
	
public:  // Donnes
	
	CMuzipArc   *m_pArc;   // Le plus important: l'archive
	
	CMuzipView  *m_plst;   // Vue liste
	CArboView   *m_ptrv;   // Vue arborescence
	CApercuView *m_papr;   // Vue aperu
	CDossier    *m_pCur;   // Dossier courant
	
	CDossier *m_pDragD;   // Dossier destination (glisser-dplacer)
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CMuzipDoc)
	public:
	virtual void DeleteContents();
	virtual BOOL SaveModified();
	virtual BOOL OnOpenDocument(LPCTSTR pszFichier);
	virtual BOOL OnSaveDocument(LPCTSTR pszFichier);
	virtual BOOL DoSave(LPCTSTR lpszPathName, BOOL bReplace=TRUE);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL
	
	
public:  // Messages
	
	//{{AFX_MSG(CMuzipDoc)
	afx_msg void OnFileDelete();
	afx_msg void OnFileSendMail();
	afx_msg void OnFileLister();
	afx_msg void OnArchivePlus();
	afx_msg void OnArchiveConvertir();
	afx_msg void OnArchiveSfx();
	afx_msg void OnArchiveNouveauDossier();
	afx_msg void OnArchiveRm();
	afx_msg void OnArchiveMaj();
	afx_msg void OnArchiveMdp();
	afx_msg void OnArchiveComment();
	afx_msg void OnArchiveRechercher();
	afx_msg void OnArchiveRechercherSuivant();
	afx_msg void OnArchiveRechercherFiltrer();
	afx_msg void OnUpdateFileSave                (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveSfx              (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveNouveauDossier   (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveMaj              (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveRm               (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveRechercherFiltrer(CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveComment          (CCmdUI* pCmdUI);
	afx_msg void OnUpdateIndicatorComment        (CCmdUI* pCmdUI);
	afx_msg void OnUpdateFautModif               (CCmdUI* pCmdUI);
	afx_msg void OnApercuDOS();
	afx_msg void OnUpdateApercuDOS               (CCmdUI* pCmdUI);
	afx_msg void OnApercuRetour();
	afx_msg void OnUpdateApercuRetour            (CCmdUI* pCmdUI);
	afx_msg void OnApercuRedim();
	afx_msg void OnUpdateApercuRedim             (CCmdUI* pCmdUI);
	afx_msg void OnApercuPolice();
	afx_msg void OnApercuOptions();
	afx_msg void OnViewResRech();
	afx_msg void OnUpdateViewResRech (CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
