// MuzipDrop.h


#ifndef _MUZIPDROP_H_
#define _MUZIPDROP_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
#include "Fichier.h"

class CMuzipDoc;
class CDossier;


class CMuzipDropTarget : public COleDropTarget
{
public:  // Hritage
	
	DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState,                            CPoint pt);
	DROPEFFECT OnDragOver (COleDataObject* pDataObject, DWORD dwKeyState,                            CPoint pt);
	BOOL       OnDrop     (COleDataObject* pDataObject, DROPEFFECT dropEffect,                       CPoint pt);
	DROPEFFECT OnDropEx   (COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint pt);
	void       OnDragLeave();
	
	
public:  // Donnes
	
	CMuzipDoc *m_pDoc;          // Document attach
	DWORD      m_dwKeyState;    // Sauvegarde des touches
};


class CMuzipDataSource : public COleDataSource
{
public:  // Hritage
	
	CMuzipDataSource()
		{
			s_pmds = this;
			
			m_fErreur  = false;
			m_pData    = NULL;
			m_pDossier = NULL;
		}
	~CMuzipDataSource()
		{
			s_pmds = NULL;
			
			delete [] m_pData;
		}
	
	void Init(const CMuzipArc* pArc);
	
	BOOL OnRenderGlobalData(FORMATETC* pfe, HGLOBAL* phGlobal);
	
	DROPEFFECT DoDragDrop();
	
	
protected:  // Interne
	
	class CMuzipDropSource : public COleDropSource
	{
	public:  // Hritage
		
		CMuzipDropSource()
			{
				m_dropEffect = DROPEFFECT_NONE;
			}
		
		SCODE GiveFeedback(DROPEFFECT dropEffect);
		SCODE QueryContinueDrag(BOOL bEscapePressed, DWORD dwKeyState);
		
		
	public:  // Donnes
		
		DROPEFFECT m_dropEffect;   // Dernier tat
	};
	
	
public:  // Donnes
	
	bool        m_fErreur;      // TRUE si erreur de dcompression
	
	CLstFichier m_lstFichier;   // Liste des fichiers  changer
	CDossier   *m_pDossier;     // Dossier  changer
	
	BYTE  *m_pData;             // Donnes  retourner aux cibles
	size_t m_lenData;           // Longueur des donnes
	
	
	
public:  // Statique
	
	static CMuzipDataSource *s_pmds;   // MDS en cours d'utilisation
};


#endif
