// MuzipFrame.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "MuzipFrame.h"

#include "ArboView.h"
#include "MuzipView.h"
#include "ApercuView.h"

#include "MuzipDoc.h"
#include "MuzipArc.h"
#include "dlgResRech.h"

#include "Interf.h"


IMPLEMENT_DYNCREATE(CMuzipFrame, CMDIChildWnd)
BEGIN_MESSAGE_MAP(CMuzipFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CMuzipFrame)
	ON_WM_MDIACTIVATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Cration client
BOOL CMuzipFrame::OnCreateClient(CREATESTRUCT*, CCreateContext* pContext)
{
	// Crer le premier splitter
	VERIF(m_wndSplitter.CreateStatic(this, 1,2));
	
	// Crer le deuxime splitter (panel de droite)
	// et toutes les vues: arborescence  gauche,
	// liste et aperu  droite
	if (!m_wndSplitterD.CreateStatic(&m_wndSplitter, 2,1,
	       WS_CHILD | WS_VISIBLE, m_wndSplitter.IdFromRowCol(0,1)) ||
	    !m_wndSplitter .CreateView(0,0, RUNTIME_CLASS(CArboView),   CSize(150, 100), pContext) ||
	    !m_wndSplitterD.CreateView(0,0, RUNTIME_CLASS(CMuzipView),  CSize(100, 200), pContext) ||
	    !m_wndSplitterD.CreateView(1,0, RUNTIME_CLASS(CApercuView), CSize(100, 100), pContext)) {
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}
	
	return TRUE;
}


// Activation
void CMuzipFrame::OnMDIActivate(BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd)
{
	// Vider la liste des fichiers trouvs par la recherche
	if (!bActivate && e_pdlgResRech)
		e_pdlgResRech->m_lst.DeleteAllItems();
	
	// Changer d'archive courante
	CMDIChildWnd::OnMDIActivate(bActivate, pActivateWnd, pDeactivateWnd);
	
	// Remplir la liste des fichiers trouvs par la recherche
	// avec les fichiers de la nouvelle archive
	if (bActivate && e_pdlgResRech)
		((CMuzipDoc*)GetActiveDocument())->m_pArc->m_pi->MAJResRech();
}
