// MuzipView.h


#ifndef _MUZIPVIEW_H_
#define _MUZIPVIEW_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Global.h"
#include "MuzipDrop.h"

class CLstMuzip;


class CMuzipView : public CListView
{
	DECLARE_DYNCREATE(CMuzipView)
	friend class CMuzipDoc;
	friend class CApercuView;
	
	
public:  // Fonctions
	
	CMuzipView();
	
	CMuzipDoc* GetDocument() { return (CMuzipDoc*)m_pDocument; }
	CListCtrl *m_plst;
	CLstMuzip *m_plstMuzip;
	
	
protected:  // Donnes
	
	CMuzipDropTarget m_mdt;    // Cible du glisser-dplacer
	
	CDossier *m_pDossier;     // Dossier list
	
	
protected:  // Hritage
	
	//{{AFX_VIRTUAL(CMuzipView)
	public:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL OnChildNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState,                            CPoint pt);
	virtual DROPEFFECT OnDragOver (COleDataObject* pDataObject, DWORD dwKeyState,                            CPoint pt);
	virtual void       OnDragLeave();
	virtual BOOL       OnDrop     (COleDataObject* pDataObject, DROPEFFECT dropEffect,                       CPoint pt);
	virtual DROPEFFECT OnDropEx   (COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint pt);
	protected:
	virtual LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CMuzipView)
	afx_msg int  OnCreate(CREATESTRUCT* pcs);
	afx_msg void OnDestroy();
	afx_msg void OnEditSelectAll();
	afx_msg void OnEditSelectInvert();
	afx_msg void OnArchiveRechercherSuivant();
	afx_msg void OnUpdateIndicatorEtat(CCmdUI* pCmdUI);
	afx_msg void OnApercu();
	afx_msg void OnItemChanged   (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginLabelEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndLabelEdit  (NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
