// PlusItem.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "PlusItem.h"

#include "Fichier.h"
#include "Dossier.h"

#include "dlgAjouter.h"



//*** RECHOPTIONS

// Impose les paramtres par dfaut
void RECHOPTIONS::SetDefaut()
{
	TA_nActive =
	TA_nOp     =
	TA_uTaille =
	TA_nUnite  = 0;
	
	AT_nR      =
	AT_nH      =
	AT_nS      =
	AT_nA      = 2;
	
	OP_fSous   = TRUE;
	OP_fCache  = FALSE;
}

// Calculer les masques des attributs que les fichiers
// doivent imprativement avoir (mskAttrO) ou ne pas avoir (msgAttrN)
void RECHOPTIONS::GetMskAttr(DWORD& mskAttrO, DWORD& mskAttrN) const
{
	mskAttrO = ~(DWORD)0;
	mskAttrN =         0;
	if      (AT_nR==0)  mskAttrN |=  FILE_ATTRIBUTE_READONLY;
	else if (AT_nR==1)  mskAttrO &= ~FILE_ATTRIBUTE_READONLY;
	if      (AT_nH==0)  mskAttrN |=  FILE_ATTRIBUTE_HIDDEN;
	else if (AT_nH==1)  mskAttrO &= ~FILE_ATTRIBUTE_HIDDEN;
	if      (AT_nS==0)  mskAttrN |=  FILE_ATTRIBUTE_SYSTEM;
	else if (AT_nS==1)  mskAttrO &= ~FILE_ATTRIBUTE_SYSTEM;
	if      (AT_nA==0)  mskAttrN |=  FILE_ATTRIBUTE_ARCHIVE;
	else if (AT_nA==1)  mskAttrO &= ~FILE_ATTRIBUTE_ARCHIVE;
}



//*** CPlusItem

// Affectation
CPlusItem& CPlusItem::operator = (const CPlusItem& pi)
{
	(PLUSOPTIONS&)  *this = pi;
	(FILTREOPTIONS&)*this = pi;
	
	DO_sFiltre  = pi.DO_sFiltre;
	DO_sContenu = pi.DO_sContenu;
	
	return *this;
}


// E/S
void CPlusItem::Serialize(CArchive& ar, WORD verPI)
{
	if (ar.IsStoring()) {
		// Enregistrement
		
		CString sFiltre = DO_sFiltre;
		sFiltre.Replace(cSepPartie, ';');
		
		ar << sFiltre;
		ar.Write((FILTREOPTIONS*)this, sizeof(FILTREOPTIONS));
		
		switch (verPI) {
			
			case verPlusItem1:
				ar.Write((PLUSOPTIONS1*)this, sizeof(PLUSOPTIONS1));
				break;
			
			case verPlusItem2:
			case verPlusItem3:
				ar.Write((PLUSOPTIONS2*)this, sizeof(PLUSOPTIONS2));
				break;
		}
		
		
	}else{
		// Chargement
		
		ar >> DO_sFiltre;
		DO_sFiltre.Replace(';', cSepPartie);
		
		if (verPI==verPlusItem1) {
			// On a supprim une valeur de la structure  partir de verPlusItem2:
			// il faut lire en deux parties
			ar.Read((FILTREOPTIONS*)this, sizeof(DA_rdC)+sizeof(DA_rdM));
			// Ignorer la valeur supprime
			BYTE abIgnore[sizeof(CRechDate)];
			ar.Read(abIgnore, sizeof(CRechDate));
			// Lire la suite
			ar.Read(&TA_nActive, sizeof(FILTREOPTIONS)-(sizeof(DA_rdC)+sizeof(DA_rdM)));
		}else
			ar.Read((FILTREOPTIONS*)this, sizeof(FILTREOPTIONS));
		
		switch (verPI) {
			
			case verPlusItem1:
				ar.Read((PLUSOPTIONS1*)this, sizeof(PLUSOPTIONS1));
				break;
			
			case verPlusItem2:
			case verPlusItem3:
				ar.Read((PLUSOPTIONS2*)this, sizeof(PLUSOPTIONS2));
				break;
		}
		
		// Initialiser pour les anciennes versions
		if (verPI<verPlusItem2)
			CO_fQueNouveau = FALSE;
	}
}


// Demander la spcification (liste de fichiers, dossiers...)
bool CPlusItem::DemanderSpec(LPCTSTR pszArchive)
{
	return CDlgAjouter(this, pszArchive).DoModal()==IDOK;
}


// Rcuprer les options de compression par dfaut
// pour les oprations extrieures  Muzip
// (glisser-dplacer, menu contextuel...)
// Cela revient  utiliser les options par dfaut
// en enlevant tous les critres restrictifs
void CPlusItem::SetDefautExt()
{
	*this = oApp.m_pi;
	
	CO_nAction         = coaPlusMAJ;
	CO_fActionDeplacer = FALSE;
	CO_fActionNomCourt = FALSE;
	CO_fArchiveMoins   = FALSE;
	CO_fArchiveQue     = FALSE;
	CO_nArbo           = arboSous;
	CO_fQueNouveau     = FALSE;
	
	DA_rdC.fActive     =
	DA_rdM.fActive     = false;
	
	TA_nActive         = 0;
	
	AT_nR              =
	AT_nH              =
	AT_nS              =
	AT_nA              = 2;
	
	OP_fSous           = TRUE;
	OP_fCache          = TRUE;
}


// Lister les parties de la spcification
// sDebut contiendra en sortie le dbut de chane commun  toutes les parties
void CPlusItem::ListerPartie(CString& sDebut, CLstCString2& lstPartie)
{
	// Si pas de spcification, viter les bugs dus aux cas particuliers !
	if (DO_sFiltre.IsEmpty()) {
		sDebut.Empty();
		return;
	}
	
	// Chercher la chane commune la plus grande
	// au dbut de toutes les parties
	
	// Lister les parties
	CTokenize tok(DO_sFiltre, cSepPartie);
	while (tok.Next())
		lstPartie.AddFin(tok.GetToken());
	
	if (lstPartie.GetNb()==1) {
		// Une seule partie: la recopier normalement
		
		sDebut = DO_sFiltre;
		sDebut.GetBuffer(MAX_PATH);
		PathRemoveFileSpec ((STRING)sDebut);
		PathRemoveBackslash((STRING)sDebut);
		sDebut.ReleaseBuffer();
		
	}else{
		// Plusieurs parties
		
		// Effectuer la recherche
		CString sTemp = lstPartie.GetDeb();
		PathRemoveFileSpec(sTemp.GetBuffer(sTemp.GetLength()+1));
		CTokenize tok(sTemp, '\\');
		while (tok.Next()) {
			CString &sPartie = tok.GetToken();
			
			POS pos = lstPartie.GetPosDeb();
			lstPartie.GetSuiv(pos);   // Ignorer la premire partie
			                          // car c'est le comparant
			
			while (pos) {
				CString sPartie2;
				if (!AfxExtractSubString(sPartie2,
				    lstPartie.GetSuiv(pos), tok.GetIndex(), '\\') ||
				    lstrcmpi(sPartie2, sPartie))
					// Diffrence: arrter l
					return;
			}
			
			// Ajouter la partie
			sDebut += sPartie;
			sDebut += '\\';
		}
	}
}



//*** CArchivePlus

// Constructeur classique
// Le mode de suppression est fix  aucun
// pour viter des mauvaises surprises  l'utilisateur
// (suppression de tout l'archive sauf des fichiers ajouts...)
CArchivePlus::CArchivePlus(CDossier* pDossier, bool fAutoDel)
	: CLstPlusItem(fAutoDel)
{
	(ARCHIVEPLUS_GUI&)*this = oApp.m_arPlus;
	m_nSup = supRien;
	if (pDossier)
		m_sDossier = pDossier->m_pszPath;
}

// Constructeur de copie
CArchivePlus::CArchivePlus(const CArchivePlus& arPlus)
	: CLstPlusItem(true)
{
	(ARCHIVEPLUS_GUI&)*this = arPlus;
	
	// Dupliquer la liste
	POS pos = arPlus.GetPosDeb();
	while (pos)
		AddFin(new CPlusItem(*arPlus.GetSuiv(pos)));
}


// E/S
void CArchivePlus::Serialize(CArchive& ar, WORD& verPI)
{
	if (ar.IsStoring()) {
		// Enregistrement
		
		ar << verPI;
		
		ar.Write((ARCHIVEPLUS1*)this, sizeof(ARCHIVEPLUS1));
		if (verPI>=verPlusItem2) {
			ar << m_sDossier;
			if (verPI>=verPlusItem3)
				ar << m_iLimite;
		}
		
		// crire les items
		ar << (DWORD)GetNb();
		POS pos = GetPosDeb();
		while (pos)
			GetSuiv(pos)->Serialize(ar, verPI);
		
	}else{
		// Chargement
		
		ar >> verPI;
		if (verPI<verPlusItem1 || verPI>verPlusItem3)
			AfxThrowArchiveException(CArchiveException::badSchema);
		
		ar.Read((ARCHIVEPLUS1*)this, sizeof(ARCHIVEPLUS1));
		if (verPI>=verPlusItem2) {
			ar >> m_sDossier;
			if (verPI>=verPlusItem3)
				ar >> m_iLimite;
		}
		
		// Initialiser pour les anciennes versions
		if (verPI<verPlusItem3) {
			if (verPI<verPlusItem2)
				m_sDossier.Empty();
			m_iLimite = 0;
		}
		
		// Lire les items
		DWORD nb;
		ar >> nb;
		while (nb) {
			nb--;
			CPlusItem *const ppi = new CPlusItem;
			ppi->Serialize(ar, verPI);
			AddFin(ppi);
		}
	}
}
