// PlusItem.h


#ifndef _PLUSITEM_H_
#define _PLUSITEM_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "RechDate.h"

class CDossier;


const WORD verPlusItem1 = 1;
const WORD verPlusItem2 = 2;
const WORD verPlusItem3 = 3;


// Paramtres d'une recherche sans les chanes
struct FILTREOPTIONS
{
	// Dates
	CRechDate DA_rdC;   // Cration
	CRechDate DA_rdM;   // Modification
	
	// Taille
	int       TA_nActive;   // Activer recherche (0=non, 1=oui)
	int       TA_nOp;       // Oprateur (0="=", 1=">=", 2="<=")
	UINT      TA_uTaille;   // Valeur
	int       TA_nUnite;    // Unit (0=octet, 1=Ko, 2=Mo, 3=Go)
	
	// Attributs (0=faut non, 1=faut oui, 2=ignorer)
	int       AT_nR;        // Lecture seule
	int       AT_nH;        // Fichier cach
	int       AT_nS;        // Fichier systme
	int       AT_nA;        // Archive
	
	BOOL      OP_fSous;     // Rechercher dans les sous-dossiers
	BOOL      OP_fCache;    // Rechercher dans les dossiers cachs
};

// Paramtres d'une recherche
struct RECHOPTIONS : public FILTREOPTIONS
{
	CString   DO_sFiltre;   // Filtre sur les fichiers
	CString   DO_sContenu;  // Filtre sur le contenu
	
	void SetDefaut();
	void GetMskAttr(DWORD& mskAttrO, DWORD& msgAttrN) const;
};


enum CO_ACTION
{
	coaPlusMAJ,   // Ajouter et mettre  jour
	coaMAJ,       // Mettre  jour uniquement
	coaPlus,      // Ajouter uniquement
	coaPasComp,   // Ne pas compresser
	coaMoins,     // Exclure de la recherche
	nbCOA
};

enum CO_ARBO
{
	arboNon,    // Ne pas converser l'arborescence
	arboSous,   // Conserver le nom des sous-dossiers
	arboTout,   // Conserver le chemin d'accs complet
};


struct PLUSOPTIONS1   // Version 1
{
	int  CO_nAction;           // Voir CO_ACTION ci-dessus
	int  CO_nNiveau;           // Niveau de compression
	BOOL CO_fActionDeplacer;   // Supprimer le fichier aprs compression
	BOOL CO_fActionNomCourt;   // Ne garder que les noms courts
	BOOL CO_fArchiveMoins;     // Enlever l'attribut archive aprs compression
	BOOL CO_fArchiveQue;       // Ne compresser que si l'attribut archive est activ
	int  CO_nArbo;             // Voir CO_ARBO si-dessus
};

struct PLUSOPTIONS2 : public PLUSOPTIONS1   // Version 2
{
	BOOL CO_fQueNouveau;       // Ne pas compresser les fichiers plus anciens
};

typedef PLUSOPTIONS2 PLUSOPTIONS;


const TCHAR cSepPartie = 1;

class CPlusItem : public PLUSOPTIONS, public RECHOPTIONS
{
public:  // Fonctions
	
	CPlusItem& operator = (const CPlusItem& pi);
	
	void Serialize(CArchive& ar, WORD verPI);
	
	bool DemanderSpec(LPCTSTR pszArchive);
	void SetDefautExt();
	
	void ListerPartie(CString& sDebut, CLstCString2& lstPartie);
};
typedef CListePtr2<CPlusItem*> CLstPlusItem;


enum SUP
{
	supRien,
	supRecherche,
	supTout,
};


struct ARCHIVEPLUS1   // Version 1
{
	int m_nSup;   // Type de suppression (voir SUP)
};


struct ARCHIVEPLUS2 : public ARCHIVEPLUS1   // Version 2
{
	CString m_sDossier;   // Dossier cible
};


struct ARCHIVEPLUS3 : public ARCHIVEPLUS2   // Version 3
{
	int m_iLimite;   // Limite du nombre de fichiers (0 pour infini)
};

// Structure ARCHIVEPLUS utilise par les scripts
typedef ARCHIVEPLUS3 ARCHIVEPLUS_SCRIPT;


struct ARCHIVEPLUS4 : public ARCHIVEPLUS3
{
	bool m_fAjoutRm;   // TRUE pour forcer l'ajout en mode reconstruction manuelle
};

// Struct ARCHIVEPLUS utilise par l'interface de Muzip
typedef ARCHIVEPLUS4 ARCHIVEPLUS_GUI;


class CArchivePlus : public ARCHIVEPLUS_GUI, public CLstPlusItem
{
public:  // Fonctions
	
	CArchivePlus(CDossier* pDossier=NULL, bool fAutoDel=false);
	CArchivePlus(const CArchivePlus& arPlus);
	
	void Serialize(CArchive& ar, WORD& verPI);
};
typedef CListePtr2<CArchivePlus*> CLstArchivePlus;


#endif
