// Z/Bits.cpp
//
// Gre un flux o l'on peut ajouter des donnes bit  bit
// au lieu d'octet par octet


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "../CodeRapide.h"
#include "ZArc.h"
#include "Fen.h"


// Tampon de sortie
// Les bits sont insrs en partant des bits de poids faible
static WORD s_buf;

// Nombre de bits valides dans s_buf
// Les bits en-dessous du dernier bit valide sont toujours  zro
static BYTE  s_nbValide;

// Tampon de sortie pour la compression dans un fichier
static BYTE s_abOut[1024];
static UINT s_offOut;


// Envoyer un mot dans le flux, l'octet de poids faible d'abord
inline void CZArc::biPutWord(WORD w)
{
	if (s_offOut >= sizeof(s_abOut)-1)
		biFlush();
	
	s_abOut[s_offOut++] = (BYTE) w;
	s_abOut[s_offOut++] = (BYTE)(w >> 8);
}

// Envoyer un octet dans le flux
inline void CZArc::biPutByte(BYTE b)
{
	if (s_offOut >= sizeof(s_abOut))
		biFlush();
	
	s_abOut[s_offOut++] = b;
}


// Initialiser les routines de gestion des bits
void CZArc::biInit()
{
	s_buf      = 0;
	s_nbValide = 0;
#ifdef _DEBUG
	e_lenOut   = 0;
#endif
	s_offOut   = 0;
}

// crire une chane bit, en prenant les bits source de droite  gauche
// val - valeur  envoyer
// len - nombre de bits (0 ~ 15)
#pragma warning (disable: 4244)
void CZArc::biEnvoyer(int val, int len)
{
#ifdef    _DEBUG
	ASSERT(len>0 && len<=15); // Longueur invalide
	e_lenOut += (DWORD)len;
#endif // _DEBUG
	
	// Si pas assez de place dans s_buf, utiliser les vits valides
	// de s_buf et (16 - s_nbValide) de la valeur, en laissant
	// (largeur - (16-s_nbValide)) bits inutiliss dans la valeur
	if (s_nbValide>16-len) {
		s_buf      |= (val<<s_nbValide);
		biPutWord(s_buf);
		s_buf       = (WORD)((WORD)val >> (16 - s_nbValide));
		s_nbValide += len - 16;
	}else{
		s_buf      |= (val<<s_nbValide);
		s_nbValide += len;
	}
}
#pragma warning (default: 4244)


// Flusher le tampon de sortie courant
void CZArc::biFlush()
{
	// Crypter et crire le tampon de sortie
	if (s_offOut) {
		Write(s_abOut, s_offOut);
		s_offOut = 0;
	}
}

// crire en sortie les bits manquants pour s'aligner sur un octet
void CZArc::biFlushOctet()
{
	if      (s_nbValide>8)  biPutWord(      s_buf);
	else if (s_nbValide>0)  biPutByte((BYTE)s_buf);
	biFlush();
	
	s_buf      = 0;
	s_nbValide = 0;
#ifdef _DEBUG
	e_lenOut = (e_lenOut+7) & ~7;
#endif
}


// Copier un bloc dans le Zip, en commenant par sa longueur
// et son complment  un si demand
// pcBloc  - donnes d'entre
// len     - leur longueur
// fHeader - TRUE si le bloc en-tte doit tre crit
void CZArc::trBlocCopier(BYTE* pbBloc, UINT len, bool fHeader)
{
	biFlushOctet();
	
	if (fHeader) {
		biPutWord((WORD) len);
		biPutWord((WORD)~len);
#ifdef _DEBUG
		e_lenOut += 2*16;
#endif
	}
	
	biFlush();
	Write(pbBloc, len);
	
#ifdef _DEBUG
	e_lenOut += (DWORD)len<<3;
#endif
}
