// Z/Fen.h
//
// Dclarations pour l'utilisation de la fentre de compression


#ifndef _Z_FEN_H_
#define _Z_FEN_H_
#if _MSC_VER>1000
#pragma once
#endif


// Longueur minimum et maximum des correspondances
const UINT minMatch =   3;
const UINT maxMatch = 258;

// Taille maximum de la fentre:
// -  la compression: 32 ko
// -  la dcompression: 64 ko
#if defined(FEN_COMP) && !defined(FEN_DECOMP)
const UINT lenFen = 0x08000;
#elif defined(FEN_DECOMP)
const UINT lenFen = 0x10000;
#endif

#ifndef MUZIPSFX
const UINT lenFenMax   = 0x10000;
const UINT lenFenAlloc = 2 * lenFenMax;
#else
const UINT lenFenMax   = 0x08000;
const UINT lenFenAlloc = lenFenMax;
#endif


#if defined(FEN_COMP) || defined(FEN_DECOMP)

// Espace minimum de prvoyance (sauf  la fin du fichier)
const UINT minResteDevant = (maxMatch+minMatch+1);

// Pour simplifier le code,
// les distances de correspondance sont limites  maxDist au lieu de lenFen
const UINT maxDist = lenFen - minResteDevant;

#endif


// Fentre de recherche
// Les octets d'entre sont lus dans la seconde moiti de e_pbFen,
// et dplacs dans la premire plus tard pour garder un dictionnaire
// d'au moins lenFen octets
// Avec cette organisation, les correspondances sont limites  une
// distance de lenFen-maxMatch octets, mais cela assure que les E/S
// sont effectues avec une longueur multiplle de la taille du bloc
extern BYTE  e_pbFen[lenFenAlloc];
extern DWORD e_lenFen;   // e_lenFen = 2*lenFen

// Position de la fentre par rapport au dbut du bloc courant
// Peut tre ngatif quand e_pbFen se dplace en arrire
extern long  e_debBloc;

extern UINT  e_offStr;       // Dbut de la chane  insrer

extern DWORD e_lenIn;        // Taille du fichier d'entre
#ifdef    _DEBUG
extern DWORD e_lenOut;       // Taille des donnes compresses
#endif // _DEBUG

// Accumulateur de taille pour les donnes du rpertoire central (Zip)
extern DWORD e_lenEcrit;


#endif
