// UnZ.h


#ifndef _Z_UNZ_H_
#define _Z_UNZ_H_
#if _MSC_VER>1000
#pragma once
#endif

#define FEN_DECOMP
#include "Fen.h"

#include <FileBuf.h>
#include "../Decomp.h"


class CZipFichier;
class CGZipFichier;
class CHuft;

namespace UNZ
{
	bool InflateInit();
#ifndef MUZIPSFX
	bool FautInflateInit();
#endif
	void InflateClose();
	
#ifndef MUZIPSFX
	bool TesterMDP(const BYTE* pbEnTete, CZipFichier* pzf);
#else
	bool TesterMDP(const BYTE* pbEnTete);
#endif
	
	void InputDeferLeftover();
	void InputUndefer();
	
#ifndef MUZIPSFX
	bool DecompZip (CZipFichier*  pzf,  LPCTSTR pszFichierOut);
	bool DecompGZip(CGZipFichier* pgzf, LPCTSTR pszFichierOut);
#else
	bool DecompZip (LPCTSTR pszFichier, LPCTSTR pszFichierOut);
#endif
	bool Inflate(bool fInflate64);
	bool InflateDynamic(bool fInflate64);
	bool InflateStore();
	bool InflateCode(CHuft* tl, CHuft* td, int bl, int bd);
	bool Flush(const void* pv, DWORD len);
	
	
	extern DWORD e_nCRC;
	
	extern long  e_lenComp;
	extern BYTE *e_pbIn;
	extern int   e_lenIn;
}


#endif
