// Z/ZipArc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "../Muzip.h"
#include "ZArc.h"

#include "../PlusItem.h"
#include "../CRC32.h"
#include "Fen.h"
#include "UnZ.h"


static CFileRead *s_pfr;      // Fichier Zip en cours de lecture

DWORD CZArc::s_nCRCIn;



// Lire un nouveau tampon dans le fichier d'entre,
// mettre  jour le CRC et la taille du fichier d'entre
// len>=2 (pour conversion des fins de ligne)
DWORD CZArc::LireFichier(BYTE* pbBuf, DWORD len)
{
	const DWORD lenLu = s_pfr->ReadLen(pbBuf, len);
	if (lenLu) {
		s_nCRCIn = crc32(s_nCRCIn, pbBuf, lenLu);
		e_lenIn += lenLu;
	}
	
	return lenLu;
}


// Compresser un fichier
// Spcificit de pnMethode:
// - passer une valeur si le format accepte le passage automatique en zmStore
// - passer NULL pour forcer zmDeflate
DWORD CZArc::Compresser(CFichier* pFichier, CFileRead& fr,
	int nNiveau, ZMETHODE* pnMethode, WORD* pnAttrI)
{
	DWORD lenC;
	
	s_pfr    = &fr;
	e_lenFen = 0;
	e_lenIn  = 0;
	s_nCRCIn = 0;
	
	e_fw.SetVerbeux(false);
	
	const bool fProgress2 = !(GetCap() & capMaxUnFichier);
	
	TRY
	{
		if (!pnMethode || *pnMethode==zmDeflate) {
			// Compression Deflate
			
			if (!UNZ::FautInflateInit())
				return 0;
			
			if (fProgress2)
				oApp.ShowStatusAvance2(pFichier->m_dwTailleN);
			
			biInit();
			ctInit(pnAttrI, pnMethode);
			lmInit(nNiveau);
			
			lenC = Deflate();
			
		}else{
			// Pas de compression
			
			const UINT lenBuf = 0x1000;
			if (fProgress2)
				oApp.ShowStatusAvance2(pFichier->m_dwTailleN/lenBuf);
			
			BYTE ab[lenBuf];
			for (;;) {
				const DWORD len = LireFichier(ab, sizeof(ab));
				if (!len)
					break;
				
				Write(ab, len);
				oApp.AddStatusAvance(0, len);
				oApp.AddStatusAvance(1);
			}
			lenC = e_lenIn;
		}
	}
	CATCH_ALL(e)
	{
		e->ReportError();
		lenC = 0;
	}
	END_CATCH_ALL
	
	return lenC;
}
