// Z/ZipArc.h


#ifndef _Z_ZIPARC_H_
#define _Z_ZIPARC_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "../MuzipArc.h"
#include "Cons.h"

class CFileRead;
class CFileWrite;

struct CTDATA;


class CZArc : public CMuzipArc
{
protected:  // Fonctions
	
	CZArc(CInterf* pi) : CMuzipArc(pi) {}
	
	DWORD Compresser(CFichier* pFichier, CFileRead& fr,
		int nNiveau, ZMETHODE* pnMethode, WORD* pnAttrI=NULL);
	
	static DWORD LireFichier(BYTE* pbBuf, DWORD len);
	
	static void  biInit();
	static void  biEnvoyer(int val, int len);
	static void  biFlush();
	static void  biFlushOctet();
	static inline void biPutWord(WORD w);
	static inline void biPutByte(BYTE b);
	
	static void  ctInit(WORD* pnAttr, ZMETHODE* pnMethode);
	static void  lmInit(int nNiveau);
	static DWORD Deflate();
	static DWORD DeflateFast();
	static void  MatchVerif(UINT nDeb, UINT nMatch, int len);
	static void  FillFen();
	
	static bool  ctCompter(int nDist, int lc);
	static void  trTreeEnvoyer(CTDATA* tree, int max_code);
	static void  trTreeEnvoyerTout(int lcodes, int dcodes, int blcodes);
	
	static void Write(BYTE* pbBuf, UINT len);
	
	static DWORD trBlocFlush(BYTE* pbBuf, DWORD len, bool fEOF);
	static void  trBlocCompresser(CTDATA* pTreeL, CTDATA* pTreeD);
	static void  trBlocCopier(BYTE* pbBloc, UINT len, bool fHeader);
	
	
	static DWORD s_nCRCIn;   // CRC des donnes avant compression
};


#endif
