// Zip/Zip.h


#ifndef _ZIP_ZIP_H_
#define _ZIP_ZIP_H_
#if _MSC_VER>1000
#pragma once
#endif


// Tampon d'E/S fichier
const size_t lenFileBuf = 32768;


#pragma pack(push,1)

struct HEADERFIN
{
	WORD  nDisque;     // Numro de ce disque
	WORD  nDisqueD;    // Numro du disque de dpart
	WORD  nbEntry;     // Nombre d'entres sur ce disque
	WORD  nbEntryT;    // Nombre total d'entres
	DWORD nTailleT;    // Taille du rpertoire central entier
	DWORD off;         // Offset du central sur le disque de dpart
	WORD  lenCom;      // Longueur des commentaires du Zip
};
struct HEADERFINSIG
{
	DWORD sig;         // Signature (sigFin)
	WORD  nDisque;     // Numro de ce disque
	WORD  nDisqueD;    // Numro du disque de dpart
	WORD  nbEntry;     // Nombre d'entres sur ce disque
	WORD  nbEntryT;    // Nombre total d'entres
	DWORD nTailleT;    // Taille du rpertoire central entier
	DWORD off;         // Offset du central sur le disque de dpart
	WORD  lenCom;      // Longueur des commentaires du Zip
};

struct HEADERLOCSIG
{
	DWORD sig;         // Signature (sigLoc)
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtra;    // Longueur du champ extra
};
struct HEADERLOC
{
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtra;    // Longueur du champ extra
};

struct HEADERLOCEXTSIG
{
	DWORD sig;         // Signature (sigLocExt)
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
};

struct HEADERLOCEXT
{
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse
	DWORD nTailleN;    // Taille dcompresse
};

struct HEADERCENSIG
{
	DWORD sig;         // Signature (sigCen)
	WORD  nVerC;       // Version du crateur
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse (utilis que pour les E/S)
	DWORD nTailleN;    // Taille dcompresse (utilis que pour les E/S)
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtraC;   // Longueur du champ extra central
	WORD  lenCom;      // Longueur des commentaires
	WORD  nDisque;     // N du disque (si Zip multi-volumes)
	WORD  nAttrI;      // Attributs internes du fichier
	DWORD nAttrE;      // Attributs externes du fichier
	DWORD off;         // Offset du rpertoire local
};
struct HEADERCEN
{
	operator HEADERLOC* ()
	{
		return (HEADERLOC*)&nVerE;
	}
	
#ifndef MUZIPSFX
	LPSTR GetZipNom(CString& sNom);
#endif
	
	
	WORD  nVerC;       // Version du crateur
	WORD  nVerE;       // Version ncessaire pour l'extraction
	WORD  nFlags;      // Flags gnraux
	WORD  nMethode;    // Mthode de compression
	DWORD dt;          // Date de modification
	DWORD nCRC;        // CRC
	DWORD nTailleC;    // Taille compresse (utilis que pour les E/S)
	DWORD nTailleN;    // Taille dcompresse (utilis que pour les E/S)
	WORD  lenNom;      // Longueur du nom
	WORD  lenExtraC;   // Longueur du champ extra central
	WORD  lenCom;      // Longueur des commentaires
	WORD  nDisque;     // N du disque (si Zip multi-volumes)
	WORD  nAttrI;      // Attributs internes du fichier
	DWORD nAttrE;      // Attributs externes du fichier
	DWORD off;         // Offset du rpertoire local
};

#pragma pack(pop)


const UINT lenSig    =  4;   // Longueur des signatures
const UINT lenEtendu = 16;   // Longueur de l'en-tte tendu

// Signatures des en-ttes
const DWORD sigLoc    = 0x04034B50;
const DWORD sigCen    = 0x02014B50;
const DWORD sigFin    = 0x06054B50;
const DWORD sigLocExt = 0x08074B50;

// Dcalages des valeurs dans les en-ttes
enum
{
	locVerE       =  0,
	locFlag       =  2,
	locfCrypte    =  1,  // Crypt
	locfEtendu    =  8,  // En-tte local tendu
	locMethode    =  4,
	locDateHeureM =  6,
	locCRC        = 10,
	locTailleC    = 14,
	locTailleN    = 18,
	loclenNom     = 22,
	loclenExtra   = 24,
};

enum
{
	extCRC        =  0,
	extTailleC    =  4,
	extTailleN    =  8,
};

enum
{
	cenVerC       =  0,
	cenVerE       =  2,
	cenFlag       =  4,
	cenMethode    =  6,
	cenDateHeureM =  8,
	cenCRC        = 12,
	cenTailleC    = 16,
	cenTailleN    = 20,
	cenlenNom     = 24,
	cenlenExtraC  = 26,
	cenlenCom     = 28,
	cenDisque     = 30,
	cenAttrI      = 32,
	cenAttrE      = 34,
	cenOff        = 38,
	cenFin        = 42,
};

enum
{
	finDisque     =  0,   // Numro de ce disque
	finDisqueD    =  2,   // Numro du disque de dpart
	finEntry      =  4,   // Nombre d'entres sur ce disque
	finEntryT     =  6,   // Nombre total d'entres
	finTailleT    =  8,   // Taille du rpertoire central entier
	finOff        = 12,   // Offset du central sur le disque de dpart
	finCom        = 16,   // Longueur des commentaires du Zip
};


// Gestion du champ extra
enum
{
	ebLenDeb    =     4,    // Longueur de l'en-tte
	ebID        =     0,    // Offset de l'ID du bloc dans l'en-tte
	ebLen       =     2,    // Offset de la longueur des donnes dans l'en-tte
	
	ebUXMin     =     8,    // Champ "UX" minimal (dtA, dtM)
	ebUXdtA     =     0,    // Offset de atime
	ebUXdtM     =     4,    // Offset de mtime
	
	ebUXMax     =    12,    // Champ "UX" complet (dtA, dtM, uid, gid)
	ebUXUID     =     8,    // Offset de UID
	ebUXGID     =    10,    // Offset de GID
	
	ebUTMin     =     1,    // Champ UT minimal
	ebUTFlags   =     0,    // Offset de Flags
	ebUTdt1     =     1,    // Offset de la premire valeur de temps
	ebUTFLdtM   =  1<<0,    // dtM prsent
	ebUTFLdtA   =  1<<1,    // dtA prsent
	ebUTFLdtC   =  1<<2,    // dtC prsent
#define ebUTLen(n)   (ebUTMin + 4 * (n))
	
	ebUX2Min    =      4,   // Champ Ux minimal (UID/GID)
	ebUX2UID    =      0,   // Offset de UID
	ebUX2GID    =      2,   // Offset de GID
	ebUX2Valide =   1<<8,   // UID/GID prsent
};


// Codes d'OS et version

enum
{
	ziposFAT,
	ziposAmiga,
	ziposVMS,
	ziposUnix,
	ziposVM_CMS,
	ziposAtari,
	ziposHPFS,
	ziposMac,
	ziposZSystem,
	ziposCPM,
	ziposTops20,
	ziposNTFS,
	ziposQDos,
	ziposAcorn,
	ziposVFAT,
	ziposMVS,
	ziposBeOS,
	ziposTandem,
	ziposTHEOS,
};

#define VER_MAKE     MAKEWORD
#define VER_GETOS    HIBYTE
#define VER_GETNUM   LOBYTE

const WORD verCur = VER_MAKE(22, ziposNTFS);


#endif
