// Zip/ZipArc.h


#ifndef _ZIP_ZIPARC_H_
#define _ZIP_ZIPARC_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "../Z/ZArc.h"

class CMuzipException;
class CArchivePlus;
class CFileWrite;
class CZipFichier;


struct CTDATA;
struct SFXFOOTER;


typedef CListePtr2<CZipFichier*> CLstZipFichier;


class CZipArc : public CZArc
{
	friend class CZipFichier;
	
public:  // Fonctions
	
	CZipArc(CInterf* pi);
	
	static CMuzipArc* CreateArchive(CInterf* pi);
	
	CMuzipException* OuvrirNormal (CLstZipFichier& lstTrouve);
	CMuzipException* OuvrirReparer(CLstZipFichier& lstTrouve);
	
	bool Compresser(CPlusItem* ppi, CZipFichier* pzf);
	
	
public:  // Hritage
	
	UINT GetSfxID() const;
	
	bool OpenDocument(bool fSilent);
	void CloseDocument();
	
	bool OpenArchiveTemp();
	bool CloseArchiveTemp();
	
	CFichier* NewFichier (LPCTSTR pszFichier, const WIN32_FIND_DATA& wfd);
	
	void SetComment(LPCTSTR psz);
	LPCTSTR GetComment() const;
	
	
protected:  // Interne
	
	bool ArchivePlus();
	
	bool IsGoodType();
	
	void IgnorerFichier(DWORD offOld, CFichier* pFichier);
	
	bool Convertir(CMuzipArc* pArc, bool fConvertirFichiers);
	
	
	bool ReadSfxFooter(SFXFOOTER& sfx);
	
	LPTSTR FromZip(WORD& len, WORD ver, bool fPasOEM);
	
	enum PUTCENTRAL
	{
		putCentralFichier,
		putCentralDossier,
		putLocalDossier,
	};
	static bool PutCentral(CDossier* pDossier, PUTCENTRAL put);
	
	
	DWORD  m_offDebut;     // Offset de dpart des structures Zip
	DWORD  m_offCen;       // Offset de dpart du rpertoire central
	
	WORD   m_lenCom;       // Longueur des commentaires
	LPTSTR m_pszCom;       // Commentaires
};


#endif
