// Zip/ZipFichier.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "ZipFichier.h"
#include "Zip.h"

#include "../Z/UnZ.h"

#include "../PlusItem.h"


// Constructeur
CZipFichier::CZipFichier()
{
	m_pszCom   = NULL;
	m_pbExtra  =
	m_pbExtraC = NULL;
}


// Destructeur
CZipFichier::~CZipFichier()
{
	delete [] m_pszCom;
	delete [] m_pbExtra;
	if (m_pbExtra!=m_pbExtraC)
		delete [] m_pbExtraC;
}


// Offset identificateur du fichier pour la cration d'auto-extractibles
// avec excution automatique de fichier
DWORD CZipFichier::GetOffSfx() const
{
	return m_cen.off;
}

// Fichier crypt ?
bool CZipFichier::IsCrypte() const
{
	return ToBool(m_nFlags & locfCrypte);
}

// Remplir une classe CPlusItem avec les donnes permettant
// de recompresser le fichier  l'identique
void CZipFichier::ToPlusItem(CPlusItem& pi) const
{
	CFichier::ToPlusItem(pi);
	pi.CO_nNiveau = m_cen.nMethode;
}


// Dcompresser le fichier (spcifique  l'extraction de dossiers)
bool CZipFichier::DecompInterne(LPCTSTR pszDest)
{
	return UNZ::DecompZip(this, pszDest);
}


// Dfinir les proprits
void CZipFichier::SetProp(DWORD dwAttr, CTempsDHS& dtModif)
{
	// Attributs
	m_cen.nAttrE = dwAttr;
	
	// Date de modification
	m_cen.dt = GetUnixDate(dtModif);
	
	CFichier::SetProp(dwAttr, dtModif);
}


// Modification des proprits
bool CZipFichier::OnModifProp()
{
	// L'offset du central peut tre indfini,
	// notamment si on a ouvert l'archive en mode rparation
	VERIF(m_offCentral!=0);
	
	// crire l'en-tte local
	VERIF(e_fw.Seek(m_cen.off, FILE_BEGIN) && PutLocal());
	
	// crire l'en-tte central
	VERIF(e_fw.Seek(m_offCentral, FILE_BEGIN) && PutCentral());
	
	return true;
}



// Copier l'entre Zip du fichier pfS au fichier pfD
// Mettre  jour e_lenEcrit
// s_nbFichier et s_nFichier doivent tre valides
// Cette fonction est statique
bool CZipFichier::FichierCopierInterne(CFileRead& fr)
{
	// Aller jusqu'aux donnes compresses
	DWORD len = sizeof(HEADERLOCSIG) + (DWORD)m_cen.lenNom + (DWORD)m_lenExtra;
	VERIF(fr.Seek(m_cen.off + len, FILE_BEGIN));
	
	// Mettre  jour la longueur du nom de l'entre,
	// et rcrire l'en-tte local
	m_cen.lenNom = (WORD)lstrlen(m_pszNom);
	if (*m_pDossier->m_pszPath)
		m_cen.lenNom = (WORD)(m_cen.lenNom + lstrlen(m_pDossier->m_pszPath)+1);
	len = sizeof(HEADERLOCSIG) + (DWORD)m_cen.lenNom + (DWORD)m_lenExtra;
	VERIF(PutLocal());
	
	m_cen.off = e_lenEcrit;
	e_lenEcrit += len;
	len = m_dwTailleC;
	
	// Copier les donnes compresses
	if (m_nFlags & locfEtendu)
		len += lenEtendu;
	e_lenEcrit += len;
	VERIF(FichierCopierHelper(fr, m_dwTailleC));
	
	// Copier l'en-tte statique tendu
	return (m_nFlags & locfEtendu) ? e_fw.WriteFrom(fr, lenEtendu) : true;
}
