// Zip/ZipFichier.h


#ifndef _ZIP_ZIPFICHIER_H_
#define _ZIP_ZIPFICHIER_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "../Dossier.h"
#include "../Fichier.h"

#include "../Z/UnZ.h"
#include "Zip.h"


#pragma pack(push,1)

class CZipFichier : public CFichier
{
	friend class CZipArc;
	friend bool UNZ::TesterMDP(const BYTE* pbEnTete, CZipFichier* pzf);
	friend bool UNZ::DecompZip(CZipFichier* pzf, LPCTSTR pszFichierOut);
	
public:  // Fonctions
	
	CZipFichier();
	~CZipFichier();
	
	
public:  // Hritage
	
	DWORD GetOffSfx() const;
	
	bool IsCrypte() const;
	void ToPlusItem(CPlusItem& pi) const;
	
	void SetProp(DWORD dwAttr, CTempsDHS& dtModif);
	bool OnModifProp();
	
	
protected:  // Interne
	
	bool FichierCopierInterne(CFileRead& fr);
	
	bool DecompInterne(LPCTSTR pszDest);
	
	bool PutLocal();
	void PutEtendu() const;
	bool PutCentral();
	
	LPSTR GetZipNom();
	
	HEADERCEN m_cen;
	
	WORD   m_nFlags;      // Flags gnraux
	WORD   m_lenExtra;    // Longueur du champ extra
	
	BYTE  *m_pbExtra;     // Champ supplmentaire (si m_lenExtra>0)
	BYTE  *m_pbExtraC;    // Champ supplmentaire central (si m_lenExtraC>0)
	LPTSTR m_pszCom;      // Commentaires (si m_lenCom>0)
	bool   m_fDOS;        // Forcer les attributs MSDOS
	
	DWORD  m_offCentral;  // Offset du rpertoire central
};

#pragma pack(pop)


#endif
