// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// DialogAide.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#include "Muzip.h"
#include "DialogAide.h"


// Message WM_HELP
static BOOL OnHelpInfo(UINT uMsg, LPARAM lParam)
{
	if (uMsg==WM_HELP) {
		// WM_HELP: demande d'aide
		
		DWORD dwId = ((HELPINFO*)lParam)->dwContextId;
		
		if (dwId) {
			// On a un ID d'aide: afficher la bulle correspondante
			
			oApp.WinHelp(dwId, HELP_CONTEXTPOPUP);
			return TRUE;
		}
		
		
		// Essayer avec le parent du contrle pour grer les botes de dialogue
		// filles d'autres botes de dialogue (pages d'options)
		
		// Rcuprer le parent
		CWnd *const pwndParent = CWnd::FromHandlePermanent(
			::GetParent((HWND)((HELPINFO*)lParam)->hItemHandle));
		
		if (pwndParent && pwndParent->IsKindOf(RUNTIME_CLASS(CDialog))) {
			// Si c'est une bote de dialogue, rcuprer son ID de contrle
			
			dwId = pwndParent->GetDlgCtrlID();
			if (dwId) {
				// OK, tout va bien: on affiche la page d'aide
				oApp.WinHelp(dwId + 0x20000, HELP_CONTEXT);
				return TRUE;
			}
		}
	}
	
	return FALSE;
}



// Bote de dialogue classique
LRESULT CDialogAide::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return (::OnHelpInfo(uMsg, lParam))
		? TRUE
		: CDialog::WindowProc(uMsg, wParam, lParam);
}


// Bote de dialogue commune d'ouverture/enregistrement de fichier
LRESULT CFileDialogAide::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return (::OnHelpInfo(uMsg, lParam))
		? TRUE
		: CFileDialogEx::WindowProc(uMsg, wParam, lParam);
}


// Page de proprigs
LRESULT CPropertyPageAide::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return (::OnHelpInfo(uMsg, lParam))
		? TRUE
		: CPropertyPage::WindowProc(uMsg, wParam, lParam);
}



// Bote de dialogue de propris
BOOL CTabSheetAide::OnInitDialog()
{
	ModifyStyleEx(0, WS_EX_CONTEXTHELP);
	
	return CTabSheet::OnInitDialog();
}
