// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Divers.cpp
//
// Des fonctions diverses


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Divers.h"


CString    e_sMsg;
CFileWrite e_fw;


// Entres/sorties entre une case  cocher et un 'bool'
void DDX_Check(CDataExchange* pDX, int nIDC, bool& f)
{
	int i;
	if (pDX->m_bSaveAndValidate) {
		DDX_Check(pDX, nIDC, i);
		f = ToBool(i);
	}else
		DDX_Check(pDX, nIDC, i = f);
}


// Activer/dsactiver une srie de contrles suivant l'tat d'un autre
void SetEnabled(CWnd *pWnd, UINT uIDDeb, UINT uIDFin, UINT uIDDef)
{
	const BOOL fActive = pWnd->IsDlgButtonChecked(uIDDef);
	for (UINT uID=uIDDeb; uID<=uIDFin; uID++)
		::EnableWindow(::GetDlgItem(*pWnd, uID), fActive);
}


// Ajouter des colonnes  une liste en mode "dtails"
// La liste des noms des colonnes (ressource nIDSHeader)
// doit tre dlimite par des '\n'
void FillListHeader(CListCtrl& lst, UINT nIDSHeader, const LIST_HEADER alh[])
{
	LVCOLUMN lvc;
	lvc.mask     = LVCF_TEXT | LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM;
	lvc.iSubItem = 0;
	
	CTokenize tok(nIDSHeader, '\n');
	while (tok.Next()) {
		lvc.pszText = (STRING)tok.GetToken();
		lvc.fmt     = alh[tok.GetIndex()].uAlign;
		lvc.cx      = alh[tok.GetIndex()].cx;
		
		lst.InsertColumn(lvc.iSubItem++, &lvc);
	}
}


//*** CTokenize
//
// Analyse une chane partie par partie
// Si cSep==0, on utilise tous les espaces comme sparateurs
// et on gre les guillemets

// Constructeurs
CTokenize::CTokenize(LPCTSTR psz, TCHAR cSep)
{
	m_s = psz;
	Init(cSep);
}
CTokenize::CTokenize(UINT nID, TCHAR cSep)
{
	m_s.LoadString(nID);
	Init(cSep);
}

// Facteur commun des constructeurs
void CTokenize::Init(TCHAR cSep)
{
	m_cSep = cSep;
	m_i    = -1;
	m_pc   = m_s;
}


// Passer au token suivant
bool CTokenize::Next()
{
	if (!*m_pc) {
		// Token vide
		
TokenVide:
		m_sToken.Empty();
		return false;
	}
	
	m_i++;
	
	// Chercher le token suivant
	
	TCHAR cSep = m_cSep;
	
	if (!cSep) {
		// Sparateur espace et tabulation,
		// gestion des guillemets
		
		while (isspace(*m_pc)) 
			m_pc++;
		if (!*m_pc)
			goto TokenVide;
		
		if (*m_pc=='"') {
			// Avec guillemets: comme si on avait un sparateur
			
			m_pc++;
			cSep = '"';
		}
	}
	
	
	LPCTSTR pcNext;
	if (cSep)
		// Aller jusqu'au sparateur
		pcNext = _tcschr(m_pc, cSep);
		
	else{
		// Aller jusqu'au prochain espace
		
		pcNext = m_pc;
		while (*pcNext && !_istspace(*pcNext))
			pcNext++;
		if (!*pcNext)
			pcNext = NULL;
	}
	
	if (!pcNext) {
		// Dernier token: copier la fin de la chane
		
		m_sToken = m_pc;
		m_pc += lstrlen(m_pc);
		
	}else{
		// Token intermdiaire: copier la partie de chane
		
		const int buf = pcNext - m_pc;
		memcpy(m_sToken.GetBufferSetLength(buf), m_pc, buf*sizeof(TCHAR));
		m_sToken.ReleaseBuffer(buf);
		m_pc = pcNext + 1;
	}
	
	return true;
}
