// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgAPropos.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgAPropos.h"
#include "IOFichier.h"

#include "MuzipDll/MuzipDll.h"


BEGIN_MESSAGE_MAP(CDlgAPropos, CDialog)
	//{{AFX_MSG_MAP(CDlgAPropos)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CDlgAPropos::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgAPropos)
	DDX_Control(pDX, IDCLBL_WEB,   m_lblWeb);
	DDX_Control(pDX, IDCLBL_EMAIL, m_lblEMail);
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate) {
		// S'occuper des versions
		
		SetVersion(IDCLBL_TITRE,   e_em.hModule);
		SetVersion(IDCLBL_VER_EXE, oApp.m_hInstance);
		SetVersion(IDCLBL_VER_RES, AfxGetResourceHandle());
		SetVersion(IDCLBL_VER_DLL, e_em.hModule);
	}
}


// Couleur
HBRUSH CDlgAPropos::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	const HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	switch (pWnd->GetDlgCtrlID()) {
		
		// Titre
		case IDCLBL_TITRE:
			{
				static CFont s_fntTitre;
				if (!(HFONT)s_fntTitre)
					s_fntTitre.CreatePointFont(200, _T("Arial"));
				pDC->SelectObject(&s_fntTitre);
			}
			break;
		
		// Liens
		case IDCLBL_WEB:
		case IDCLBL_EMAIL:
			{
				static CFont s_fntLien;
				if (!(HFONT)s_fntLien) {
					LOGFONT lf;
					pWnd->GetFont()->GetLogFont(&lf);
					lf.lfUnderline = TRUE;
					s_fntLien.CreateFontIndirect(&lf);
				}
				pDC->SelectObject(&s_fntLien);
				pDC->SetTextColor(RGB(0,0,255));
			}
			break;
	}
	
	return hbr;
}


// Remplir un label de version
void CDlgAPropos::SetVersion(UINT nID, HINSTANCE hInst)
{
	CString s = _T("?");
	
	// Rcuprer le numro de version et le convertir en chane
	VERSION ver;
	if (GetInstanceVersion(hInst, ver))
		s.Format(_T("%lu.%02lu"), ver.verH>>16, ver.verL>>16);
	
	// Ajouter la version au label prcdent
	CString sTout;
	GetDlgItemText(nID, sTout);
	sTout += s;
	SetDlgItemText(nID, sTout);
}
