// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgArchivePlus.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgArchivePlus.h"

#include "MuzipArc.h"
#include "PlusItem.h"
#include "Fichier.h"

#include "dlgAjouter.h"
#include "dlgPlusItem.h"


const int maxLimite = 1000000000;


BEGIN_MESSAGE_MAP(CDlgArchivePlus, CDialogAide)
	//{{AFX_MSG_MAP(CDlgArchivePlus)
	ON_COMMAND      (IDCCMD_AJOUTER,   OnAjouter)
	ON_COMMAND      (IDCCMD_SUPPRIMER, OnSupprimer)
	ON_LBN_SELCHANGE(IDCLST_PI,        OnLstSelChange)
	ON_COMMAND      (IDCCMD_ENLEVER,   OnEnlever)
	ON_EN_CHANGE    (IDCTXT_LIMITE,    OnLimiteChange)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDCCMD_HAUT, IDCCMD_BAS, OnHautBas)
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnToolTipNeedText)
END_MESSAGE_MAP()


// Constructeur
#pragma warning (disable: 4355)
CDlgArchivePlus::CDlgArchivePlus(CMuzipArc* pArc, LPCTSTR pszArchive,
		CArchivePlus& arPlus, CString& sMdp, CWnd* pParent)
	: CDialogAide(IDD, pParent),
	  m_dlgPI(pArc, pszArchive, true, sMdp),
	  m_pArc(pArc), m_pszArchive(pszArchive), m_rarPlus(arPlus), m_sMdp(sMdp),
	  m_lstBouton(this, m_lst, IDCCMD_AJOUTER)
{
	if (m_pArc)
		m_pszArchive = m_pArc->GetPath();
	
	m_arPlus = m_rarPlus;
	
	(CPlusItem&)m_dlgPI = oApp.m_pi;
	
	m_ppiCur = NULL;
	
	//{{AFX_DATA_INIT(CDlgArchivePlus)
	//}}AFX_DATA_INIT
}
#pragma warning (default: 4355)


// Contrles
void CDlgArchivePlus::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgArchivePlus)
	DDX_Control   (pDX, IDCSPN_LIMITE,      m_spnLimite);
	DDX_Control   (pDX, IDCLST_PI,          m_lst);
	DDX_Control   (pDX, IDCCMD_AJOUTER,     m_cmdAjouter);
	DDX_Control   (pDX, IDCCMD_HAUT,        m_cmdHaut);
	DDX_Control   (pDX, IDCCMD_BAS,         m_cmdBas);
	//}}AFX_DATA_MAP
	DDX_CBIndex   (pDX, IDCCBO_SUP,         m_arPlus.m_nSup);
	DDX_Text      (pDX, IDCTXT_DOSSIERPLUS, m_arPlus.m_sDossier);
	DDX_TextInfini(pDX, IDCTXT_LIMITE,      m_arPlus.m_iLimite);
	DDV_MinMaxUInt(pDX,                     m_arPlus.m_iLimite, 0, maxLimite);
	DDX_Check     (pDX, IDCCHK_AJOUTRM,     m_arPlus.m_fAjoutRm);
	
	if (!pDX->m_bSaveAndValidate) {
		OnLimiteChange();
		
		// Si on dite pas un script, alors il faut dsactiver la case
		// "forcer l'ajout en mode reconstruction manuelle"
		if (!m_pArc) {
			GetDlgItem(IDCCHK_AJOUTRM)->EnableWindow(FALSE);
			m_arPlus.m_fAjoutRm = false;
		}
	}
}


// Initialisation
BOOL CDlgArchivePlus::OnInitDialog()
{
	// Charger la bote de dialogue du panneau de droite
	// On utilise pour la placer le contrle IDCDLG_PLUSITEM
	// On doit le faire AVANT le premier CDlgArchivePlus::UpdateData()
	{
		// Rcuprer la position de la future bote de dialogue
		CRect rcPlusItem;
		GetDlgItem(IDCDLG_PLUSITEM)->GetWindowRect(rcPlusItem);
		ScreenToClient(rcPlusItem);
		
		// Crer la bote de dialogue et la dsactiver
		// (aucune slection dans la liste pour l'instant)
		m_dlgPI.Create(IDD_PLUSITEM_CHILD, this);
		m_dlgPI.SetEnabled(false);
		
		// Positionner et afficher la bote de dialogue quand tout est fini
		m_dlgPI.SetWindowPos(NULL, rcPlusItem.left,rcPlusItem.top,
			0,0, SWP_NOZORDER | SWP_NOSIZE | SWP_SHOWWINDOW);
	}
	
	m_dlgPI.m_pdlgArchivePlus = this;
	
	CDialogAide::OnInitDialog();
	
	EnableToolTips();
	
	// Affecter les icnes aux boutons
	m_lstBouton.SetIcons();
	
	
	// Remplir la liste
	// On fait une copie des CPlusItem
	m_lst.SetRedraw(FALSE);
	POS pos = m_rarPlus.GetPosDeb();
	while (pos)
		m_lst.InsertString(-1, new CPlusItem(*m_rarPlus.GetSuiv(pos)));
	m_lst.UpdateHorizontalExtent();
	m_lst.SetRedraw();
	
	// Aucune slection au dbut
	OnLstSelChange();
	
	// Limite
	m_spnLimite.SetRange32(0, maxLimite);
	
	
	return TRUE;
}


// Modifier un CPlusItem d'aprs les paramtres du panneau de droite
// Les donnes sont enregistres dans m_ppiCur
// Si m_ppiCur est nul, TRUE est retourn directement
// Renvoyer TRUE en cas de succs, FALSE s'il y a une erreur dans le UpdateData()
bool CDlgArchivePlus::DLGtoPI()
{
	if (!m_ppiCur)
		return true;
	
	// Charger les donnes de la bote de dialogue
	VERIF(m_dlgPI.UpdateData());
	*m_ppiCur = m_dlgPI;
	
	return true;
}

// Afficher les paramtres d'un CPlusItem dans le panneau de droite
void CDlgArchivePlus::PItoDLG(CPlusItem* ppi)
{
	m_ppiCur = ppi;
	
	// Activer ou dsactiver le panneau de droite
	// selon si un item est dit ou non
	m_dlgPI.SetEnabled(ToBool(m_ppiCur));
	
	// Enregistrer les donnes dans la bote de dialogue
	if (m_ppiCur) {
		(CPlusItem&)m_dlgPI = *m_ppiCur;
		m_dlgPI.UpdateData(FALSE);
	}
}


// Fonction appele par m_dlgPI quand un item a chang
// et que cela a des rpercutions sur son apparence dans la liste
// (icne ou texte -> action ou spcification)
// Si fTexte==true, la fonction doit supprimer et ajouter l'item
// car son texte a chang
// Si fTexte==false, la fonction se contente de redessiner l'item
void CDlgArchivePlus::OnCurItemChanged(bool fTexte)
{
	const int nSel = m_lst.GetCaretIndex();
	CPlusItem *const ppi = m_lst.GetItemPI(nSel);
	
	if (ppi) {
		// Supprimer puis ajouter l'item,
		// sans oublier de le reslectionner aprs
		
		ppi->DO_sFiltre = m_dlgPI.DO_sFiltre;
		ppi->CO_nAction = m_dlgPI.CO_nAction;
		
		if (fTexte) {
			m_lst.DeleteString(nSel);
			m_lst.InsertString(nSel, ppi);
		}else
			m_lst.RedrawWindow();
	}
}


// OK
void CDlgArchivePlus::OnOK()
{
	if (!DLGtoPI() || !UpdateData())
		return;
	
	// Copier les paramtres globaux
	(ARCHIVEPLUS_GUI&)m_rarPlus = m_arPlus;
	m_rarPlus.DeleteAll();
	
	// Copier les requtes
	
	int nbItem = m_lst.GetCount();
	
	// Si aucune requte n'a t ajoute,
	// alors c'est comme si on avait cliqu sur "Annuler"
	if (!nbItem) {
		OnCancel();
		return;
	}
	
	// Rcuprer les objets CPlusItem
	while (nbItem)
		m_rarPlus.AddDeb(m_lst.GetItemPI(--nbItem));
	
	EndDialog(IDOK);
}

// Annuler
void CDlgArchivePlus::OnCancel()
{
	// Dtruire les objets
	int nbItem = m_lst.GetCount();
	while (nbItem > 0)
		delete m_lst.GetItemPI(--nbItem);
	
	EndDialog(IDCANCEL);
}


// Ajouter
void CDlgArchivePlus::OnAjouter()
{
	AjouterEnlever(true);
}

// Enlever
void CDlgArchivePlus::OnEnlever()
{
	AjouterEnlever(false);
}

// Ajouter ou enlever
void CDlgArchivePlus::AjouterEnlever(bool fAjouter, LPCTSTR pszSpecInitiale)
{
	// Enregistrer les modifications de l'item slectionn
	if (!DLGtoPI())
		return;
	
	// Crer l'item
	CPlusItem *const ppi = new CPlusItem;
	*ppi = oApp.m_pi;
	ppi->CO_nAction = (fAjouter) ? coaPlusMAJ : coaMoins;
	ppi->DO_sFiltre = pszSpecInitiale;
	
	// Demander la spcification
	if (!ppi->DemanderSpec(m_pszArchive)) {
		delete ppi;
		return;
	}
	
	// Ajouter l'item  la fin de la liste
	// et le slectionner uniquement lui
	m_lst.SetSel(-1, FALSE);
	m_lst.SetSel(m_lst.InsertString(-1, ppi));
	m_lst.UpdateHorizontalExtent();
	OnLstSelChange();
	
	// Demander les options
	PItoDLG(ppi);
	
	// Redonner le focus  la liste car le bouton l'avait pris
	// (la liste est plus importante que le bouton)
	m_lst.SetFocus();
}


// Supprimer
void CDlgArchivePlus::OnSupprimer()
{
	m_lst.SetRedraw(FALSE);
	
	// Supprimer l'item
	int nItem = 0;
	for (;;) {
		const int sel = m_lst.GetSel(nItem);
		if (sel==LB_ERR)
			break;
		
		if (sel) {
			delete m_lst.GetItemPI(nItem);
			m_lst.DeleteString(nItem);
		}else
			nItem++;
	}
	
	m_lst.UpdateHorizontalExtent();
	m_lst.SetRedraw();
	
	// Plus d'item courant
	m_ppiCur = NULL;
	
	OnLstSelChange();
}

// Haut/bas
void CDlgArchivePlus::OnHautBas(UINT nID)
{
	m_lstBouton.OnHautBas(nID);
}


// Liste - slection modifie
void CDlgArchivePlus::OnLstSelChange()
{
	// Enregistrer les paramtres de l'item prcdent
	if (!DLGtoPI()) {
		// Erreur: il faut annuler le changement de slection
		
		// Slectionner l'item correspondant  m_ppiCur
		const int nbItem = m_lst.GetCount();
		for (int nItem=0; nItem<nbItem; nItem++) {
			if (m_lst.GetItemPI(nItem)==m_ppiCur) {
				m_lst.SetSel(nItem);
				break;
			}
		}
		
		return;
	}
	
	// Charger les informations sur le nouvel item
	PItoDLG(m_lst.GetItemPI(m_lst.GetCaretIndex()));
	
	// Mettre  jour les boutons
	m_lstBouton.OnLstSelChange(true);
}


// Info-bulle des boutons
BOOL CDlgArchivePlus::OnToolTipNeedText(UINT, NMHDR* pNMHDR, LRESULT*)
{
	TOOLTIPTEXT *const pTTT = (TOOLTIPTEXT*)pNMHDR;
	
	if (pTTT->uFlags & TTF_IDISHWND) {
		pTTT->lpszText = MAKEINTRESOURCE(::GetDlgCtrlID((HWND)pNMHDR->idFrom));
		pTTT->hinst    = AfxGetResourceHandle();
		return TRUE;
	}
	
	return FALSE;
}


// Changement de la limite
void CDlgArchivePlus::OnLimiteChange()
{
	InfiniRemplaceZero(this, IDCTXT_LIMITE);
}


// Glisser-dplacer de fichiers dans la liste
void CDlgArchivePlus::OnLstDropFiles(HDROP hDrop)
{
	CString sSpecInitiale;
	
	// Rcuprer la liste de fichiers
	const UINT nbFichier = ::DragQueryFile(hDrop, (UINT)-1, NULL,0);
	for (UINT iFichier=0; iFichier<nbFichier; iFichier++) {
		TCHAR pszFichier[MAX_PATH];
		if (::DragQueryFile(hDrop, iFichier, pszFichier, nbArray(pszFichier))) {
			if (!sSpecInitiale.IsEmpty())
				sSpecInitiale += cSepPartie;
			sSpecInitiale += pszFichier;
		}
	}
	
	AjouterEnlever(true, sSpecInitiale);
}
