// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgAssoc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"
#include "dlgAssoc.h"

#include "Reg.h"
#include "Options.h"
#include "IOFichier.h"


#if 0
BEGIN_MESSAGE_MAP(CDlgAssoc, CDialog)
	//{{AFX_MSG_MAP(CDlgAssoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Contrles
void CDlgAssoc::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgAssoc)
	DDX_Control(pDX, IDCLST_ASSOC, m_lst);
	//}}AFX_DATA_MAP
}



// Initialisation
BOOL CDlgAssoc::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Crer la liste des filtres
	CString sFilterTous, sFilterAutre, sDefault;
	
	TCHAR pszFichier[MAX_PATH], pszFichierOld[MAX_PATH], pszProg[MAX_PATH];
	CString s, sFilterExt;
	
	// Crer un fichier temporaire pour FindExecutable
	if (!e_opt.GetDossier(repTemp, pszFichier))
		return TRUE;
	PathAppend(pszFichier, _T("Assoc"));
	TCHAR *pcFichier = &pszFichier[lstrlen(pszFichier)];
	lstrcpy(pszFichierOld, pszFichier);
	TCHAR *pcFichierOld = pszFichierOld + (pcFichier-pszFichier);
	TCHAR pszExt[16];
	
	// Prparer chaque association
	POS pos = oApp.m_lstAssoc.GetPosDeb();
	while (pos) {
		CAssoc *const pAssoc = oApp.m_lstAssoc.GetSuiv(pos);
		
		lstrcpy(pszExt, pAssoc->m_pszExt);
		CharUpper(pszExt);
		if (!lstrcmp(pszExt, _T(".EXE")))
			continue;
		
		lstrcpy(pcFichier, pszExt);
		
		// Pour que FindExecutable fonctionne,
		// il faut que le fichier existe
		if (!PathFileExists(pszFichierOld))
			FichierCreer(pszFichier);
		else
			MoveFile(pszFichierOld, pszFichier);
		lstrcpy(pcFichierOld, pcFichier);
		
		if (FindExecutable(pszFichier, NULL, pszProg)>(HINSTANCE)32) {
			// L'extension est associe  un programme
			// Traiter spcialement certains fichiers .exe correspondant 
			// Muzip, CabView, WinZip, WinRar, TurboZip, ZipMagic...
			// en affichant le nom du compresseur au lieu de l'excutable
			
			PathStripPath      (pszProg);
			PathRemoveExtension(pszProg);
			CharUpper(pszProg);
			
			struct
			{
				LPCTSTR pszExe;
				LPCTSTR pszNom;
			}
			const aProg[] =
			{
				{ _T("WINZIP32"), _T("WinZip") },
				{ _T("MUZIP"),    _T("Muzip") },
				{ _T("TURBOZIP"), _T("TurboZIP") },
				{ _T("WINRAR"),   _T("WinRAR") },
				{ _T("ZMOPEN"),   _T("ZipMagic") },
				{ _T("CABVIEW"),  _T("CabView") },
			};
			
			LPCTSTR psz = pszProg;
			for (int iProg=0; iProg<nbArray(aProg); iProg++) {
				if (!lstrcmp(pszProg, aProg[iProg].pszExe)) {
					// Trouv: utiliser le joli nom
					psz = aProg[iProg].pszNom;
					break;
				}
			}
			// Formatter et ajouter l'item  la liste
			s.Format(_T(" %s (%s)"), pszExt, psz);
		}else{
			// L'extension n'est associe  aucun programme
			// L'afficher simplement
			*pszProg = 0;
			s.Format(_T(" %s"), pszExt);
		}
		
		// Ajouter l'item, dfinir les donnes (la structure ASSOC)
		// et cocher l'item si l'extension est associe  Muzip
		const int nItem = m_lst.AddString(s);
		m_lst.SetItemDataPtr(nItem, pAssoc);
		if (!lstrcmpi(pszProg, _T("MUZIP")))
			m_lst.SetCheck(nItem, TRUE);
	}
	DeleteFile(pszFichierOld);
	
	
	return TRUE;
}


// OK
void CDlgAssoc::OnOK()
{
	bool fNotify = false;
	
	for (int nItem=m_lst.GetCount(); nItem>0; ) {
		nItem--;
		
		// Rcuprer l'association et l'tat de la case
		CAssoc *const pAssoc = (CAssoc*)m_lst.GetItemDataPtr(nItem);
		const bool fMuzip = ToBool(m_lst.GetCheck(nItem));
		
		// Ouvrir la cl correspondant  l'association
		// et lire l'association courante
		HKEY hKey;
		TCHAR pszValeur[MAX_PATH];
		
		// Regarder si la valeur trouve correspond  l'tat de la case
		// (pszClasseMuzipArchive pour case coche)
		if (pAssoc->GetAssocCur(hKey, pszValeur)!=fMuzip) {
			// Cela ne correspond pas: il faut changer quelque chose
			// (la sauvegarde ou le registre)
			pAssoc->Affecter(fMuzip, hKey, pszValeur);
			fNotify = true;
		}
		
		if (hKey)
			RegCloseKey(hKey);
	}
	
	if (fNotify)
		CAssoc::NotifyChange();
	
	CDialog::OnOK();
}
