// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgConfirm.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgConfirm.h"


#if 0
BEGIN_MESSAGE_MAP(CDlgConfirm, CDialogAide)
	//{{AFX_MSG_MAP(CDlgConfirm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Contrles
void CDlgConfirm::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgConfirm)
	DDX_Control(pDX, IDCLBL_QUESTION,   m_lblQuestion);
	DDX_Check  (pDX, IDCCHK_PASCONFIRM, m_fPasConfirm);
	//}}AFX_DATA_MAP
}


// Initialisation
BOOL CDlgConfirm::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	// Dfinir l'icne
	m_lblQuestion.SetIcon(oApp.LoadStandardIcon(IDI_QUESTION));
	
	// Redimensionner la bote de dialogue et repositionner les contrles en bas
	const int yDiff = DlgRedimSelonLabel(*this, m_sMsg);
	MoveControlY(*this, IDCCHK_PASCONFIRM, yDiff);
	MoveControlY(*this, IDOK,              yDiff);
	MoveControlY(*this, IDCANCEL,          yDiff);
	
	// Dfinir le bouton par dfaut
	const UINT idDefaut = (m_cfm & cfmNonDefaut) ? IDCANCEL : IDOK;
	SetDefID(idDefaut);
	GetDlgItem(idDefaut)->SetFocus();
	
	return FALSE;
}


// Non
void CDlgConfirm::OnCancel()
{
	UpdateData();
	EndDialog(IDCANCEL);
}


// Afficher une bote de dialogue de confirmation
// Passer 0 pour nIDS afin d'utiliser e_sMsg
// Retourner TRUE si l'utilisateur a cliqu sur Oui
// Le "mcf" est l'index du message de confirmation
bool CDlgConfirm::GetReponse(int mcf, UINT nIDS, int cfm)
{
	// Rcuprer le boolen indiquant s'il faut afficher
	// le message de confirmation (dans les options)
	const DWORD dwMcfMask = 1<<mcf;
	BOOL bConfirm = ToBool(e_opt.m_dwConfirmMcf & dwMcfMask);
	
	// Confier tout le travail  GetReponseMan()
	const bool fRet = GetReponseMan(bConfirm, nIDS, cfm);
	
	// Stocker le boolen indiquant s'il faut afficher
	// le message de confirmation
	if (bConfirm)
		e_opt.m_dwConfirmMcf |=  dwMcfMask;
	else
		e_opt.m_dwConfirmMcf &= ~dwMcfMask;
	
	return fRet;
}


// Afficher une bote de dialogue de confirmation
// Passer 0 pour nIDS afin d'utiliser e_sMsg
// Retourner TRUE si l'utilisateur a cliqu sur Oui
bool CDlgConfirm::GetReponseMan(BOOL& rbConfirm, UINT nIDS, int cfm)
{
	// Si la confirmation est dsactive,
	// faire comme si on avait rpondu oui
	if ((!(cfm & cfmForcerConfirm) && oApp.m_nConfirm<=0) || !rbConfirm)
		return true;
	
	// Dsactiver les fentres
	oApp.EnableModeless(FALSE);
	
	// Afficher la bote de dialogue
	CDlgConfirm dlgConfirm;
	if (nIDS) 
		e_sMsg.LoadString(nIDS);
	dlgConfirm.m_sMsg        = e_sMsg;
	dlgConfirm.m_cfm         = cfm;
	dlgConfirm.m_fPasConfirm = ToBool(cfm & cfmPlusDemander);
	const bool fOui = (dlgConfirm.DoModal()==IDOK);
	rbConfirm = !dlgConfirm.m_fPasConfirm;
	
	// Ractiver les fentres
	oApp.EnableModeless(TRUE);
	
	return fOui;
}
