// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgConvertir.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgConvertir.h"

#include "MuzipArc.h"

#include "FileDialogEx.h"


BEGIN_MESSAGE_MAP(CDlgConvertir, CDialogAide)
	//{{AFX_MSG_MAP(CDlgConvertir)
	ON_CBN_SELCHANGE(IDCCBO_CIBLE, OnFormatSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgConvertir::CDlgConvertir(CMuzipArc* pArc, CWnd* pParent)
	: CDialogAide(IDD, pParent), m_pArc(pArc)
{
	//{{AFX_DATA_INIT(CDlgConvertir)
	m_nFormat = 0;
	m_nType   = 0;
	//}}AFX_DATA_INIT
}


// Contrles
void CDlgConvertir::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgConvertir)
	DDX_Control(pDX, IDCCBO_CIBLE,  m_cboFormat);
	DDX_CBIndex(pDX, IDCCBO_CIBLE,  m_nFormat);
	DDX_Radio  (pDX, IDCOPT_CONV_0, m_nType);
	//}}AFX_DATA_MAP
	
	if (pDX->m_bSaveAndValidate)
		m_pmdt = (m_nFormat>=0)
			? (CDocType*)m_cboFormat.GetItemDataPtr(m_nFormat)
			: NULL;
}


// Initialisation
BOOL CDlgConvertir::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	// Remplir la liste des formats
	POS pos = oApp.m_lstDocType.GetPosDeb();
	while (pos) {
		CDocType &dt = *oApp.m_lstDocType.GetSuiv(pos);
		
		// Le cas des auto-extractibles
		// est gr par une bote de dialogue spcifique
		const UINT idType = dt.GetIdType();
		if (idType==IDR_SFXTYPE || idType==m_pArc->m_pmdt->GetIdType())
			continue;
		
		// Ajouter le format
		CString sFormat;
		dt.GetDocString(sFormat, CDocTemplate::regFileTypeName);
		m_cboFormat.SetItemDataPtr(m_cboFormat.AddString(sFormat), &dt);
	}
	
	
	// Remettre  jour la bote de dialogue maintenant que la liste est pleine
	UpdateData(FALSE);
	OnFormatSelChange();
	
	return TRUE;
}


// Changement de format
void CDlgConvertir::OnFormatSelChange()
{
	if (!UpdateData())
		return;
	
	// Regarder si on peut recompresser les fichiers de l'archive
	// dans le format cible
	// Cela n'est pas possible si le format cible n'accepte qu'un seul fichier
	// (GZip, UUE) et si l'archive contient plusieurs fichiers
	const bool fPeutConvertirFichiers =
		(!(m_pmdt->GetCap() & capMaxUnFichier)) ||
		m_pArc->GetNbFichier()<=1;
	
	GetDlgItem(IDCOPT_CONV_0)->EnableWindow(fPeutConvertirFichiers);
	
	// Cocher l'autre choix s'il n'y a que celui-l de disponible
	if (!fPeutConvertirFichiers)
		CheckRadioButton(IDCOPT_CONV_0, IDCOPT_CONV_1, IDCOPT_CONV_1);
}


// OK
void CDlgConvertir::OnOK()
{
	if (!UpdateData())
		return;
	
	// Rcuprer le nom par dfaut de l'archive cible
	// en utilisant le nom de l'archive source et l'extension par dfaut
	// du type d'archive cible
	CString sExtDefaut;
	m_pmdt->GetExtDefaut(sExtDefaut);
	m_sCible = m_pArc->GetPath();
	PathRenameExtension(m_sCible.GetBuffer(MAX_PATH), sExtDefaut);
	m_sCible.ReleaseBuffer();
	
	// Demander confirmation
	CFileDialogEx dlgSave(FALSE, NULL, m_sCible, fdFlagsSave);
	dlgSave.m_ofn.nFilterIndex = 1;
	if (oApp.ShowFileOpenDialog(dlgSave, sfodPasScript, m_pmdt)) {
		m_sCible = dlgSave.GetPathName();
		delete [] dlgSave.m_ofn.lpstrFile;
		EndDialog(IDOK);
	}
}
