// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgDecomp.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgDecomp.h"
#include <TrvExplore.h>

#include "MuzipArc.h"
#include "Fichier.h"

#include "Options.h"
#include "IOFichier.h"


BEGIN_MESSAGE_MAP(CDlgDecomp, CDialogAide)
	//{{AFX_MSG_MAP(CDlgDecomp)
	ON_NOTIFY(TVN_SELCHANGED, IDCTRE_DEST, OnTreDestSelChanged)
	ON_CBN_SELCHANGE(IDCCBO_ECRASE, OnEcraseSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgDecomp::CDlgDecomp(bool fAppDefaut,
	const CMuzipArc* pArc)
	: CDialogAide(IDD),
	  m_fAppDefaut(fAppDefaut)
{
	//{{AFX_DATA_INIT(CDlgDecomp)
	//}}AFX_DATA_INIT
	
	// Options
	m_dec = oApp.m_dec;
	
	if (pArc) {
		// Rpertoire de destination par dfaut de l'archive
		
		e_opt.GetDossier(repDecomp, m_sDest.GetBuffer(MAX_PATH), pArc->GetPath());
		m_sDest.ReleaseBuffer();
	}
}

// Initialiser le rpertoire de destination et les options
// Renvoyer TRUE si toutes les options ncessaires  la compression
// ont t spcifies
bool CDlgDecomp::Init(LPCTSTR pszDest, LPCTSTR pszOptions)
{
	m_dec.FromOptions(pszOptions);
	
	// Si un rpertoire de destination par dfaut est impos...
	TCHAR pszDestFull[MAX_PATH];
	VERIF(MyGetFullPathName(pszDest, pszDestFull));
	m_sDest = pszDestFull;
	
	return true;
}


// Contrles
void CDlgDecomp::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	DDX_TrvExplore(pDX, IDCTRE_DEST,         m_treDest, m_sDest);
	//{{AFX_DATA_MAP(CDlgDecomp)
	DDX_Text      (pDX, IDCTXT_DEST,         m_sDest);
	DDV_MaxChars  (pDX,                      m_sDest, MAX_PATH);
	//}}AFX_DATA_MAP
	DDX_CBIndex   (pDX, IDCCBO_ECRASE,       m_dec.nEcrase);
	DDX_Check     (pDX, IDCCHK_ECRASEDATE,   m_dec.fEcraseDate);
	DDX_Check     (pDX, IDCCHK_ARBO,         m_dec.fArbo);
	DDX_Check     (pDX, IDCCHK_GARDERERREUR, m_dec.fGardeErreur);
	DDX_Check     (pDX, IDCCHK_QUETROUVE,    m_dec.fQueTrouve);
	
	if (!pDX->m_bSaveAndValidate)
		OnEcraseSelChange();
}


// Arborescence - Slection modifie
void CDlgDecomp::OnTreDestSelChanged(NMHDR*, LRESULT*)
{
	SetDlgItemText(IDCTXT_DEST, m_treDest.GetPath());
}


// Comportement si crasement - Slection modifie
void CDlgDecomp::OnEcraseSelChange()
{
	::EnableWindow(::GetDlgItem(*this, IDCCHK_ECRASEDATE),
		((CComboBox*)GetDlgItem(IDCCBO_ECRASE))->GetCurSel()!=ecrJamais);
}


// OK
void CDlgDecomp::OnOK()
{
	if (!UpdateData())
		return;
	
	if (m_fAppDefaut) {
		
		// Garder les options
		oApp.m_dec = m_dec;
		
		// Mmoriser le dernier chemin d'accs si ncessaire
		e_opt.SetDossierDernier(repDecomp, m_sDest);
	}
	
	EndDialog(IDOK);
}
