// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgDecompMult.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "dlgDecompMult.h"

#include "MuzipArc.h"
#include "FileDialogEx.h"

#include "dlgDecomp.h"



BEGIN_MESSAGE_MAP(CDlgDecompMult, CDialogAide)
	//{{AFX_MSG_MAP(CDlgDecompMult)
	ON_COMMAND      (IDCCMD_DM_AJOUTER,   OnAjouter)
	ON_COMMAND      (IDCCMD_DM_SUPPRIMER, OnSupprimer)
	ON_COMMAND      (IDCCMD_DM_OPTIONS,   OnOptions)
	ON_LBN_SELCHANGE(IDCLST_DM,           OnLstSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
#pragma warning (disable: 4355)
CDlgDecompMult::CDlgDecompMult()
	: CDialogAide(IDD),
	  m_lstBouton(this, m_lst, IDCCMD_DM_AJOUTER)
{
	//{{AFX_DATA_INIT(CDlgDecompMult)
	m_fDecompSousDossier = TRUE;
	//}}AFX_DATA_INIT
	
	e_opt.GetDossier(repDecomp, m_sDest.GetBuffer(MAX_PATH));
	m_sDest.ReleaseBuffer();
	m_dec = oApp.m_dec;
}
#pragma warning (default: 4355)


// Contrles
void CDlgDecompMult::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgDecompMult)
	DDX_Control(pDX, IDCLST_DM,                m_lst);
	DDX_Check  (pDX, IDCCHK_DECOMPSOUSDOSSIER, m_fDecompSousDossier);
	//}}AFX_DATA_MAP
	
	if (pDX->m_bSaveAndValidate) {
		
		// Rcuprer la liste des noms d'archive
		m_lstArchive.RemoveAll();
		const int nbItem = m_lst.GetCount();
		for (int iItem=0; iItem<nbItem; iItem++) {
			CString sArchive;
			m_lst.GetText(iItem, sArchive);
			m_lstArchive.AddFin(sArchive);
		}
	}
}


// Initialisation
BOOL CDlgDecompMult::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	// Affecter les icnes aux boutons
	m_lstBouton.SetIcons();
	OnLstSelChange();
	
	return TRUE;
}


// Liste - slection modifie
void CDlgDecompMult::OnLstSelChange()
{
	m_lstBouton.OnLstSelChange(true);
}


// Ajouter
void CDlgDecompMult::OnAjouter()
{
	CFileDialogEx dlgOpen(TRUE, pszExtDefaut, NULL,
		fdFlagsOpen | OFN_ALLOWMULTISELECT);
	if (oApp.ShowFileOpenDialog(dlgOpen, sfodPasScript)) {
		// OK
		
		// Ajouter les archives  la liste
		POSITION pos = dlgOpen.GetStartPosition();
		while (pos)
			m_lst.AddString(dlgOpen.GetNextPathName(pos));
		
		delete [] dlgOpen.m_ofn.lpstrFile;
	}
}

// Supprimer
void CDlgDecompMult::OnSupprimer()
{
	// Supprimer les items slectionns
	int nItem = 0;
	for (;;) {
		const int sel = m_lst.GetSel(nItem);
		if (sel==LB_ERR)
			break;
		
		if (sel)
			m_lst.DeleteString(nItem);
		else
			nItem++;
	}
	
	
	OnLstSelChange();
}


// Options de dcompression
void CDlgDecompMult::OnOptions()
{
	CDlgDecomp dlgDecomp(false);
	dlgDecomp.m_sDest = m_sDest;
	dlgDecomp.m_dec   = m_dec;
	if (dlgDecomp.DoModal()==IDOK) {
		m_sDest = dlgDecomp.m_sDest;
		m_dec   = dlgDecomp.m_dec;
	}
}


//*** CLBDecompMult
//
// Liste des archives  dcompresser


BEGIN_MESSAGE_MAP(CLBDecompMult, CListBox)
	//{{AFX_MSG_MAP(CLBDecompMult)
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Glisser-dplacer
void CLBDecompMult::OnDropFiles(HDROP hDropInfo)
{
	// Ajouter les fichiers  la liste
	const UINT nbFichier = ::DragQueryFile(hDropInfo, (UINT)-1, NULL,0);
	for (UINT iFichier=0; iFichier<nbFichier; iFichier++) {
		TCHAR pszFichier[MAX_PATH];
		if (::DragQueryFile(hDropInfo, iFichier, pszFichier, nbArray(pszFichier)))
			AddString(pszFichier);
	}
	
	DragFinish(hDropInfo);
}
