// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgLister.h


#ifndef _DLGLISTER_H_
#define _DLGLISTER_H_
#if _MSC_VER>1000
#pragma once
#endif


#include <FileBuf.h>

class CMuzipArc;
class CFichier;
class CDossier;

enum
{
	ltHTMLArbo,
	ltHTMLTableau,
	ltHTMLListe,
	ltTexteArbo,
	ltTexteFixe,
	ltTexteTab,
	ltCSV,
	
	ltTexteFixeInit,
};


#include "DialogAide.h"
class CDlgLister : public CDialogAide
{
public:  // Fonctions
	
	CDlgLister(CMuzipArc* pArc, CWnd* pParent=NULL);
	
	
protected:  // Interne
	
	void MajChk(int idChkClic, int idChkAutre);
	
	bool AddDeb(int nProf);
	
	bool Lister(const CFichier* pFichier);
	bool Lister(const CDossier* pDossier, int nProf=0);
	
	
	static bool IsQueUneSeuleColonne(int nType)
	{
		return (nType==ltHTMLArbo || nType==ltHTMLListe || nType==ltTexteArbo);
	}
	
	
	CMuzipArc* m_pArc;
	
	enum{ maxCol = 8 };
	
	CFileWrite m_fw;
	CString    m_asCol  [maxCol];
	int        m_aCol   [maxCol];
	int        m_alenCol[maxCol];
	int        m_nbColF, m_nbColD;   // Pour fichiers et dossiers
	TCHAR      m_cSep;
	
	bool AddSep(int iCol, int nCol, bool fDossier, LPCTSTR psz, bool fHeader=false);
	
	
public:  // Donnes
	
	//{{AFX_DATA(CDlgLister)
	enum { IDD = IDD_LISTER };
	int  m_nType;
	BOOL m_fColonne;
	BOOL m_fNom;
	BOOL m_fPath;
	BOOL m_fType;
	BOOL m_fTailleN;
	BOOL m_fTailleC;
	BOOL m_fPC;
	BOOL m_fDtModif;
	BOOL m_fAttr;
	//}}AFX_DATA
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CDlgLister)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CDlgLister)
	afx_msg void OnTypeSelChange();
	virtual void OnOK();
	afx_msg void OnChkNom();
	afx_msg void OnChkPath();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
