// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgMacroAction.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "dlgMacroAction.h"

#include "dlgMacroCmd.h"


BEGIN_MESSAGE_MAP(CDlgMacroAction, CDialogAide)
	//{{AFX_MSG_MAP(CDlgMacroAction)
	ON_LBN_SELCHANGE(IDCLST_MAC_CMD,       OnLstSelChange)
	ON_LBN_DBLCLK   (IDCLST_MAC_CMD,       OnEditer)
	ON_EN_CHANGE    (IDCTXT_MAC_ID,        OnTxtIdChange)
	ON_COMMAND      (IDCCMD_CMD_AJOUTER,   OnAjouter)
	ON_COMMAND      (IDCCMD_CMD_EDITER,    OnEditer)
	ON_COMMAND      (IDCCMD_CMD_SUPPRIMER, OnSupprimer)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDCCMD_CMD_HAUT, IDCCMD_CMD_BAS, OnHautBas)
END_MESSAGE_MAP()
 

// Contrles
void CDlgMacroAction::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgMacroAction)
	DDX_Control (pDX, IDCLST_MAC_CMD,     m_lstCmd);
	DDX_Text    (pDX, IDCTXT_MAC_ID,      m_sId);
	DDV_MaxChars(pDX,                     m_sId,       64);
	DDX_Text    (pDX, IDCTXT_MAC_NAME,    m_sName);
	DDV_MaxChars(pDX,                     m_sName,    256);
	DDX_Text    (pDX, IDCTXT_MAC_COMMENT, m_sComment);
	DDV_MaxChars(pDX,                     m_sComment, 256);
	DDX_Check   (pDX, IDCCHK_HIDDEN,      m_fHidden);
	DDX_Check   (pDX, IDCCHK_ENTRYPOINT,  m_fEntryPoint);
	//}}AFX_DATA_MAP
	
	if (pDX->m_bSaveAndValidate) {
		// Enregistrement:
		// rcuprer les commandes dans la liste
		// et recalculer les ID d'aprs l'ordre
		// On numrote les ID de 10 en 10
		
		RemoveAll();
		const int nb = m_lstCmd.GetCount();
		UINT id = 0;
		for (int nIndex=0; nIndex<nb; nIndex++) {
			CMacCmd *const pcmd = (CMacCmd*)m_lstCmd.GetItemData(nIndex);
			pcmd->m_id = id += 10;
			AddFin(pcmd);
		}
		
	}else{
		OnLstSelChange();
		OnTxtIdChange();
	}
}


// Initialisation
BOOL CDlgMacroAction::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	m_sIdOrig = m_sId;
	
	// Affecter les icnes aux boutons
	m_lstBouton.SetIcons();
	
	// Remplir la liste des commandes
	POS pos = GetPosDeb();
	for (int nIndex=0; pos; nIndex++)
		AddItem(GetSuiv(pos), nIndex, false);
	
	OnLstSelChange();
	OnTxtIdChange();
	
	return TRUE;
}


// Ajoute dans la liste l'item correspondant  une commande
void CDlgMacroAction::AddItem(CMacCmd* pcmd, int nIndex, bool fSel)
{
	// Formatter le texte de l'action
	CString sItem;
	pcmd->GetItem(sItem);
	
	// Ajouter et slectionner l'item
	const int nItem = m_lstCmd.InsertString(nIndex, sItem);
	m_lstCmd.SetItemDataPtr(nItem, pcmd);
	if (fSel) {
		m_lstCmd.SetCurSel(nItem);
		OnLstSelChange();
	}
}


// Liste - slection modifie
void CDlgMacroAction::OnLstSelChange()
{
	m_lstBouton.OnLstSelChange(false);
}


// Changement de l'ID
void CDlgMacroAction::OnTxtIdChange()
{
	// Conditions de validit de l'ID:
	// - non-nul
	// - alphanumrique exclusivement
	// - inutilis par les autres actions (pas de doublons)
	
	// Non-nul, alphanumrique
	CString sId;
	GetDlgItemText(IDCTXT_MAC_ID, sId);
	bool fOK = sId.GetLength()>0;
	for (int i=0; i<sId.GetLength(); i++) {
		if (!IsCharAlphaNumeric(sId[i])) {
			fOK = false;
			break;
		}
	}
	
	// Pas de doublons
	if (lstrcmpi(sId, m_sIdOrig)) {
		POS pos = m_pmac->GetPosDeb();
		while (pos) {
			if (!lstrcmpi(m_pmac->GetSuiv(pos)->m_sId, sId)) {
				fOK = false;
				break;
			}
		}
	}
	
	GetDlgItem(IDOK)->EnableWindow(fOK);
}



// Ajouter
void CDlgMacroAction::OnAjouter()
{
	CDlgMacroCmd dlgCmd(this);
	dlgCmd.m_mcm = (MACCMD)0;
	if (dlgCmd.DoModal()==IDCANCEL)
		return;
	
	// Ajouter la nouvelle action
	CMacCmd *const pcmd = new CMacCmd(this);
	*pcmd = dlgCmd;
	AddFin(pcmd);
	AddItem(pcmd, -1);
}


// diter
void CDlgMacroAction::OnEditer()
{
	const int sel = m_lstCmd.GetCurSel();
	CMacCmd *const pcmd = (CMacCmd*)m_lstCmd.GetItemDataPtr(sel);
	
	CDlgMacroCmd dlgCmd(this);
	(CMacCmd&)dlgCmd = *pcmd;
	if (dlgCmd.DoModal()==IDCANCEL)
		return;
	
	// Modifier la commande
	*pcmd = dlgCmd;
	m_lstCmd.DeleteString(sel);
	AddItem(pcmd, sel);
}


// Supprimer
void CDlgMacroAction::OnSupprimer()
{
	const int sel = m_lstCmd.GetCurSel();
	DeleteAt(Find((CMacCmd*)m_lstCmd.GetItemDataPtr(sel)));
	m_lstCmd.DeleteString(sel);
	OnLstSelChange();
}


// Haut/bas
void CDlgMacroAction::OnHautBas(UINT nID)
{
	m_lstBouton.OnHautBas(nID);
}
