// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgMacroCmd.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "dlgMacroCmd.h"


BEGIN_MESSAGE_MAP(CDlgMacroCmd, CDialogAide)
	//{{AFX_MSG_MAP(CDlgMacroCmd)
	ON_CBN_SELCHANGE(IDCCBO_CMD, OnCmdSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CDlgMacroCmd::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgMacroCmd)
	DDX_Control(pDX, IDCCBO_CMD, m_cboCmd);
	//}}AFX_DATA_MAP
	
	for (int i=0; i<maxArgs; i++)
		DDX_Text(pDX, IDCTXT_ARG_0+i, m_aArgs[i]);
}


// Initialisation
BOOL CDlgMacroCmd::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	// Remplir la liste des commandes possibles
	CTokenize tok(IDS_MAC_CMD, '\n');
	for (int mcm=0; mcm<nbMacCmd; mcm++) {
		tok.Next();
		
		// Rcuprer la description de la commande
		CString sItem;
		sItem.Format(_T("%s - %s"),
			e_apszCmd[mcm],
			(LPCTSTR)tok.GetToken().SpanExcluding(_T("|")));
		
		// Ajouter l'item
		const int nItem = m_cboCmd.AddString(sItem);
		m_cboCmd.SetItemData(nItem, mcm);
		if (m_mcm==mcm)
			m_cboCmd.SetCurSel(nItem);
	}
	
	OnCmdSelChange();
	
	return TRUE;
}


// Changement de type de commande
void CDlgMacroCmd::OnCmdSelChange()
{
	// Rcuprer l'index de la commande
	m_mcm = (MACCMD)m_cboCmd.GetItemData(m_cboCmd.GetCurSel());
	
	// S'occuper des arguments:
	// - affecter leur signification aux labels
	// - griser les zones de texte inutiles
	//   (c'est--dire les arguments sans signification)
	
	// Rcuprer d'abord la liste des explications pour chaque argument
	CString sExplication;
	AfxExtractSubString(sExplication,
		CStringRes(IDS_MAC_CMD), m_mcm, '\n');
	
	// Utiliser cette liste
	CTokenize tok(sExplication, '|');
	tok.Next();   // Ignorer la description de l'action
	for (int i=0; i<maxArgs; i++) {
		tok.Next();
		
		// Label d'explication
		SetDlgItemText(IDCLBL_ARG_0+i, tok.GetToken());
		
		// Activation de la zone de texte
		GetDlgItem(IDCTXT_ARG_0+i)->EnableWindow(!tok.GetToken().IsEmpty());
	}
}
