// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgMacroEditer.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "dlgMacroEditer.h"


#include "dlgMacroAction.h"
#include "dlgConfirm.h"


BEGIN_MESSAGE_MAP(CDlgMacroEditer, CDialogAide)
	//{{AFX_MSG_MAP(CDlgMacroEditer)
	ON_LBN_SELCHANGE(IDCLST_MAC_ACTION,    OnLstSelChange)
	ON_LBN_DBLCLK   (IDCLST_MAC_ACTION,    OnEditer)
	ON_COMMAND      (IDCCMD_ACT_AJOUTER,   OnAjouter)
	ON_COMMAND      (IDCCMD_ACT_SUPPRIMER, OnSupprimer)
	ON_COMMAND      (IDCCMD_ACT_EDITER,    OnEditer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CDlgMacroEditer::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgMacroEditer)
	DDX_Control(pDX, IDCLST_MAC_ACTION, m_lstAction);
	DDX_Check  (pDX, IDCCHK_MAC_AUTO,   m_fAuto);
	DDX_Check  (pDX, IDCCHK_MAC_UNZIP,  m_fUnzip);
	DDX_Check  (pDX, IDCCHK_AUTOOPEN,   m_fAutoOpen);
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate)
		OnLstSelChange();
}


// Initialisation
BOOL CDlgMacroEditer::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	// Affecter les icnes aux boutons
	m_lstBouton.SetIcons();
	
	// Remplir la liste des actions
	POS pos = GetPosDeb();
	while (pos) {
		AddItem(pos, false);
		pos = GetPosSuiv(pos);
	}
	OnLstSelChange();
	
	return TRUE;
}


// Ajoute dans la liste l'item correspondant  une action
void CDlgMacroEditer::AddItem(POS pos, bool fSel)
{
	const CMacAction *const pact = (*this)[pos];
	
	// Formatter le texte de l'item
	CString sItem;
	pact->GetItem(sItem);
	
	// Ajouter et slectionner l'item
	const int nItem = m_lstAction.AddString(sItem);
	m_lstAction.SetItemDataPtr(nItem, pos);
	if (fSel)
		m_lstAction.SetCurSel(nItem);
}


// Liste - slection modifie
void CDlgMacroEditer::OnLstSelChange()
{
	m_lstBouton.OnLstSelChange(false);
}


// Ajouter
void CDlgMacroEditer::OnAjouter()
{
	CDlgMacroAction dlgAction(this);
	if (dlgAction.DoModal()==IDCANCEL)
		return;
	
	// Ajouter la nouvelle action
	CMacAction *const pact = new CMacAction(this);
	*pact = dlgAction;
	AddFin(pact);
	AddItem(GetPosFin());
	OnLstSelChange();
}


// diter
void CDlgMacroEditer::OnEditer()
{
	const int sel = m_lstAction.GetCurSel();
	const POS pos = (POS)m_lstAction.GetItemDataPtr(sel);
	
	// diter l'action
	if ((*this)[pos]->Editer(false)) {
		m_lstAction.DeleteString(sel);
		AddItem(pos);
	}
}


// Supprimer
void CDlgMacroEditer::OnSupprimer()
{
	const int sel = m_lstAction.GetCurSel();
	DeleteAt((POS)m_lstAction.GetItemDataPtr(sel));
	m_lstAction.DeleteString(sel);
	OnLstSelChange();
}


// OK
void CDlgMacroEditer::OnOK()
{
	if (!UpdateData())
		return;
	
	// Compter les points d'entre
	// et les lister en mme temps dans sEntryPoint,
	// spars par des retour  la ligne
	CString sEntryPoint;
	UINT nbEntryPoint = 0;
	POS pos = GetPosDeb();
	while (pos) {
		CMacAction *const pact = GetSuiv(pos);
		
		if (pact->m_fEntryPoint) {
			nbEntryPoint++;
			
			CString sAction;
			pact->GetItem(sAction);
			sEntryPoint += sAction;
			sEntryPoint += '\n';
		}
	}
	
	if (nbEntryPoint > 1) {
		// Plusieurs points d'entre: demander confirmation
		
		AfxFormatString1(e_sMsg, WAR_ENTRYPOINT, sEntryPoint);
		if (!CDlgConfirm::GetReponse(mcfMacroEntryPoint))
			return;
	}
	
	
	EndDialog(IDOK);
}
