// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgMdp.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgMdp.h"

#include "Reg.h"

#include "dlgProgress.h"


const LPTSTR eszGeneralMdpCacher = _T("MdpCacher");


BEGIN_MESSAGE_MAP(CDlgMdp, CDialog)
	//{{AFX_MSG_MAP(CDlgMdp)
	ON_BN_CLICKED(IDCCHK_MASQUER, OnChkMasquer)
	ON_EN_CHANGE (IDCTXT_MDP,     OnTxtChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgMdp::CDlgMdp(CString& sMdp, bool fFautMDP, CWnd* pParent)
	: CDialog(IDD, pParent), m_sMdpRet(sMdp), m_fFautMDP(fFautMDP)
{
	//{{AFX_DATA_INIT(CDlgMdp)
	m_sMdp = m_sMdpRet;
	//}}AFX_DATA_INIT
	m_fMasquer = ToBool(oApp.GetProfileInt(kszGeneral, eszGeneralMdpCacher, true));
}


// Contrles
void CDlgMdp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgMdp)
	DDX_Control (pDX, IDCTXT_MDP,     m_txtMdp);
	DDX_Text    (pDX, IDCTXT_MDP,     m_sMdp);
	DDV_MaxChars(pDX,                 m_sMdp, 100);
	DDX_Control (pDX, IDCCHK_MASQUER, m_chkMasquer);
	DDX_Check   (pDX, IDCCHK_MASQUER, m_fMasquer);
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate) {
		OnTxtChange();
		OnChkMasquer();
	}
}


// OK
void CDlgMdp::OnOK()
{
	if (!UpdateData())
		return;
	
	m_sMdpRet = m_sMdp;
	oApp.WriteProfileInt(kszGeneral, eszGeneralMdpCacher, m_fMasquer);
	
	EndDialog(IDOK);
}


// Masquer
void CDlgMdp::OnChkMasquer()
{
	m_txtMdp.SetPasswordChar((m_chkMasquer.GetCheck()) ? '*' : '\0');
	m_txtMdp.RedrawWindow();
}


// Mot de passe - Changement
void CDlgMdp::OnTxtChange()
{
	if (m_fFautMDP)
		GetDlgItem(IDOK)->EnableWindow(m_txtMdp.GetWindowTextLength()!=0);
}
