// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgPlusItem.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgPlusItem.h"

#include "dlgArchivePlus.h"
#include "dlgRech.h"
#include "dlgMdp.h"

#include "MuzipArc.h"
#include "Fichier.h"


BEGIN_MESSAGE_MAP(CDlgPlusItem, CDialogAide)
	//{{AFX_MSG_MAP(CDlgPlusItem)
	ON_CBN_SELCHANGE(IDCCBO_ACTION,         OnActionSelChange)
	ON_COMMAND      (IDCCMD_DEFAUT_CHARGER, OnDefautCharger)
	ON_COMMAND      (IDCCMD_DEFAUT_SAUVER,  OnDefautSauver)
	ON_COMMAND      (IDCCMD_SPEC,           OnSpec)
	ON_COMMAND      (IDCCMD_FILTRE,         OnFiltre)
	ON_COMMAND      (IDCCMD_MDP,            OnMdp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgPlusItem::CDlgPlusItem(CMuzipArc* pArc, LPCTSTR pszArchive,
	bool fPeutSpec, CString& rsMdp)
	: CDialogAide(IDD),
	  m_pArc      (pArc),
	  m_pszArchive(pszArchive),
	  m_fPeutSpec (fPeutSpec),
	  m_rsMdp     (rsMdp)
{
	if (m_pArc)
		m_pszArchive = m_pArc->GetPath();
	
	m_pdlgArchivePlus = NULL;
	
	//{{AFX_DATA_INIT(CDlgPlusItem)
	//}}AFX_DATA_INIT
}


// Contrles
void CDlgPlusItem::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgPlusItem)
	DDX_CBIndex(pDX, IDCCBO_ACTION,            CO_nAction);
	DDX_CBIndex(pDX, IDCCBO_NIVEAU,            CO_nNiveau);
	DDX_Check  (pDX, IDCCHK_SOUS,              OP_fSous);
	DDX_Check  (pDX, IDCCHK_FILTRE_QUENOUVEAU, CO_fQueNouveau);
	DDX_Check  (pDX, IDCCHK_FILTRE_CACHE,      OP_fCache);
	DDX_Check  (pDX, IDCCHK_ACTION_DEPLACER,   CO_fActionDeplacer);
	DDX_Check  (pDX, IDCCHK_ACTION_NOMCOURT,   CO_fActionNomCourt);
	DDX_Check  (pDX, IDCCHK_ARCHIVE_MOINS,     CO_fArchiveMoins);
	DDX_Check  (pDX, IDCCHK_ARCHIVE_QUE,       CO_fArchiveQue);
	DDX_CBIndex(pDX, IDCCBO_ARBO,              CO_nArbo);
	//}}AFX_DATA_MAP
}


// Initialisation
BOOL CDlgPlusItem::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	OnActionSelChange();
	
	// Interdire ventuellement:
	// - modification de spcification
	// - slection du niveau de compression
	// - mot de passe
	if (!m_fPeutSpec)
		GetDlgItem(IDCCMD_SPEC)->ShowWindow(SW_HIDE);
	if (m_pArc) {
		// Faire attention car m_pArc est nul si c'est pour un script
		const int cap = m_pArc->GetCap();
		if (!(cap & capNiveau))  GetDlgItem(IDCCBO_NIVEAU)->EnableWindow(FALSE);
		if (!(cap & capCrypte))  GetDlgItem(IDCCMD_MDP)   ->EnableWindow(FALSE);
	}
	
	return TRUE;
}


// Annuler
void CDlgPlusItem::OnCancel()
{
	// Empcher la fermeture de la bote de dialogue
	// si on est dans CDlgArchivePlus
	if (!m_pdlgArchivePlus)
		CDialogAide::OnCancel();
}


// Activer ou dsactiver la totalit de la bote de dialogue,
// sauf le bouton "Mot de passe" qui est indpendant du CPlusItem
// Utilis par CDlgArchivePlus lorsqu'aucune action n'est slectionne
void CDlgPlusItem::SetEnabled(bool fEnabled)
{
	for (CWnd *pwndChild=GetTopWindow(); pwndChild; pwndChild=pwndChild->GetNextWindow())
		if (pwndChild->GetDlgCtrlID()!=IDCCMD_MDP)
			pwndChild->EnableWindow(fEnabled);
}


// Action - slection
void CDlgPlusItem::OnActionSelChange()
{
	// Les rglages relatifs  la compression sont indisponibles
	// pour les actions ngatives ("ne pas compresser" et "exclure de la recherche")
	CO_nAction = ((CComboBox*)GetDlgItem(IDCCBO_ACTION))->GetCurSel();
	const bool fEnabled = CO_nAction < coaPasComp;
	const UINT aid[] =
	{
		IDCCHK_ACTION_DEPLACER,
		IDCCHK_ACTION_NOMCOURT,
		IDCCBO_ARBO,
		IDCCBO_NIVEAU,
		0
	};
	for (int i=0; aid[i]; i++)
		GetDlgItem(aid[i])->EnableWindow(fEnabled);
	
	// Mettre  jour CDlgArchivePlus ( cause de l'icne)
	if (m_pdlgArchivePlus)
		m_pdlgArchivePlus->OnCurItemChanged(false);
}


// Charger les paramtres par dfaut
void CDlgPlusItem::OnDefautCharger()
{
	(FILTREOPTIONS&)*this = (FILTREOPTIONS&)oApp.m_pi;
	(PLUSOPTIONS&)  *this = (PLUSOPTIONS&)  oApp.m_pi;
	UpdateData(FALSE);
}

// Sauver les paramtres par dfaut
void CDlgPlusItem::OnDefautSauver()
{
	if (UpdateData()) {
		(FILTREOPTIONS&)oApp.m_pi = (FILTREOPTIONS&)*this;
		(PLUSOPTIONS&)  oApp.m_pi = (PLUSOPTIONS&)  *this;
	}
}


// Modifier la slection de fichiers
void CDlgPlusItem::OnSpec()
{
	DemanderSpec(m_pszArchive);
	
	// Mettre  jour CDlgArchivePlus ( cause de la spcification)
	if (m_pdlgArchivePlus)
		m_pdlgArchivePlus->OnCurItemChanged(true);
}

// Filtre avanc
void CDlgPlusItem::OnFiltre()
{
	CDlgRech(false, *this, this).DoModal();
}


// Mot de passe
void CDlgPlusItem::OnMdp()
{
	CDlgMdp(m_rsMdp, false, this).DoModal();
}
