// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgProgress.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgProgress.h"

#include "Options.h"
#include "dlgConfirm.h"


BEGIN_MESSAGE_MAP(CDlgProgress, CDialog)
	//{{AFX_MSG_MAP(CDlgProgress)
	ON_COMMAND(IDCCMD_IGNORER, OnIgnorer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgProgress::CDlgProgress() : CDialog(IDD, NULL)
{
	m_prs = prsOK;
	m_f2  = true;
	
	//{{AFX_DATA_INIT(CDlgProgress)
	//}}AFX_DATA_INIT
}


// Contrles
void CDlgProgress::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgProgress)
	DDX_Control(pDX, IDCPRG_1,       m_prg[0]);
	DDX_Control(pDX, IDCPRG_2,       m_prg[1]);
	DDX_Control(pDX, IDCCMD_IGNORER, m_cmdIgnorer);
	DDX_Control(pDX, IDCANCEL,       m_cmdAnnuler);
	//}}AFX_DATA_MAP
}


// Ignorer
void CDlgProgress::OnIgnorer()
{
	if (m_prs==prsOK && CDlgConfirm::GetReponse(mcfIgnorer, DEM_IGNORER))
		m_prs = prsIgnorer;
}

// Annuler
void CDlgProgress::OnCancel()
{
	if (m_prs==prsOK)
		m_prs = prsAnnuler;
}


// Timer
void CDlgProgress::OnTimer(UINT nIDEvent)
{
	if (nIDEvent!=idTimerDlgProgress) {
		// Ce n'est pas notre timer
		
		CDialog::OnTimer(nIDEvent);
		return;
	}
	
	
	// Centrer et afficher la fentre et forcer son redessin
	// On doit faire attention: si une bote de dialogue est affiche,
	// il ne faut pas mettre la fentre de progression au premier plan
	// car c'est assez perturbant pour l'utilisateur de voir surgir
	// une fentre  l'improviste
	
	// - Centrer
	CenterWindow();
	
	// - Afficher
	CWnd *const pwndDialog = oApp.m_pMainWnd->GetLastActivePopup();
	if (!pwndDialog)
		// Pas de bote de dialogue:
		// afficher la fentre de progression au premier plan,
		// et la rendre active
		
		ShowWindow(SW_SHOW);
	
	else{
		// Il y a une bote de dialogue, elle doit rester au premier plan
		// Mais SetWindowPos(&wndBottom, ...) masque compltement notre application
		// Afficher la fentre de progression sans l'activer
		// puis passer la bote de dialogue au premier plan
		
		SetWindowPos(NULL, 0,0, 0,0,
			SWP_SHOWWINDOW | SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE);
		pwndDialog->BringWindowToTop();
	}
	
	// - Redessiner
	RedrawWindow();
	
	// On n'a plus besoin du timer car maintenant la fentre est visible
	KillTimer(idTimerDlgProgress);
}
