// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgProprietes.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "dlgProprietes.h"

#include "MuzipArc.h"
#include "Dossier.h"
#include "Fichier.h"

#include <afxPriv.h>


const UINT buf = 128;

static void FormatSize(LONGLONG ddwTaille, LPTSTR psz);


#if 0
BEGIN_MESSAGE_MAP(CDlgProprietes, CDialog)
	//{{AFX_MSG_MAP(CDlgProprietes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif


// Contrles
void CDlgProprietes::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	if (m_pFichier || m_pDossier) {
		DDX_TempsDHS(pDX, IDCTXT_MODIFJ, m_dtModif);
		DDV_TempsDHS(pDX, IDCTXT_MODIFJ, m_dtModif);
	}
	
	//{{AFX_DATA_MAP(CDlgProprietes)
	DDX_Check   (pDX, IDCCHK_ATTR_R, m_fAttrR);
	DDX_Check   (pDX, IDCCHK_ATTR_H, m_fAttrH);
	DDX_Check   (pDX, IDCCHK_ATTR_S, m_fAttrS);
	DDX_Check   (pDX, IDCCHK_ATTR_A, m_fAttrA);
	//}}AFX_DATA_MAP
}


// Affichage
int CDlgProprietes::DoModal()
{
	if (m_pDossier)
		m_pDossier->ListerFichier(m_lstFichier);
	
	m_pFichier = (!m_pDossier && m_lstFichier.GetNb()==1)
		? m_lstFichier.GetDeb() : NULL;
	
	const DWORD dwAttr = (m_pFichier) ? m_pFichier->m_dwAttr : 0;
	m_fAttrR = ToBool(dwAttr & FILE_ATTRIBUTE_READONLY);
	m_fAttrH = ToBool(dwAttr & FILE_ATTRIBUTE_HIDDEN);
	m_fAttrA = ToBool(dwAttr & FILE_ATTRIBUTE_ARCHIVE);
	m_fAttrS = ToBool(dwAttr & FILE_ATTRIBUTE_SYSTEM);
	
	if (m_pFichier)
		m_dtModif = m_pFichier->m_dtM;
	else if (m_pDossier)
		m_dtModif = m_pDossier->m_dtM;
	
	return CDialog::DoModal();
}


// Initialisation
BOOL CDlgProprietes::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	TCHAR psz[buf];
	
	LPCTSTR pszSel;
	
	const CFichier *const pFichier = (m_pDossier) ? NULL : m_lstFichier.GetDeb();
	CMuzipArc *pArc = (m_lstFichier.GetNb())
		? m_lstFichier.GetDeb()->m_pArc
		: m_pDossier->m_pArc;
	
	const bool fLectureSeule = pArc->IsLectureSeule() || (m_pDossier==pArc);
	
	if (m_pFichier) {
		// Un seul fichier slectionn
		
		// Nom
		SetDlgItemText(IDCLBL_NOM, m_pFichier->m_pszNom);
		
		// Type
		SHFILEINFO shfi;
		SHGetFileInfo(m_pFichier->m_pszNom, FILE_ATTRIBUTE_NORMAL,
			&shfi, sizeof(shfi), SHGFI_USEFILEATTRIBUTES | SHGFI_TYPENAME);
		SetDlgItemText(IDCLBL_TYPE, shfi.szTypeName);
		
	}else{
		// Plusieurs fichiers slectionns
		
		CString s;
		if (m_pDossier) {
			// Dossier
			
			SetDlgItemText(IDCLBL_NOM,   m_pDossier->m_pszNom);
			
			s.Format(IDS_FMTDOSSIER, m_pDossier->GetNbDossier(), m_lstFichier.GetNb());
			SetDlgItemText(IDCLBL_TYPE,  s);
			
			GetDlgItem(IDCLBL_LBLTYPE) ->ShowWindow(SW_HIDE);
			
		}else{
			// Fichiers
			
			s.Format(IDS_FMTFICHIER, m_lstFichier.GetNb());
			
			SetDlgItemText(IDCLBL_NOM,   s);
			GetDlgItem(IDCLBL_LBLNOM)  ->ShowWindow(SW_HIDE);
			
			GetDlgItem(IDCLBL_TYPE)    ->ShowWindow(SW_HIDE);
		}
	}
	
	// Dsactiver le bouton OK si ncessaire
	if (fLectureSeule)
		GetDlgItem(IDOK)->EnableWindow(FALSE);
	
	// Date de modification
	if (fLectureSeule)
		// Dsactiver
		for (int i=IDCTXT_MODIFJ; i<=IDCLBL_MODIFMS; i++)
			GetDlgItem(i)->EnableWindow(FALSE);
	
	// Attributs
	if (!m_pFichier || !(m_pFichier->m_pArc->GetCap() & capAttribut)) {
		// Masquer
		GetDlgItem(IDCLBL_LBLATTR)->ShowWindow(SW_HIDE);
		for (int i=IDCCHK_ATTR_R; i<=IDCCHK_ATTR_S; i++)
			GetDlgItem(i)->ShowWindow(SW_HIDE);
	}else if (fLectureSeule)
		// Dsactiver
		for (int i=IDCCHK_ATTR_R; i<=IDCCHK_ATTR_S; i++)
			GetDlgItem(i)->EnableWindow(FALSE);
	
	
	pszSel = (pFichier)
		? pFichier->m_pDossier->m_pszPath
		:           m_pDossier->m_pszPath;
	if (!*pszSel) {
		AfxLoadString(IDS_RACINE, psz, buf);
		pszSel = psz;
	}
	SetDlgItemText(IDCLBL_PATH, pszSel);
	
	// Faire la moyenne ou la somme des proprits de chaque fichier
	LONGLONG ddwTailleC = 0;
	LONGLONG ddwTailleN = 0;
	POS pos = m_lstFichier.GetPosDeb();
	while (pos) {
		const CFichier *const pFichier = m_lstFichier.GetSuiv(pos);
		ddwTailleC += pFichier->m_dwTailleC;
		ddwTailleN += pFichier->m_dwTailleN;
	}
	
	// Taille
	FormatSize(ddwTailleN, psz);
	SetDlgItemText(IDCLBL_TAILLE, psz);
	
	// Compress
	FormatSize(ddwTailleC, psz);
	SetDlgItemText(IDCLBL_COMP, psz);
	
	// %
	int nPC = 100;
	if (ddwTailleN)
		nPC -= (int)(ddwTailleC*100/ddwTailleN);
	wsprintf(psz, _T("%d %%"), nPC);
	SetDlgItemText(IDCLBL_PC, psz);
	
	return TRUE;
}


// OK
void CDlgProprietes::OnOK()
{
	if (!UpdateData())
		return;
	
	if (m_pFichier) {
		
		// Modifier le fichier
		// Convertir les attributs
		DWORD dwAttr = 0;
		if (m_fAttrR)  dwAttr |= FILE_ATTRIBUTE_READONLY;
		if (m_fAttrH)  dwAttr |= FILE_ATTRIBUTE_HIDDEN;
		if (m_fAttrA)  dwAttr |= FILE_ATTRIBUTE_ARCHIVE;
		if (m_fAttrS)  dwAttr |= FILE_ATTRIBUTE_SYSTEM;
		
		m_pFichier->SetProp(dwAttr, m_dtModif);
		
	}else if (m_pDossier)
		m_pDossier->m_dtM = m_dtModif;
	
	EndDialog(IDOK);
}


// Formatter une taille
void FormatSize(LONGLONG ddwTaille, LPTSTR psz)
{
	WCHAR osz[buf], oszUnite[32];
	
	// Rcuprer l'unit des octets
	const LONGLONG ddwPetit = (ddwTaille>1) ? 2 : 1;
	StrFormatByteSizeW(ddwPetit, oszUnite, nbArray(oszUnite));
	
	//*** Formatter la taille en octets
	
	// Formatter le nombre
	TCHAR pszNombre[64], pszNombreTemp[64];
	wsprintf(pszNombreTemp, _T("%lu"), (DWORD)ddwTaille);
	
	// Rcuprer le sparateur des milliers
	TCHAR pszSep[3], pszGroup[16];
	GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_STHOUSAND, pszSep,   nbArray(pszSep));
	GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SGROUPING, pszGroup, nbArray(pszGroup));
	
	// Composer le format
	NUMBERFMT fmt;
	fmt.NumDigits     = 0;
	fmt.LeadingZero   = TRUE;
	fmt.Grouping      = _tcstoul(pszGroup, NULL, 10);
	fmt.lpDecimalSep  = _T("");
	fmt.lpThousandSep = pszSep;
	fmt.NegativeOrder = 1;
	
	// Formatter le nombre (ouf...)
	GetNumberFormat(LOCALE_USER_DEFAULT, 0,
		pszNombreTemp, &fmt, pszNombre, nbArray(pszNombre));
	
	
	// Former le texte final
	StrFormatByteSizeW(ddwTaille, osz, buf);
	wsprintf(psz, _T("%ls (%s %ls)"), osz, pszNombre, oszUnite+2);
}
