// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgRecomp.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgRecomp.h"

#include "MuzipArc.h"

#include "dlgMdp.h"


BEGIN_MESSAGE_MAP(CDlgRecomp, CDialogAide)
	//{{AFX_MSG_MAP(CDlgRecomp)
	ON_COMMAND(IDCCMD_MDP_1, OnMdp1)
	ON_COMMAND(IDCCMD_MDP_2, OnMdp2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgRecomp::CDlgRecomp(CMuzipArc* pArc, CString& sMdp1, CString& sMdp2, CWnd* pParent)
	: CDialogAide(IDD, pParent), m_pArc(pArc), m_sMdp1(sMdp1), m_sMdp2(sMdp2)
{
	//{{AFX_DATA_INIT(CDlgRecomp)
	//}}AFX_DATA_INIT
	
	m_nNiveau = oApp.m_pi.CO_nNiveau;
}


// Contrles
void CDlgRecomp::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgRecomp)
	DDX_CBIndex(pDX, IDCCBO_NIVEAU, m_nNiveau);
	//}}AFX_DATA_MAP
}


// Initialisation
BOOL CDlgRecomp::OnInitDialog()
{
	CDialogAide::OnInitDialog();
	
	// Activer et dsactiver certaines options
	// selon les capacits du format de l'archive
	const int cap = m_pArc->GetCap();
	
	if (!(cap & capNiveau))
		GetDlgItem(IDCCBO_NIVEAU)->EnableWindow(FALSE);
	
	if (!(cap & capCrypte)) {
		GetDlgItem(IDCCMD_MDP_1)->EnableWindow(FALSE);
		GetDlgItem(IDCCMD_MDP_2)->EnableWindow(FALSE);
	}
	
	return TRUE;
}


// Ancien mot de passe
void CDlgRecomp::OnMdp1()
{
	CDlgMdp(m_sMdp1, false, this).DoModal();
}


// Nouveau mot de passe
void CDlgRecomp::OnMdp2()
{
	CDlgMdp(m_sMdp2, false, this).DoModal();
}
