// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgResRech.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "dlgResRech.h"

#include "MuzipArc.h"
#include "MuzipView.h"


CDlgResRech *e_pdlgResRech = NULL;


BEGIN_MESSAGE_MAP(CDlgResRech, CDialog)
	//{{AFX_MSG_MAP(CDlgResRech)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_NOTIFY(LVN_ITEMCHANGED, IDCLST, OnLstItemChanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Indicateurs sur la barre d'tat
static const UINT s_StatusBar[] =
{
	ID_INDICATOR_SEL,
	ID_INDICATOR_TOTAL,
};


// Constructeur
CDlgResRech::CDlgResRech() : m_hAccelTable(NULL)
{
	//{{AFX_DATA_INIT(CDlgResRech)
	//}}AFX_DATA_INIT
}


// Attacher une archive
void CDlgResRech::AttachArc(CMuzipArc* pArc)
{
	m_pArc = pArc;
	m_lst.AttachArc(m_pArc);
	
	// Forcer WM_SIZE
	CRect rc;
	GetWindowRect(rc);
	rc.left--;
	MoveWindow(rc, FALSE);
	rc.left++;
	MoveWindow(rc);
}


// Contrles
void CDlgResRech::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgResRech)
	DDX_Control(pDX, IDCLST, m_lst);
	//}}AFX_DATA_MAP
}


// Cration
int CDlgResRech::OnCreate(CREATESTRUCT* pcs)
{
	if (CDialog::OnCreate(pcs)==-1)
		return -1;
	
	if (!m_stb.CreateEx(this) ||
	    !m_stb.SetIndicators(s_StatusBar, nbArray(s_StatusBar)))
		return -1;
	
	m_hAccelTable = ::LoadAccelerators(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MUZIPTYPE));
	
	return 0;
}

// Initialisation
BOOL CDlgResRech::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Dfinir l'icne
	SetIcon(oApp.LoadIcon(IDI_RESRECH), TRUE);
	
	// Initialiser la liste
	CLstMuzip::InitListCtrl(m_lst);
	m_lst.Init(3);
	
	return TRUE;
}


// Aprs destruction
void CDlgResRech::PostNcDestroy()
{
	CDialog::PostNcDestroy();
	
	e_pdlgResRech = NULL;
	delete this;
}


// Redimensionnement
void CDlgResRech::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	
	const int cyStb = m_stb.CalcFixedLayout(FALSE, TRUE).cy;
	m_stb.MoveWindow(0,cy-cyStb, cx,cyStb);
	if (m_lst)
		m_lst.MoveWindow(0,0, cx,cy-cyStb);
}

// Fermeture
void CDlgResRech::OnClose()
{
	DestroyWindow();
}


// Slection modifie dans la liste
void CDlgResRech::OnLstItemChanged(NMHDR*, LRESULT*)
{
	MAJStatusBar();
}


// Mettre  jour la barre d'tat
void CDlgResRech::MAJStatusBar()
{
	for (int i=0; i<nbArray(s_StatusBar); i++)
		m_stb.SetPaneText(
			m_stb.CommandToIndex(s_StatusBar[i]),
				m_lst.OnUpdateIndicatorEtat(s_StatusBar[i]));
}


// Traitement des raccourcis clavier
BOOL CDlgResRech::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message>=WM_KEYFIRST && pMsg->message<=WM_KEYLAST &&
	    m_hAccelTable && ::TranslateAccelerator(m_lst, m_hAccelTable, pMsg))
		return TRUE;
	
	return CDialog::PreTranslateMessage(pMsg);
}
