// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// dlgSimil.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "dlgSimil.h"

#include "ScriptDoc.h"


BEGIN_MESSAGE_MAP(CDlgSimil, CDialogAide)
	//{{AFX_MSG_MAP(CDlgSimil)
	ON_EN_CHANGE(IDCTXT_MAX, OnMaxChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CDlgSimil::CDlgSimil(CScriptDoc* pDoc) : CDialogAide(IDD), m_pDoc(pDoc)
{
	//{{AFX_DATA_INIT(CDlgSimil)
	//}}AFX_DATA_INIT
	
	m_fMsg = m_pDoc->m_fSimilMsg;
	m_simt = m_pDoc->m_simt;
}

// Contrles
void CDlgSimil::DoDataExchange(CDataExchange* pDX)
{
	CDialogAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDlgSimil)
	DDX_Control(pDX, IDCSPN_MAX,    m_spnMax);
	DDX_Check  (pDX, IDCCHK_MSG,    m_fMsg);
	DDX_Radio  (pDX, IDCOPT_TYPE_0, m_simt);
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate) {
		
		// Donnes
		SetDlgItemInt(IDCTXT_MAX, m_pDoc->m_uMaxSimil, FALSE);
		OnMaxChange();
		
		// Plage de valeurs du spinner
		m_spnMax.SetRange(0, 10);
	}
}


// Nombre maximal d'archive similaires
void CDlgSimil::OnMaxChange()
{
	InfiniRemplaceZero(this, IDCTXT_MAX);
}


// OK
void CDlgSimil::OnOK()
{
	if (!UpdateData())
		return;
	
	// Sauver les modifications dans le CScriptDoc
	m_pDoc->m_uMaxSimil = GetDlgItemInt(IDCTXT_MAX, NULL, FALSE);
	m_pDoc->m_fSimilMsg = m_fMsg;
	m_pDoc->m_simt      = m_simt;
	m_pDoc->SetModifiedFlag();
	
	EndDialog(IDOK);
}
