// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// pgOptionsDossiers.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "pgOptionsDossiers.h"

#include "dlgParcourir.h"
#include "Options.h"


BEGIN_MESSAGE_MAP(CPgOptionsDossiers, CPropertyPageAide)
	//{{AFX_MSG_MAP(CPgOptionsDossiers)
	ON_CBN_SELCHANGE(IDCCBO_DOSSIER, OnDossierSelChange)
	ON_EN_CHANGE    (IDCTXT_PERSO,   OnTxtPerso)
	ON_COMMAND      (IDCCMD_PERSO,   OnPerso)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CPgOptionsDossiers::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPageAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CPgOptionsDossiers)
	DDX_Control(pDX, IDCCBO_DOSSIER,      m_cboDossier);
	DDX_Check  (pDX, IDCCHK_NETTOYERTEMP, m_fNettoyerTemp);
	//}}AFX_DATA_MAP
	
	if (pDX->m_bSaveAndValidate && m_nDossierOld>=0) {
		// Sauver les options
		
		DOSSIER_OPTION &doo = m_aDossier[m_nDossierOld];
		doo.repo = GetCheckedRadioButton(IDCOPT_ARCHIVE,IDCOPT_PERSO) - IDCOPT_ARCHIVE;
		GetDlgItemText(IDCTXT_PERSO, doo.sPerso);
	}
}


// Initialisation
BOOL CPgOptionsDossiers::OnInitDialog()
{
	m_nDossierOld = -1;
	
	CPropertyPageAide::OnInitDialog();
	
	// Choisir le premier dossier
	m_cboDossier.SetCurSel(0);
	OnDossierSelChange();
	
	// Donner une icne au bouton Parcourir
	oApp.SetIconeParcourir(this, IDCCMD_PERSO);
	
	return TRUE;
}


// Changement de type de dossier
void CPgOptionsDossiers::OnDossierSelChange()
{
	if (!UpdateData()) {
		m_cboDossier.SetCurSel(m_nDossierOld);
		return;
	}
	
	// Afficher les options du nouveau dossier
	
	m_nDossierOld = m_cboDossier.GetCurSel();
	const bool fUtilisateurPeutModifier = (m_nDossierOld!=repTemp);
	
	// Activer ou dsactiver les cases d'options rserves aux dossiers
	// modifiables par l'utilisateur
	GetDlgItem(IDCOPT_ARCHIVE)->EnableWindow(fUtilisateurPeutModifier);
	GetDlgItem(IDCOPT_DERNIER)->EnableWindow(fUtilisateurPeutModifier);
	
	// Affecter les options aux contrles
	DOSSIER_OPTION &doo = m_aDossier[m_nDossierOld];
	SetDlgItemText(IDCTXT_PERSO, doo.sPerso);
	CheckRadioButton(IDCOPT_ARCHIVE,IDCOPT_PERSO, IDCOPT_ARCHIVE+doo.repo);
}


// Changement manuel du dossier personnalis:
// cocher automatiquement l'option "Personnalis"
void CPgOptionsDossiers::OnTxtPerso()
{
	CheckRadioButton(IDCOPT_ARCHIVE,IDCOPT_PERSO, IDCOPT_PERSO);
}


// Bouton Parcourir
void CPgOptionsDossiers::OnPerso()
{
	// Rcuprer le chemin d'accs courant
	CString sDossier;
	GetDlgItemText(IDCTXT_PERSO, sDossier);
	
	// Demander le chemin d'accs  l'utilisateur
	if (CDlgParcourir(sDossier, this).DoModal()==IDOK) {
		SetDlgItemText(IDCTXT_PERSO, sDossier);
		OnTxtPerso();
	}
}
