// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// pgOptionsGeneral.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "pgOptionsGeneral.h"


BEGIN_MESSAGE_MAP(CPgOptionsGeneral, CPropertyPageAide)
	//{{AFX_MSG_MAP(CPgOptionsGeneral)
	ON_CBN_SELCHANGE(IDCCBO_FORMAT, OnFormatSelChange)
	ON_CBN_SELCHANGE(IDCCBO_EXT, OnExtSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CPgOptionsGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPageAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CPgOptionsGeneral)
	DDX_Control(pDX, IDCSPN_MRU,              m_spnMRU);
	DDX_Check  (pDX, IDCCHK_OUVRIRAUTO,       m_fOuvrirAuto);
	DDX_Check  (pDX, IDCCHK_ASSOCVERIFAUTO,   m_fAssocVerifAuto);
	DDX_Check  (pDX, IDCCHK_COMMENTAIRE,      m_fCommentaire);
	DDX_Check  (pDX, IDCCHK_CORBEILLE,        m_fCorbeille);
	DDX_Check  (pDX, IDCCHK_TJVISIBLE,        m_fTjVisible);
	DDX_Check  (pDX, IDCCHK_SUPPRDOSSIERVIDE, m_fSupprDossierVide);
	DDX_Text   (pDX, IDCTXT_MRU,              m_nMRU);
	DDX_Control(pDX, IDCCBO_FORMAT,           m_cboFormat);
	DDX_Control(pDX, IDCCBO_EXT,              m_cboExt);
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate && m_cboFormat.GetCount()>0) {
		m_cboFormat.SetCurSel(0);
		OnFormatSelChange();
	}
}


// Initialisation
BOOL CPgOptionsGeneral::OnInitDialog()
{
	CPropertyPageAide::OnInitDialog();
	
	// Initialiser le spinner
	m_spnMRU.SetRange(0, 10);
	
	// Remplir la liste des types d'archives
	POS pos = m_lstExtDefaut.GetPosDeb();
	while (pos) {
		EXTDEFAUT &ed = m_lstExtDefaut.GetSuiv(pos);
		CDocType &dt = *ed.pdt;
		
		// Ajouter le format
		CString sFormat;
		dt.GetDocString(sFormat, CDocTemplate::regFileTypeName);
		m_cboFormat.SetItemDataPtr(m_cboFormat.AddString(sFormat), &ed);
	}
	
	
	// Remettre  jour la bote de dialogue maintenant que la liste est pleine
	UpdateData(FALSE);
	
	return TRUE;
}


// Changement de format
void CPgOptionsGeneral::OnFormatSelChange()
{
	EXTDEFAUT &ed =
		*(EXTDEFAUT*)m_cboFormat.GetItemDataPtr(m_cboFormat.GetCurSel());
	
	CString sFilterExt;
	ed.pdt->GetDocString(sFilterExt, CDocTemplate::filterExt);
	
	// Rcuprer la liste des extensions
	m_cboExt.ResetContent();
	CTokenize tok(sFilterExt, ';');
	while (tok.Next())
		m_cboExt.AddString(tok.GetToken());
	
	// Slectionner la bonne extension
	m_cboExt.SetCurSel(ed.iExtDefaut);
}

// Changement d'extension
void CPgOptionsGeneral::OnExtSelChange()
{
	((EXTDEFAUT*)m_cboFormat.GetItemDataPtr(m_cboFormat.GetCurSel()))
		->iExtDefaut = m_cboExt.GetCurSel();
}
