// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// pgOptionsMenu.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "Muzip.h"
#include "pgOptionsMenu.h"

#include "Reg.h"
#include "dlgOptions.h"
#include "dlgAssoc.h"


enum
{
	imgOn,
	imgOff,
	imgRien,
	imgOui,
	imgNon,
};


BEGIN_MESSAGE_MAP(CPgOptionsMenu, CPropertyPageAide)
	//{{AFX_MSG_MAP(CPgOptionsMenu)
	ON_BN_CLICKED   (                  IDCCHK_MENU,     OnChkMenu)
	ON_CBN_SELCHANGE(                  IDCCBO_MENUTYPE, OnTypeSelChange)
	ON_NOTIFY       (NM_CLICK,         IDCLST_MENU,     OnLstClick)
	ON_NOTIFY       (LVN_ITEMCHANGING, IDCLST_MENU,     OnLstItemChanging)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Constructeur
CPgOptionsMenu::CPgOptionsMenu() : CPropertyPageAide(IDD)
{
	//{{AFX_DATA_INIT(CPgOptionsMenu)
	//}}AFX_DATA_INIT
	
	m_iml.Create(IDB_ONOFF, 16,0, RGB(255,255,255));
}


// Contrles
void CPgOptionsMenu::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPageAide::DoDataExchange(pDX);
	
#define LISTER(mac) \
	mac(Menu,      MENU) \
	mac(MenuIcone, MENUICONE) \
	mac(MenuSous,  MENUSOUS)
	
	#define DCL(nom,maj)  BOOL f##nom;
	LISTER(DCL)
	#undef DCL
	
	UINT nFlags = oApp.GetProfileInt(kszGeneral, eszGeneralShell, gsDefaut);
	
	if (!pDX->m_bSaveAndValidate) {
		// Rcuprer les flags dans le registre
		
		#define GET(nom,maj)  f##nom = ToBool(nFlags & gs##nom);
		LISTER(GET)
		#undef GET
	}
	
	#define DX(nom,maj)  DDX_Check(pDX, IDCCHK_##maj, f##nom);
	LISTER(DX)
	#undef DX
	//{{AFX_DATA_MAP(CPgOptionsMenu)
	DDX_Control(pDX, IDCCBO_MENUTYPE, m_cboType);
	DDX_Control(pDX, IDCLST_MENU,     m_lst);
	//}}AFX_DATA_MAP
	
	if (pDX->m_bSaveAndValidate && m_nOldType>=0) {
		// Enregistrer les flags dans le registre
		
		#define MASK(nom,maj)  | gs##nom
		nFlags &= ~(0 LISTER(MASK));
		#undef MASK
		
		#define SET(nom,maj)  if (f##nom)  nFlags |= gs##nom;
		LISTER(SET)
		#undef SET
		oApp.WriteProfileInt(kszGeneral, eszGeneralShell, nFlags);
		
		
		// Items du menu contextuel
		
		MCT_OPTION *const aMCT = MCT_OPTION::GetArray();
		MCT_OPTION &omct = aMCT[m_nOldType];
		omct.uVisible =
		omct.uDemande = 0;
		
		LVITEM lvi;
		lvi.iSubItem = 0;
		for (lvi.iItem=0;; lvi.iItem++) {
			lvi.mask      = LVIF_STATE | LVIF_IMAGE | LVIF_PARAM;
			lvi.stateMask = LVIS_STATEIMAGEMASK;
			if (!m_lst.GetItem(&lvi))
				break;
			
			if (lvi.state==INDEXTOSTATEIMAGEMASK(imgOn+1))
				omct.uVisible |= lvi.lParam;
			if (lvi.iImage==imgOui)
				omct.uDemande |= lvi.lParam;
		}
		
		oApp.WriteProfileBinary(kszGeneral, eszGeneralMCT, (BYTE*)aMCT, bufMCT);
		delete [] (BYTE*)aMCT;
		
		
	}else
		// Chargement
		
		OnChkMenu();
	
#undef LISTER
}


// Initialisation
BOOL CPgOptionsMenu::OnInitDialog()
{
	m_nOldType = -1;
	
	CPropertyPageAide::OnInitDialog();
	
	// Ajouter la seule colonne de la liste
	CRect rc;
	m_lst.GetClientRect(rc);
	m_lst.InsertColumn(0, NULL, LVCFMT_LEFT, rc.right);
	
	// Affecter les listes d'images  la liste
	m_lst.SetImageList(&m_iml, LVSIL_SMALL);
	m_lst.SetImageList(&m_iml, LVSIL_STATE);
	
	// Affecter les icnes aux labels
	for (UINT id=IDCICO_0; id<=IDCICO_4; id++)
		if (id!=IDCICO_1+1)   // Il n'y a pas de IDCICO_2 !!!
			((CStatic*)GetDlgItem(id))->SetIcon(m_iml.ExtractIcon(id-IDCICO_0));
	
	// Initialiser la liste
	m_cboType.SetCurSel(0);
	OnTypeSelChange();
	
	return TRUE;
}


// Activation
void CPgOptionsMenu::OnChkMenu()
{
	SetEnabled(this, IDCCHK_MENUICONE,IDCLST_MENU, IDCCHK_MENU);
}


// Changement de type de menu
void CPgOptionsMenu::OnTypeSelChange()
{
	// Enregistrer les paramtres courants
	UpdateData();
	
	m_nOldType = m_cboType.GetCurSel();
	
	// Lire les options
	MCT_OPTION *const aMCT = MCT_OPTION::GetArray();
	const MCT_OPTION &mcto = aMCT[m_nOldType];
	
	// Remplir la liste des options
	m_lst.DeleteAllItems();
	for (int mcc=0; mcc<=cmdFin-cmdDeb; mcc++) {
		const UINT mccMask = 1<<mcc;
		
		// L'option doit tre autorise
		if (!(auShellMenuMax[m_nOldType] & mccMask))
			continue;
		
		// Rcuprer la chane, sans le '\n' et sans l'ventuel '&'
		CString s = CStringRes(cmdDeb+mcc).SpanExcluding(_T("\n"));
		const int iPrefix = s.Find('&');
		if (iPrefix>=0)
			s.Delete(iPrefix);
		
		
		// Ajouter l'item
		LVITEM lvi;
		lvi.mask      = LVIF_STATE | LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
		lvi.iItem     = m_lst.GetItemCount();
		lvi.iSubItem  = 0;
		lvi.state     = INDEXTOSTATEIMAGEMASK(
			(mcto.uVisible & mccMask) ? imgOn+1 : imgOff+1);
		lvi.stateMask = LVIS_STATEIMAGEMASK;
		lvi.pszText   = (STRING)s;
		lvi.iImage    = (uShellMenuPeutDemander & mccMask)
			? ((mcto.uDemande & mccMask) ? imgOui : imgNon)
			: imgRien;
		lvi.lParam    = mccMask;
		m_lst.InsertItem(&lvi);
	}
	
	delete [] (BYTE*)aMCT;
}


// Clic
void CPgOptionsMenu::OnLstClick(NMHDR*, LRESULT*)
{
	// Identifier l'item cliqu
	LVHITTESTINFO lvhti;
	lvhti.pt = GetCurrentMessage()->pt;
	m_lst.ScreenToClient(&lvhti.pt);
	lvhti.iItem = m_lst.HitTest(&lvhti);
	if (lvhti.iItem<0 ||
	    !(lvhti.flags & (LVHT_ONITEMSTATEICON | LVHT_ONITEMICON)))
		return;
	
	// Rcuprer l'tat de l'item
	LVITEM lvi;
	lvi.iItem     = lvhti.iItem;
	lvi.iSubItem  = 0;
	lvi.mask      = LVIF_STATE | LVIF_IMAGE | LVIF_PARAM;
	lvi.stateMask = LVIS_STATEIMAGEMASK;
	m_lst.GetItem(&lvi);
	
	if (lvhti.flags & LVHT_ONITEMSTATEICON)
		// Activation
		lvi.state = (lvi.state==INDEXTOSTATEIMAGEMASK(imgOn+1))
			? INDEXTOSTATEIMAGEMASK(imgOff+1)
			: INDEXTOSTATEIMAGEMASK(imgOn+1);
	else if (lvi.iImage!=2)
		// Demande des options
		lvi.iImage = (lvi.iImage==imgOui) ? imgNon : imgOui;
	
	// Dslectionner l'item
	m_lst.SetItem(&lvi);
}


// Changement d'tat d'un item
void CPgOptionsMenu::OnLstItemChanging(NMHDR* pNMHDR, LRESULT* pResult)
{
	*pResult = ToBool(((const NMLISTVIEW*)pNMHDR)->uNewState & ~LVIS_STATEIMAGEMASK);
}
