// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// pgOptionsRm.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "pgOptionsRm.h"


BEGIN_MESSAGE_MAP(CPgOptionsRm, CPropertyPageAide)
	//{{AFX_MSG_MAP(CPgOptionsRm)
	ON_LBN_SELCHANGE(IDCLST_RM, OnLstSelChange)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDCCMD_HAUT, IDCCMD_BAS, OnHautBas)
END_MESSAGE_MAP()


// Contrles
void CPgOptionsRm::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPageAide::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CPgOptionsRm)
	DDX_Control  (pDX, IDCLST_RM,        m_lstRm);
	DDX_Text     (pDX, IDCTXT_TAILLEMIN, m_nTailleMin);
	DDV_MinMaxInt(pDX,                   m_nTailleMin, 0, 1024);
	//}}AFX_DATA_MAP
	
	if (!pDX->m_bSaveAndValidate) {
		// Chargement
		
		if (m_lstRm.GetCount()) {
			
			// Cocher ou dcocher les options de reconstruction manuelle
			for (int nItem=0; nItem<nbRmOption; nItem++)
				m_lstRm.SetCheck(nItem, m_aRmOption[nItem].fActive);
			
			// Mettre  jour les boutons selon la slection
			OnLstSelChange();
		}
		
	}else{
		// Enregistrement et validation
		
		// Rcuprer la liste des options de reconstruction manuelle
		for (int nItem=0; nItem<nbRmOption; nItem++) {
			m_aRmOption[nItem].rmo     = (RM_OPTION_AC)m_lstRm.GetItemData(nItem);
			m_aRmOption[nItem].fActive = ToBool(m_lstRm.GetCheck(nItem));
		}
	}
}


// Initialisation
BOOL CPgOptionsRm::OnInitDialog()
{
	CPropertyPageAide::OnInitDialog();
	
	// Lister les options de reconstruction manuelle
	CTokenize tok(IDS_RM_OPTIONS, '\n');
	while (tok.Next()) {
		const RM_OPTION_AC rmo = m_aRmOption[tok.GetIndex()].rmo;
		
		// Ajouter l'item
		VERIFY(m_lstRm.AddString(tok.GetToken())==tok.GetIndex());
		m_lstRm.SetItemData(tok.GetIndex(), rmo);
	}
	ASSERT(m_lstRm.GetCount()==nbRmOption);
	
	// Affecter les icnes aux boutons
	m_lstBouton.SetIcons();
	
	
	// Mettre  jour la liste
	UpdateData(FALSE);
	
	return TRUE;
}


// Haut/bas
void CPgOptionsRm::OnHautBas(UINT nID)
{
	m_lstBouton.OnHautBas(nID);
}

// Liste - slection modifie
void CPgOptionsRm::OnLstSelChange()
{
	m_lstBouton.OnLstSelChange(false);
}
