// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// pgOptionsShell.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "Muzip.h"
#include "pgOptionsShell.h"

#include "Reg.h"
#include "dlgOptions.h"
#include "dlgAssoc.h"


BEGIN_MESSAGE_MAP(CPgOptionsShell, CPropertyPageAide)
	//{{AFX_MSG_MAP(CPgOptionsShell)
	ON_COMMAND(IDCCMD_ASSOC,    OnAssoc)
	ON_COMMAND(IDCCMD_DESENREG, OnDesenreg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Contrles
void CPgOptionsShell::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPageAide::DoDataExchange(pDX);
	
#define LISTER(mac) \
	mac(Drop,      DROP) \
	mac(InfoBulle, INFOBULLE)
	
	#define DCL(nom,maj)  BOOL f##nom;
	LISTER(DCL)
	#undef DCL
	
	
	UINT nFlags = oApp.GetProfileInt(kszGeneral, eszGeneralShell, gsDefaut);
	
	if (!pDX->m_bSaveAndValidate) {
		// Rcuprer les flags dans le registre
		
		#define GET(nom,maj)  f##nom = ToBool(nFlags & gs##nom);
		LISTER(GET)
		#undef GET
	}
	
	#define DX(nom,maj)  DDX_Check(pDX, IDCCHK_##maj, f##nom);
	LISTER(DX)
	#undef DX
	//{{AFX_DATA_MAP(CPgOptionsShell)
	//}}AFX_DATA_MAP
	
	if (pDX->m_bSaveAndValidate) {
		// Enregistrer les flags dans le registre
		
		#define MASK(nom,maj)  | gs##nom
		nFlags &= ~(0 LISTER(MASK));
		#undef MASK
		
		#define SET(nom,maj)  if (f##nom)  nFlags |= gs##nom;
		LISTER(SET)
		#undef SET
		oApp.WriteProfileInt(kszGeneral, eszGeneralShell, nFlags);
	}
	
#undef LISTER
}


// Associations
void CPgOptionsShell::OnAssoc()
{
	bool &fRegister = ((CDlgOptions*)GetParent())->m_fRegister;
	
	if (!fRegister)
		// Renregistrer Muzip pour que si on modifie les associations
		// les icnes soient visibles sans avoir besoin de fermer
		// la bote de dialogue Options
		// (pas la DLL, cela peut se faire plus tard)
		oApp.Register();
	
	if (CDlgAssoc().DoModal()==IDOK)
		fRegister = true;
	else if (!fRegister)
		// Dsenregistrer Muzip si on a cliqu sur Annuler
		// et qu'il tait dj dsenregistr
		oApp.Unregister();
}


// Dsenregistrer Muzip
void CPgOptionsShell::OnDesenreg()
{
	// Demander confirmation
	if (AfxMessageBox(DEM_UNREGISTER, MB_YESNO | MB_DEFBUTTON2)==IDNO)  return;
	
	oApp.Unregister();
	
	((CDlgOptions*)GetParent())->m_fRegister = false;
	
	AfxMessageBox(WAR_UNREGISTER, MB_ICONINFORMATION);
}
