// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// DlgFrame.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "App.h"
#include "AppResource.h"
#include "DlgFrame.h"


IMPLEMENT_DYNCREATE(CDlgFrame, CMDIChildWnd)
BEGIN_MESSAGE_MAP(CDlgFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CDlgFrame)
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Initialiser la frame
void CDlgFrame::Init()
{
	CFormView *const pView = (CFormView*)GetActiveView();
	ASSERT_KINDOF(CFormView, pView);
	
	// Calculer les dimensions idales de la frame
	const CSize size = pView->GetTotalSize();
	CRect rc(0,0, size.cx,size.cy);
	AdjustWindowRect(rc, pView->GetStyle(), FALSE);
	
	// Masquer la bordure cliente et redimensionner la frame
	pView->ModifyStyleEx(WS_EX_CLIENTEDGE, 0);
	SetWindowPos(NULL, 0,0, rc.Width(),rc.Height(), SWP_NOZORDER | SWP_NOMOVE);
}


// Avant cration
BOOL CDlgFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// Affecter la classe normalement
	VERIF(CMDIChildWnd::PreCreateWindow(cs));
	
	// Rcuprer les informations de la classe
	// et recrer une classe spciale, sans les styles de classes
	// (enlever le redessin automatique si redimensionnement horizontal/vertical)
	WNDCLASS wc;
	GetClassInfo(pApp->m_hInstance, cs.lpszClass, &wc);
	cs.lpszClass = AfxRegisterWndClass(0,
		wc.hCursor, wc.hbrBackground, wc.hIcon);
	
	return TRUE;
}


// Tailles
void CDlgFrame::OnGetMinMaxInfo(MINMAXINFO* pmmi)
{
	const CScrollView *const pView = DYNAMIC_DOWNCAST(CScrollView, GetActiveView());
	if (pView) {
		const CSize size = pView->GetTotalSize();
		CRect rc(0,0, size.cx,size.cy);
		AdjustWindowRect(rc, GetStyle(), FALSE);
		pmmi->ptMinTrackSize.x = rc.Width();
		pmmi->ptMinTrackSize.y = rc.Height();
	}
	CMDIChildWnd::OnGetMinMaxInfo(pmmi);
}

// Taille
void CDlgFrame::OnSize(UINT nType, int cx, int cy)
{
	CMDIChildWnd::OnSize(nType, cx, cy);
	
	CView *const pView = GetActiveView();
	if (pView) {
		CWnd *const pscr = pView->GetDlgItem(IDCSCR);
		
		CRect rc;
		pView->GetClientRect(rc);
		pscr->ShowWindow((nType==SIZE_MAXIMIZED) ? SW_HIDE : SW_SHOW);
		pscr->SetWindowPos(NULL,
			rc.right  - GetSystemMetrics(SM_CXHSCROLL),
			rc.bottom - GetSystemMetrics(SM_CYHSCROLL),
			0,0, SWP_NOZORDER | SWP_NOSIZE);
	}
}
