// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// DocType.h


#ifndef _DOCTYPE_H_
#define _DOCTYPE_H_
#if _MSC_VER>1000
#pragma once
#endif


// Types de documents
class CDocType
{
	friend class CDlgOptions;
	
public:  // Fonctions
	
	CDocType() : m_iExtDefaut(0), m_pmdt(NULL) {}
	
	int  GetCap() const { return m_cap; }
	UINT GetIdType() const { return m_idType; }
	CMuzipDocTemplate* GetTemplate() const { return m_pmdt; }
	
	
	static void AddDocTypes();
	
	void AddDocTemplate();
	void AddAssocs();
	void LoadSaveOptions(bool fLoad);
	
	bool GetDocString(CString& s, int i) const;
	bool IsMultiExt() const;
	void GetExtDefaut(CString& sExt) const;
	
	CDocTemplate::Confidence
		MatchDocType(LPCTSTR pszPathName, CDocument*& rpDocMatch) const;
	
	CMuzipArc* CreateArchive(CInterf* pi) const;
	
	
protected:  // Donnes
	
	UINT           m_idType;       // Ressource du type de document
	CRuntimeClass *m_prcDoc;       // Classe du document
	int            m_iExtDefaut;   // Index de l'extension par dfaut
	
	PFN_CREATEARCHIVE m_pfnCreateArchive;   // Crer une archive
	
	CMuzipDocTemplate *m_pmdt;   // NULL possible
	
	int                m_cap;    // Capacits du format
	                             // (mme valeurs que pour CMuzipArc::GetCap)
};
typedef CListePtr2<CDocType*> CLstDocType;


#endif
