// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Exceptions.h
//
// Gestion des exceptions


#ifndef _EXCEPTIONS_H_
#define _EXCEPTIONS_H_


class CFileBuf;
class CFileRead;
class CFileWrite;


class CMuzipException : public CException
{
public:  // Fonctions
	
	CMuzipException() {}                                   // Pas d'erreur
	CMuzipException(UINT nID);                             // Message uniquement
	CMuzipException(                LPCTSTR pszFichier);   // Ouverture
	CMuzipException(UINT nID,       LPCTSTR pszFichier);   // Au choix
	CMuzipException(CFileRead&  fr);                       // Lecture
	CMuzipException(CFileWrite& fw);                       // criture
	
	BOOL GetErrorMessage(LPTSTR pszError, UINT nMaxError, UINT* pnHelpContext=NULL);
	int  ReportError(UINT nType=MB_OK, UINT nMessageID=0);
	
	
protected:  // Interne
	
	void Init(UINT nID, LPCTSTR pszFichier);
	
	
	CString m_s;      // Message  afficher
	UINT    m_nID;    // ID du message, zro si aucun
	
	union   // Fichier ayant provoqu l'erreur
	{
		void       *m_p;
		CFileRead  *m_pfr;
		CFileWrite *m_pfw;
	};
};


#endif
