// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// FileDialogEx.h
//
// Constantes pour CFileDialog


#ifndef _FILEDIALOGEX_H_
#define _FILEDIALOGEX_H_


const DWORD fdFlagsCommon = OFN_HIDEREADONLY | OFN_PATHMUSTEXIST |
                            OFN_EXPLORER | OFN_ENABLESIZING;
const DWORD fdFlagsOpen   = fdFlagsCommon | OFN_FILEMUSTEXIST;
const DWORD fdFlagsSave   = fdFlagsCommon | OFN_OVERWRITEPROMPT;


class CFileDialogEx : public CFileDialog
{
public:  // Fonctions
	
	CFileDialogEx(BOOL bOpenFileDialog,
		LPCTSTR lpszDefExt=NULL,
		LPCTSTR lpszFileName=NULL,
		DWORD dwFlags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		LPCTSTR lpszFilter=NULL,
		CWnd* pParentWnd=NULL)
		: CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName,
		dwFlags, lpszFilter, pParentWnd, 0) {}
};



// CWndFileDialogParent
//
// Aligne  droite le template d'une CFileDialog
// Cette fentre doit tre sous-classs  partir de la CFileDialog:
//
// class CMyFileDialog
// {
//   //...
//
//   CWndFileDialogParent m_wndParent;
//
//   //...
// };
//
//
// void CMyFileDialog::OnInitDone()
// {
//   // Sous-classer la fentre parent pour aligner le template  droite
//   m_wndParent.SubclassWindow(*GetParent());
// }

class CWndFileDialogParent : public CWnd
{
public:  // Donnes
	
	CWndFileDialogParent() : m_cxTemplate(-1)
		{}
	
	
	CFileDialogEx* m_pFileDialog;
	
	
protected:  // Hritage
	
	// Largeur initiale du template
	// On doit la garder la CFileDialog redimensionne le template
	int m_cxTemplate;
	
	//{{AFX_MSG(CWndFileDialogParent)
	afx_msg void OnWindowPosChanged(WINDOWPOS* pwp);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif
