// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// IOFichier.h
//
// Des fonctions utilitaires pour grer les fichiers et les dossiers
// affichant les messages d'erreurs appropris quand il y a lieu


#ifndef _IOFICHIER_H_
#define _IOFICHIER_H_


#define FILE_SHARE_ALL  (FILE_SHARE_READ | FILE_SHARE_WRITE)


bool GetPathPartieSuiv(LPCTSTR& pszPath, CString& sPart);

bool FichierCreer    (LPCTSTR pszFichier);
bool FichierEcraser  (LPCTSTR pszFichier);
bool FichierSupprimer(LPCTSTR pszFichier, bool fPeutCorbeille);
bool FichierDeplacer (LPCTSTR pszDe, LPCTSTR pszVers);

bool DossierCreer    (LPCTSTR pszDossier, bool bVerbose = true);
bool DossierSupprimer(LPCTSTR pszDossier, bool fQueVide = false);

bool NomCorriger     (LPTSTR pszNom);

bool GetFichierTemp  (LPCTSTR pszDossier, LPTSTR pszFichier);
bool GetDossierTemp  (LPCTSTR pszParent,  LPTSTR pszDossier);

bool MyGetFullPathName(LPCTSTR pszIn, LPTSTR pszOut);
CString MyPathQuoteSpacesCopy(LPCTSTR pszPath);


struct VERSION
{
	DWORD verH;
	DWORD verL;
};

bool GetInstanceVersion(HINSTANCE hInst, VERSION& ver);


class CMyFindFile
{
public:  // Fonctions
	
	CMyFindFile() : m_hff(INVALID_HANDLE_VALUE) {}
	CMyFindFile(LPCTSTR pszRech) : m_hff(INVALID_HANDLE_VALUE)
		{
			Start(pszRech);
		}
	~CMyFindFile() { Close(); }
	
	void Start(LPCTSTR pszRech);
	bool Next();
	
	void Close();
	
	bool IsError() const { return m_hff==INVALID_HANDLE_VALUE; }
	bool IsDots() const;
	
	
public:  // Donnes
	
	WIN32_FIND_DATA m_wfd;   // Informations sur le fichier trouv
	
	
protected:  // Interne
	
	HANDLE m_hff;      // Handle de ::FindFirstFile
	bool   m_fStart;   // TRUE si la recherche vient de commencer
	                   // (pas besoin d'appeler ::FindNextFile)
};


#endif
