// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// MacroDoc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "MacroDoc.h"
#include "AppResource.h"


IMPLEMENT_DYNCREATE(CMacroDoc, CDocument)
BEGIN_MESSAGE_MAP(CMacroDoc, CDocument)
	//{{AFX_MSG_MAP(CMacroDoc)
	ON_COMMAND(ID_MACRO_EDITER, OnMacroEditer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// E/S
void CMacroDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring()) {
		// Enregistrement
		
		CString s;
		m_mac.ToINI(s);
		ar.WriteString(s);
		
	}else
		// Lecture
		
		if (!m_mac.FromINI(ar.GetFile()->GetFilePath()))
			AfxThrowArchiveException(CArchiveException::badSchema);
}


// Supprimer le contenu
void CMacroDoc::DeleteContents()
{
	// Valeur par dfaut
	CIniKey ini;
	m_mac.Serialize(ini);
	
	m_mac.DeleteAll();
}


// diter la macro
void CMacroDoc::OnMacroEditer()
{
	m_mac.Editer();
}


// Changement de titre
void CMacroDoc::SetTitle(LPCTSTR pszTitle)
{
	CDocument::SetTitle(pszTitle);
	
	// Mettre  jour le nom de la macro
	m_mac.m_sName = pszTitle;
}


// Mettre  jour la vue d'aprs le document
void CMacroDoc::ToView()
{
	if (m_mac.m_fModified)
		SetModifiedFlag();
	
	UpdateAllViews(NULL, FALSE);
}
