// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// MacroView.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "AppResource.h"
#include "MacroView.h"

#include "DlgFrame.h"

#include "Options.h"
#include "IOFichier.h"


IMPLEMENT_DYNCREATE(CMacroView, CFormView)
BEGIN_MESSAGE_MAP(CMacroView, CFormView)
	//{{AFX_MSG_MAP(CMacroView)
	ON_WM_SIZE()
	ON_BN_CLICKED  (IDCCHK_MAC_EDIT, OnEdit)
	ON_EN_SETFOCUS (IDCTXT_MAC,      OnTxtSetFocus)
	ON_EN_KILLFOCUS(IDCTXT_MAC,      OnTxtKillFocus)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ID_MAC_ACTION,ID_MAC_ACTION+1000-1, OnAction)
END_MESSAGE_MAP()


// Contrles
void CMacroView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CMacroView)
	DDX_Control(pDX, IDCTXT_MAC,          m_txt);
	DDX_Control(pDX, IDCCMD_MAC_EXECUTER, m_cmdExecuter);
	//}}AFX_DATA_MAP
}


// Taille
void CMacroView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	// Redimensionner la zone de texte
	
	if (::IsWindow(m_txt)) {
		CRect rc;
		m_txt.GetWindowRect(rc);
		ScreenToClient(rc);
		rc.right  = cx - rc.left;
		rc.bottom = cy - rc.left;
		m_txt.MoveWindow(rc);
	}
}


// Initialisation
void CMacroView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	
	((CDlgFrame*)GetParent())->Init();
}


// dition directe
void CMacroView::OnEdit()
{
	m_txt.SetReadOnly(!IsDlgButtonChecked(IDCCHK_MAC_EDIT));
}


// Mise  jour
// lHint==TRUE  => copie du document dans la vue
// lHint==FALSE => copie de la vue dans le document
// On stocke le texte du fichier INI dans le document
void CMacroView::OnUpdate(CView*, LPARAM lHint, CObject*)
{
	if (lHint)
		// Sauvegarder l'tat courant dans le document
		
		OnTxtKillFocus();
		
	else{
		// Mettre  jour la vue d'aprs le document
		
		CMacro &mac = GetDocument()->m_mac;
		
		CString s;
		mac.ToINI(s);
		
		if (!lHint) {
			m_txt.SetWindowText(s);
			m_txt.SetSel(0,0);
		}
		
		// Recrer le menu des squences et l'affecter au bouton
		m_mnuContext.DestroyMenu();
		m_mnuContext.LoadMenu(IDM_CONTEXT);
		m_mnuAction.Detach();
		m_mnuAction.Attach(::GetSubMenu(m_mnuContext, 5));
		
		UINT id = ID_MAC_ACTION;
		POS pos = mac.GetPosDeb();
		while (pos) {
			CMacAction *const pact = mac.GetSuiv(pos);
			
			// Passer  l'ID suivant dans le menu,
			// mme si aucun item n'a t ajout
			// (cela conserve la bijection vidente ID <-> index de l'action)
			// Ne pas oublier de mettre cette ligne au dbut
			// car ID_MAC_ACTION est rserv  "Automatique",
			// la premire action a donc comme ID_MAC_ACTION+1 pour ID
			id++;
			
			if (!pact->m_fHidden) {
				// Ajouter l'item si l'action n'est pas cache
				pact->GetItem(s);
				m_mnuAction.AppendMenu(MF_STRING, id, s);
			}
		}
		
		m_cmdExecuter.SetMenu(&m_mnuAction);
	}
}


// Focus reu par la zone de texte
// Contourner un petit bug agaant: la totalit du contrle
// est slectionn  chaque fois qu'il reoit le focus
// Si le bouton de la souris est enfonc, ne pas toucher  la slection
void CMacroView::OnTxtSetFocus()
{
	CString s;
	m_txt.GetWindowText(s);
	
	int nStart, nEnd;
	m_txt.GetSel(nStart, nEnd);
	if (nStart==0 && nEnd==s.GetLength())
		m_txt.SetSel(0,0);
}

// Focus perdu par la zone de texte
void CMacroView::OnTxtKillFocus()
{
	// Sauvegarder le fichier INI dans le document
	
	// Rcuprer le nom du fichier temporaire
	// pour y enregistrer le fichier INI et ainsi pouvoir le lire
	TCHAR pszTemp[MAX_PATH];
	TCHAR pszDossierTemp[MAX_PATH];
	if (e_opt.GetDossier(repTemp, pszDossierTemp) &&
		  GetFichierTemp(pszDossierTemp, pszTemp)) {
		
		CMacroDoc *const pDoc = GetDocument();
		
		// Rcuprer le texte
		CString s;
		m_txt.GetWindowText(s);
		
		// Regarder s'il est identique  celui de la macro
		CString sAvant;
		pDoc->m_mac.ToINI(sAvant);
		if (lstrcmp(sAvant, s)) {
			// Le fichier a chang
			
			// L'crire dans le fichier INI temporaire
			CFileWrite fw;
			fw.Open(pszTemp);
			fw.Write(s);
			fw.Close();
			
			// Rcuprer les donnes  partir du fichier INI temporaire
			pDoc->m_mac.FromINI(pszTemp);
			pDoc->m_mac.m_fModified = true;
			pDoc->SetModifiedFlag();
		}
		
		// Supprimer le fichier temporaire
		DeleteFile(pszTemp);
	}
}


// Excuter une action
void CMacroView::OnAction(UINT nID)
{
	CMacContexte ctx;
	
	if (nID==ID_MAC_ACTION)
		// Automatique
		GetDocument()->m_mac.Executer(ctx);
	else
		// Manuel
		GetDocument()->m_mac[nID - ID_MAC_ACTION]->Executer(ctx);
}


// diter le texte de la macro
void CMacroView::EditMacroText()
{
	// Permettre l'dition
	if (!IsDlgButtonChecked(IDCCHK_MAC_EDIT)) {
		CheckDlgButton(IDCCHK_MAC_EDIT, TRUE);
		OnEdit();
	}
	
	// Aller dans la zone de texte
	m_txt.SetFocus();
	m_txt.SetSel(MAKELONG(0,0));
}
