// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Muzip.h


#ifndef _MUZIP_H_
#define _MUZIP_H_
#if _MSC_VER>1000
#pragma once
#endif
#ifndef __AFXWIN_H__
#error Inclure 'StdAfx.h' avant d'inclure ce fichier
#endif

#include <App.h>
#include "AppResource.h"
#include "Global.h"

#include "Archives/PlusItem.h"


class CMuzipArc;
class CDlgProgress;

class CMuzipCmdLine;
class CMuzipDocTemplate;


const LPCTSTR pszExtDefaut = _T("zip");


enum PRGSTATUS
{
	prsOK,
	prsIgnorer,
	prsAnnuler,
	prsErreur,
};


enum DECOMP_ECRASE
{
	ecrDemander,
	ecrToujours,
	ecrJamais,
	ecrRenommer,
	ecrMax = ecrRenommer,
	
	ecrAnnuler,    // Pas d'crasement, on arrte tout (seulement pour CDlgEcrase)
};

// Options de dcompression
struct DECOMP
{
	int  nEcrase;        // Voir DECOMP_ECRASE plus haut
	BOOL fEcraseDate;    // N'craser que les fichiers plus anciens
	BOOL fArbo;          // Restaurer l'arborescence
	BOOL fGardeErreur;   // Garder les fichiers mal dcompresss
	BOOL fQueTrouve;     // Seulement les fichiers trouvs par la recherche
	
	void FromOptions(LPCTSTR psz);
	void ToOptions(CString& s) const;
};

extern const DECOMP e_decEcraseToujours;

class CInterf;
class CMuzipArc;


typedef CMuzipArc* (*PFN_CREATEARCHIVE)(CInterf* pi);



// Fichier  extraire
struct FICHIERDECOMP
{
	CFichier *pFichier;   // Fichier  dcompresser
	LPTSTR    pszDest;    // Rpertoire de destination
	TCHAR    *pcFin;      // Pointeur sur la fin de pszDest
};

class CLstFichierDecomp : public CListePtr1<FICHIERDECOMP*>
{
public:  // Fonctions
	
	CLstFichierDecomp(bool fAutoDel=false) : CListePtr1<FICHIERDECOMP*>(fAutoDel) {}
	
	void Ajouter(CLstFichier& lstFichier, const DECOMP* pdec, LPTSTR pszDest, TCHAR* pcFin);
};


// Associations
class CAssoc
{
public:  // Fonctions
	
	bool GetAssocCur(HKEY& hKey, LPTSTR pszValeur);
	void Affecter(bool fToMuzip, HKEY hKey, LPCTSTR pszValeur=NULL);
	
	static void NotifyChange();
	
	CAssoc& operator = (CAssoc& rAssoc);
	
	
public:  // Donnes
	
	TCHAR m_pszExt[16];             // Extension avec point
	TCHAR m_pszOldProg[MAX_PATH];   // Ancien programme associ
};
typedef CListePtr2<CAssoc*> CLstAssoc;


class CSurvDecomp
{
public:  // Fonctions
	
	CSurvDecomp(HANDLE hProcess, LPCTSTR pszFichier,
		CFichier* pFichier, CMuzipArc* pArc);
	
	~CSurvDecomp();
	
	void Main();
	void VerifModif();
	void VerifAttribut();
	
	static HANDLE s_hEvent;   // Pour stopper prcThreadTous
	static void CreateThreadTous();
	static void TerminateThreadTous();
	
	
protected:  // Statique interne
	
	static HANDLE s_hThreadTous;   // Pour attendre prcThreadTous
	static DWORD WINAPI prcThreadTous(void* pv);
	
	
public:  // Donnes
	
	enum{ etModif=1, etAttr=2, etFini=4, etClose=8 };
	
	LPTSTR     m_pszFichier;   // Fichier dcompress
	CFichier  *m_pFichier;     // Fichier  surveiller
	CMuzipArc *m_pArc;         // Document du fichier
	HANDLE     m_hProcess;     // Processus lanc
	
	HANDLE     m_hf;           // Handle du fichier
	FILETIME   m_ftModif;      // Date de modification initiale
	DWORD      m_dwAttr;       // Attributs initiaux
	int        m_et;           // tat du fichier
	HANDLE     m_hThread;      // Thread de surveillance
	HANDLE     m_hEvent;       // Pour stopper prcThread
	static DWORD WINAPI prcThread(CSurvDecomp* psd);
};
typedef CListePtr1<CSurvDecomp*> CLstSurvDecomp;


class CApp : public CWinApp
{
public:  // Fonctions
	
	CApp();
	~CApp();
	
	
protected:  // Hritage
	
	//{{AFX_VIRTUAL(CApp)
	BOOL InitInstance();
	int  ExitInstance();
	BOOL OnIdle(LONG lCount);
	int  DoMessageBox(LPCTSTR lpszPrompt, UINT nType, UINT nIDPrompt);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileNew();
	afx_msg void OnFileNewScript();
	afx_msg void OnFileOpen();
	afx_msg void OnFileReparer();
	afx_msg void OnFileRaccourci();
	afx_msg void OnFileOptions();
	afx_msg void OnFileDecompMult();
	afx_msg void OnMacroGerer();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#include "MuzipDll/MuzipApp.h"
#define CApp  CMuzipApp
#define oApp  ((CMuzipApp&)*pApp)


void DDX_TextInfini(CDataExchange* pDX, int nIDC, int& value);
void InfiniRemplaceZero(CWnd* pwndParent, UINT nIDC);


//{{AFX_INSERT_LOCATION}}
#endif
