// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Muzip2.h
//
// Classes auxiliaires utilises dans Muzip.cpp


#ifndef _MUZIP2_H_
#define _MUZIP2_H_
#if _MSC_VER>1000
#pragma once
#endif


#include "PlusItem.h"
class CMuzipArc;
class CInterf;


enum EXECSOURCE
{
	esMuzip,
	esMenu,
	esDrop,
};


// Opration longue de Muzip
class CMuzipOp
{
public:  // Fonctions
	
	CMuzipOp(const CMuzipArc* pArc=NULL, UINT nIDSTitre=0);
	~CMuzipOp();
};


// Gestion de la ligne de commande
enum
{
	FileComp = 100,
	FileDecomp,
	FileSendMail,
	FileScriptEdit,
	FileShortcut,
};


class CMuzipCmdLine : public CCommandLineInfo
{
public:  // Hritage
	
	CMuzipCmdLine();
	
	void ParseCommandLine(LPCTSTR pszCmdLine, bool fPeutInclude=true);
	
	
	void ParseParam(LPCTSTR pszParam, BOOL bFlag, BOOL bLast);
	
	void SetShellCommand(int nShellCommand)
		{
			(int&)m_nShellCommand = nShellCommand;
		}
	
	static void GetOption(int*& piOptions, int& ri, int max=1);
	static void AddOption(CString& s, int i);
	
	
public:  // Donnes
	
	CString      m_sShortcut;          // Nom ou rpertoire du raccourci
	CString      m_sDest;              // Dossier d'extraction
	CArchivePlus m_arPlus;             // Fichiers  ajouter
	bool         m_fDemanderOptions;   // TRUE s'il faut demander les options
	bool         m_fQuitter;           // TRUE s'il faut quitter aprs excution
	CString      m_sOptions;           // Options
	
	
protected:  // Interne
	
	enum
	{
		attDest     = 1,
		attPlusItem = 2,
	};
	
	DWORD m_dwAttend;   // Paramtres attendus aprs certains commutateurs
	                    // (/d et /f par exemple)
};


class CDocType;

// Modle de documents
class CMuzipDocTemplate : public CMultiDocTemplate
{
public:  // Fonctions
	
	CMuzipDocTemplate(CDocType* pdt,
		UINT nIDStrings, UINT nIDResource,
		CRuntimeClass* pDocClass,
		CRuntimeClass* pFrameClass,
		CRuntimeClass* pViewClass)
		: CMultiDocTemplate(nIDResource, pDocClass, pFrameClass, pViewClass),
		  m_pdt(pdt),
		  m_nIDStrings(nIDStrings)
		{
			m_strDocStrings.LoadString(nIDStrings);
		}
	
	CDocType* GetDocType() const { return m_pdt; }
	
	UINT GetStringsID()  const { return m_nIDStrings; }
	UINT GetResourceID() const { return m_nIDResource; }
	
	
public:  // Hritage
	
	void InitialUpdateFrame(CFrameWnd* pFrame, CDocument* pDoc, BOOL bMakeVisible=TRUE);
	
	Confidence MatchDocType(LPCTSTR lpszPathName, CDocument*& rpDocMatch);
	
	
protected:  // Donnes
	
	CDocType* m_pdt;          // Type de document
	UINT      m_nIDStrings;   // Argument pass au constructeur
};


#endif
