// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// MuzipApp.h


#ifndef _MUZIPAPP_H_
#define _MUZIPAPP_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Muzip.h"
#include "DocType.h"


// Flags pour CMuzipApp::ShowFileOpenDialog()
enum
{
	sfodOuvrir          = 0x1,   // Ouvre le fichier choisi
	sfodPasScript       = 0x2,   // Refuse les scripts
	sfodPasLectureSeule = 0x4,   // Refuse les fichiers en lecture seule
};

// Provenance d'une action
enum SOURCE_ACTION
{
	saMuzip,
	saDrop,
	saExplorer,
};

class CFileDialogEx;


// La classe CMuzipApp est entirement statique (pas de variables membre),
// parce qu'on doit pouvoir caster un CWinApp en CMuzipApp

class AFX_EXT_CLASS CMuzipApp : public CWinApp
{
public:  // Fonctions
	
	CMuzipApp()  { Constructeur(); }
	~CMuzipApp() { Destructeur(); }
	
	void Constructeur();
	void Destructeur();
	
	
	static bool InitOnce();
	static void ExitOnce();
	
	bool Init(bool fSilent=true);
	bool Exit();
	
	static bool LoadResourcesDll();
	CString GetProfileString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault = NULL);
	BOOL GetProfileBinary(LPCTSTR lpszSection, LPCTSTR lpszEntry, BYTE** ppData, UINT* pBytes);
	
	static void NettoyerTemp(LPCTSTR pszDossier, FILETIME ftLimite);
	
	void RebuildRecentFileList();
	
	
	static CDocument* FindDocument(LPCTSTR pszFichier);
	
	static bool ShowFileOpenDialog(CFileDialogEx& dlg, DWORD sfod, CDocType* pdtExclusif=NULL);
	static void InitFileOpenStruct(OPENFILENAME& ofn, CString& sExtDefaut,
		CString& sTous, CString& sAutre, DWORD sfod, CDocType* pdtExclusif=NULL);
	
	static void DoEvents();
	
	void SetMessageText(UINT    nID);
	void SetMessageText(LPCTSTR psz);
	void SetProgress(UINT nID, LPCTSTR pszFichier);
	void SetProgress(UINT nID, LPCTSTR pszFichier, UINT iCur, UINT iTotal);
	static void InitStatusAvance (const CMuzipArc* pArc=NULL, UINT nIDSTitre=0);
	static void ShowStatusAvance (DWORD nMax, bool fPeutIgnorer=false);
	static void ShowStatusAvance2(DWORD nMax);
	static void SetStatusLabel(UINT nIDC, UINT nIDS);
	static void SetStatusLabel(UINT nIDC, LPCTSTR psz);
	static void SetStatusFichier(LPCTSTR pszFichier);
	static void HideStatusAvance();
	static void HideStatusAvance2();
	static void UpdateProgressPos(int iType);
	static void SetStatusAvance (DWORD n);
	static void AddStatusAvance (int iType, DWORD n=1);
	static PRGSTATUS GetProgressStatus();
	static PRGSTATUS UpdateProgressStatus();
	static void ResetProgressStatus();
	
	bool ProcessShellCommand(CMuzipCmdLine& cmdInfo, SOURCE_ACTION sa=saMuzip);
	
	static void Register();
	static void Unregister();
	
	static bool DemanderEncoreErreur();
	
	static void SetFontVoir(const LOGFONT* plf);
	
	static void SetIconeParcourir(CWnd* pWnd, UINT nID);
	
	
protected:  // Interne
	
	static bool m_fErreurFatale;
	
	// Paramtres de la barre de progression
	static DWORD m_aPos[2];   // Position courante par rapport  m_aMax
	static DWORD m_aMax[2];   // Maximum
	static int   m_aPC [2];   // Position en %
	
	static int GetPourcent(DWORD dwCur, DWORD dwTot);
	
	
public:  // Donnes
	
	static bool       m_fSilent;    // TRUE si Init() a t appele avec
	                                // fSilent==true (mode DLL seule, appele
	                                // par le shell par exemple)
	
	static bool       m_fMsg;       // TRUE s'il faut afficher les AfxMessageBox
	static CLIPFORMAT m_cfMuzip;    // Format de presse-papiers
	static int        m_nConfirm;   // Apparition des messages de confirmation
	                                // (activ si >0, dsactiv si <=0)
	
	static CLstSurvDecomp m_lstSurvDecomp;   // Fichiers dcompresss  surveiller
	static CLstStr1       m_lstDelDossier;   // Dossiers  supprimer  la sortie
	
	static ARCHIVEPLUS_GUI m_arPlus;     // Options d'ajout par dfaut
	static CPlusItem       m_pi;         // Options de compression par dfaut
	static DECOMP          m_dec;        // Options d'extraction
	static RECHOPTIONS     m_rch;        // Options de recherche
	
	static CLstDocType  m_lstDocType; // Types de documents
	static CLstAssoc    m_lstAssoc;   // Associations
	
	// Bote de dialogue d'avancement
	static CDlgProgress *m_pdlgProgress;   // Pointeur
	static UINT          m_ndlgProgress;   // Compteur d'affichage (0=masqu)
	static CString       m_sdlgProgress;   // Titre
	
	static CFont m_fntVoir;           // Police du visualiseur interne
	
	static HIMAGELIST m_himlSystem;   // Liste d'images systme
	static int m_iIconRepClosed;      // Dossier ferm (index dans m_himlSystem)
	static int m_iIconRepOpen;        // Dossier ouvert (index dans m_himlSystem)
	
	static CMuzipDocTemplate *m_pmdtScript;   // Template des script
	static CMuzipDocTemplate *m_pmdtMacro;    // Template des macros
	
	static bool m_fOuvreVisible;      // TRUE si les documents doivent tre ouverts
	                                  // en mode visible
	
	static SOURCE_ACTION m_sa;        // Source de l'action courante
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CApp)
	public:
	BOOL InitInstance();
	int  ExitInstance();
	BOOL OnIdle(LONG lCount);
	int  DoMessageBox(LPCTSTR lpszPrompt, UINT nType, UINT nIDPrompt);
	//}}AFX_VIRTUAL
	
	
public:  // Messages
	
	//{{AFX_MSG(CApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileNew();
	afx_msg void OnFileNewScript();
	afx_msg void OnFileOpen();
	afx_msg void OnFileReparer();
	afx_msg void OnFileRaccourci();
	afx_msg void OnFileOptions();
	afx_msg void OnFileDecompMult();
	afx_msg void OnMacroGerer();
	//}}AFX_MSG
};

extern CMuzipApp *e_pma;


CDocument* GetActiveDocument();
void       SetActiveDocument(CDocument* pDocument);

int DlgRedimSelonLabel(CDialog& dlg, const CString& sMsg);
void MoveControlY(CDialog& dlg, UINT nIDC, int yDiff);


#endif
