// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// MuzipDll.cpp


#include "StdAfx.h"
#include <afxDllX.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "MuzipApp.h"
#include "MuzipDll.h"


// Informations sur la DLL
AFX_EXTENSION_MODULE e_em = { NULL, NULL };
HANDLE               e_hEventAppClose = NULL;
HANDLE               e_hThreadApp     = NULL;


// Point d'entre
STDAPI_(int) DllMain(HINSTANCE hInstance, DWORD dwReason, void*)
{
	if (dwReason==DLL_PROCESS_ATTACH) {
		// Nouveau processus
		
		TRACE0("MuzipDll - DllMain - DLL_PROCESS_ATTACH\n");
		
		// On a pas besoin de DLL_THREAD_*
		DisableThreadLibraryCalls(hInstance);
		
		// Initialiser la DLL d'extension MFC
		VERIF(AfxInitExtensionModule(e_em, hInstance));
		new CDynLinkLibrary(e_em);
		
		// Pour pouvoir utiliser les AfxGet*()
		AfxGetModuleState()->m_hCurrentInstanceHandle = hInstance;
		
		// Charger l'interface de manipulation des archives
		VERIF(CMuzipApp::InitOnce());
		
		
	}else{
		// Fermeture de processus
		
		TRACE0("MuzipDll - DllMain - DLL_PROCESS_DETACH\n");
		
		ASSERT(dwReason==DLL_PROCESS_DETACH);
		
		// Terminer l'application et attendre que tout soit fini
		if (e_hEventAppClose) {
			TRACE0("MuzipDll - DllMain - Attente terminaison...\n");
			SetEvent(e_hEventAppClose);
			WaitForSingleObject(e_hThreadApp, INFINITE);
			TRACE0("MuzipDll - DllMain - Terminaison OK\n");
		}
		
		CMuzipApp::ExitOnce();
		
		// Terminer la DLL d'extension MFC
		AfxTermExtensionModule(e_em);
	}
	
	return TRUE;
}
