// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Options.h


#ifndef _OPTIONS_H_
#define _OPTIONS_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "AppResource.h"


#define ManipulerPage(fonction) \
	fonction(General) \
	fonction(Dossiers) \
	fonction(Confirm) \
	fonction(Comp) \
	fonction(Rm) \
	fonction(Cache) \
	fonction(Affichage) \
	fonction(Progress) \
	fonction(Apercu) \
	fonction(Shell) \
	fonction(Menu) \
	fonction(Macro)


enum
{
	#define dclEnumPage(page)  pgOptions##page,
	ManipulerPage(dclEnumPage)
	#undef  dclEnumPage
	
	nbPageOptions
};


#define ManipulerValeurGeneral(fonction, fonction2) \
	fonction(fonction2, General, BOOL, f,OuvrirAuto,         FALSE) \
	fonction(fonction2, General, BOOL, f,AssocVerifAuto,     TRUE) \
	fonction(fonction2, General, BOOL, f,Commentaire,        TRUE) \
	fonction(fonction2, General, BOOL, f,Corbeille,          TRUE) \
	fonction(fonction2, General, BOOL, f,TjVisible,          FALSE) \
	fonction(fonction2, General, BOOL, f,SupprDossierVide,   TRUE) \
	fonction(fonction2, General, UINT, n,MRU,                4)
#define ManipulerChaineGeneral(fonction, fonction2)

#define ManipulerValeurDossiers(fonction, fonction2) \
	fonction(fonction2, Dossiers, BOOL, f,NettoyerTemp,      TRUE)
#define ManipulerChaineDossiers(fonction, fonction2)

#define ManipulerValeurConfirm(fonction, fonction2) \
	fonction(fonction2, Confirm, DWORD, dw,Mcf,              (DWORD)-1)
#define ManipulerChaineConfirm(fonction, fonction2)

#define ManipulerValeurComp(fonction, fonction2) \
	fonction(fonction2, Comp, BOOL, f,OptionsDropMuzip,      TRUE) \
	fonction(fonction2, Comp, BOOL, f,OptionsDropArchive,    TRUE)
#define ManipulerChaineComp(fonction, fonction2) \
	fonction(fonction2, Comp, PasCompExt, _T("arc;arj;b64;bhx;cab;gz;hqx;lzh;taz;tgz;tz;z;zip;zoo;jar;ear;war;nbm"))

#define ManipulerValeurRm(fonction, fonction2) \
	fonction(fonction2, Rm, UINT, n,TailleMin,               1)
#define ManipulerChaineRm(fonction, fonction2)

#define ManipulerValeurCache(fonction, fonction2) \
	fonction(fonction2, Cache, UINT, u,PrevMax,              2000) \
	fonction(fonction2, Cache, BOOL, f,PrevAmovible,         TRUE) \
	fonction(fonction2, Cache, UINT, u,GarderMax,            2000) \
	fonction(fonction2, Cache, BOOL, f,GarderAmovible,       TRUE)
#define ManipulerChaineCache(fonction, fonction2)

#define ManipulerValeurAffichage(fonction, fonction2) \
	fonction(fonction2, Affichage, BOOL, f,Grille,           FALSE) \
	fonction(fonction2, Affichage, BOOL, f,SelLigne,         FALSE) \
	fonction(fonction2, Affichage, BOOL, f,ModifHeure,       FALSE) \
	fonction(fonction2, Affichage, int,  n,Souris,           afsWindows) \
	fonction(fonction2, Affichage, int,  n,Souris1,          afssJamais)
#define ManipulerChaineAffichage(fonction, fonction2)

#define ManipulerValeurProgress(fonction, fonction2) \
	fonction(fonction2, Progress, BOOL, f,AfficherMuzip,     TRUE) \
	fonction(fonction2, Progress, BOOL, f,AfficherDrop,      TRUE) \
	fonction(fonction2, Progress, BOOL, f,AfficherExplorer,  TRUE) \
	fonction(fonction2, Progress, BOOL, f,Detail,            TRUE) \
	fonction(fonction2, Progress, UINT, n,Delai,             1000)
#define ManipulerChaineProgress(fonction, fonction2)

#define ManipulerValeurApercu(fonction, fonction2) \
	fonction(fonction2, Apercu, BOOL, f,MAJAuto,             TRUE) \
	fonction(fonction2, Apercu, BOOL, f,DefautTexte,         TRUE) \
	fonction(fonction2, Apercu, UINT, n,Taille,               500) \
	fonction(fonction2, Apercu, BOOL, f,PoliceTout,          TRUE)
#define ManipulerChaineApercu(fonction, fonction2) \
	fonction(fonction2, Apercu,         PolicePlus,          _T(""))

#define ManipulerValeurShell(fonction, fonction2)
#define ManipulerChaineShell(fonction, fonction2)

#define ManipulerValeurMenu(fonction, fonction2)
#define ManipulerChaineMenu(fonction, fonction2)

#define ManipulerValeurMacro(fonction, fonction2) \
	fonction(fonction2, Macro,  int,  n,AutoOpen,            maoDemander)
#define ManipulerChaineMacro(fonction, fonction2)


#define ManipulerValeurComplet(fonction, fonction2) \
	ManipulerValeurGeneral  (fonction, fonction2) \
	ManipulerValeurDossiers (fonction, fonction2) \
	ManipulerValeurConfirm  (fonction, fonction2) \
	ManipulerValeurComp     (fonction, fonction2) \
	ManipulerValeurRm       (fonction, fonction2) \
	ManipulerValeurCache    (fonction, fonction2) \
	ManipulerValeurAffichage(fonction, fonction2) \
	ManipulerValeurProgress (fonction, fonction2) \
	ManipulerValeurApercu   (fonction, fonction2) \
	ManipulerValeurShell    (fonction, fonction2) \
	ManipulerValeurMenu     (fonction, fonction2) \
	ManipulerValeurMacro    (fonction, fonction2)

#define ManipulerChaineComplet(fonction, fonction2) \
	ManipulerChaineGeneral  (fonction, fonction2) \
	ManipulerChaineDossiers (fonction, fonction2) \
	ManipulerChaineConfirm  (fonction, fonction2) \
	ManipulerChaineComp     (fonction, fonction2) \
	ManipulerChaineRm       (fonction, fonction2) \
	ManipulerChaineCache    (fonction, fonction2) \
	ManipulerChaineAffichage(fonction, fonction2) \
	ManipulerChaineProgress (fonction, fonction2) \
	ManipulerChaineApercu   (fonction, fonction2) \
	ManipulerChaineShell    (fonction, fonction2) \
	ManipulerChaineMenu     (fonction, fonction2) \
	ManipulerChaineMacro    (fonction, fonction2)


#define ManipulerAutreComplet(fonction, fonction2) \
	fonction(fonction2, Affichage, UINT, n,StyleEx,          0)



// Rajouter le type CString et le prfixe 's' aux chanes
#define fnManipulerMembres1(fonction, page, type, prefixe, nom, defaut) \
	fonction(page, type,    prefixe, nom, defaut)
#define fnManipulerMembres2(fonction, page,                nom, defaut) \
	fonction(page, CString, s,       nom, defaut)
#define ManipulerMembres(fonction) \
	ManipulerValeurComplet(fnManipulerMembres1, fonction) \
	ManipulerChaineComplet(fnManipulerMembres2, fonction)


// Macros Manipuler sans 'fonction2'
#define fnManipulerValeur(fonction, page, type, prefixe, nom, defaut) \
	fonction(type, ##prefixe##page##nom, defaut)
#define ManipulerValeur(fonction) \
	ManipulerValeurComplet(fnManipulerValeur, fonction) \
	ManipulerAutreComplet( fnManipulerValeur, fonction)
#define fnManipulerChaine(fonction, page, nom, defaut) \
	fonction(##page##nom, defaut)
#define ManipulerChaine(fonction) \
	ManipulerChaineComplet(fnManipulerChaine, fonction)

// Macros Manipuler sans 'fonction' et avec le nom complet de la valeur
#define fnManipulerNomPageValeur(fonction, page, type, prefixe, nom, defaut) \
	fonction(##type, ##prefixe##page##nom, defaut)
#define fnManipulerNomPageChaine(fonction, page,                nom, defaut) \
	fonction(CString, s##page##nom, defaut)
#define ManipulerNomPage(fonction) \
	ManipulerValeurComplet(fnManipulerNomPageValeur, fonction) \
	ManipulerAutreComplet( fnManipulerValeur,        fonction) \
	ManipulerChaineComplet(fnManipulerNomPageChaine, fonction)

#define fnManipulerNomValeur(fonction, page, type, prefixe, nom, defaut) \
	fonction(##type, ##prefixe##nom, defaut)
#define fnManipulerNomChaine(fonction, page,                nom, defaut) \
	fonction(CString, s##nom, defaut)
#define fndclMembresNom(type, nom, defaut)  type m_##nom;
#define dclMembresDePage(page) \
	ManipulerValeur##page(fnManipulerNomValeur, fndclMembresNom) \
	ManipulerChaine##page(fnManipulerNomChaine, fndclMembresNom)


// Longueur totale de toutes les chanes (somme de _opt.m_len*)
#define fnTotalLen(nom, defaut)  _opt.m_len##nom +
#define TotalLen   (ManipulerChaine(fnTotalLen) 0)


enum AFFICHAGESOURIS
{
	afsWindows,
	afsClicUn,
	afsClicDeux,
};
enum AFFICHAGESOURIS1
{
	afssJamais,
	afssPointe,
	afssToujours,
};

enum REPARER
{
	repNon,
	repPresumer,
	repVerifier,
	repAltere,
};


enum RM_OPTION_AC
{
	rmoRien = -1,
	rmoAjouter,
	rmoTaille,
	rmoAmovible,
	rmoSupprimer,
	rmoProprietes,
	rmoDeplacer,
	rmoReconstruire,
	rmoManuel,
	
	nbRmOption
};

struct RM_OPTION
{
	RM_OPTION_AC rmo;
	bool         fActive;
};


enum
{
	repAjout,
	repDecomp,
	repTemp,
	
	repTotal,
};

enum
{
	repoArchive,
	repoDernier,
	repoAuto,
	repoPerso,
	
	repoTotal
};

struct DOSSIER_OPTION
{
	int     repo;
	CString sPerso;
};


// Types de menu contextuel
enum
{
	mctArchive,
	mctFichier,
	mctDossier,
	
	mctTotal
};

// Commandes du menu contextuel
enum
{
	mccOuvrir         = 1<<0,
	mccDecomp         = 1<<1,
	mccDecompAuto     = 1<<2,
	mccDecompIci      = 1<<3,
	mccCompresser     = 1<<4,
	mccCompresserAuto = 1<<5,
	mccMail           = 1<<6,
};

// ID des commandes du menu contextuel
const UINT cmdDeb = CMD_OUVRIR;
const UINT cmdFin = CMD_MAIL;

// Liste des options pour lesquelles il est possible
// d'afficher FACULTATIVEMENT une bote de dialogue de paramtrage
// Cela signifie que si la bote de dialogue est indispensable,
// la commande correspondante ne doit PAS figurer dans la liste
const UINT uShellMenuPeutDemander =
	mccDecompAuto | mccDecompIci |
	mccCompresser | mccCompresserAuto;

extern const UINT auShellMenuMax[mctTotal];

struct MCT_OPTION
{
	UINT uVisible;   // Items devant tre affichs
	UINT uDemande;   // Items pour lesquels les options doivent tre demandes
	
	static MCT_OPTION* GetArray();
};

const int bufMCT = mctTotal*sizeof(MCT_OPTION);


// Excution automatique des macros  l'ouverture
enum
{
	maoDemander,
	maoToujours,
	maoJamais,
};



class CMuzipArc;


// Options gnrales
class COptions
{
public:  // Fonctions
	
	void Load();
	void Save();
	
	void Appliquer();
	void MAJAffichageStyleEx();
	void MAJPasCompExt();
	
	bool GetDossier(int rep, LPTSTR pszDossier, LPCTSTR pszArchive=NULL) const;
	void SetDossierDernier(int rep, LPCTSTR pszDossier);
	
	
public:  // Donnes
	
	#define dclMembre(type, nom, defaut)  type m_##nom;
	ManipulerNomPage(dclMembre)
	#undef  dclMembre
	
	CLstCString2 m_lstPasCompExt;   // Extensions  ne pas compresser
	REPARER      m_nReparer;        // Niveau de rparation
	
	RM_OPTION m_aRmOption[nbRmOption];    // Options de la reconstruction manuelle
	
	DOSSIER_OPTION m_aDossier[repTotal];  // Options des dossiers
};


extern COptions e_opt;



// Nom des cls et des valeurs dans le registre

#define GetKSZ(page)                   kszOptions##page
#define GetESZ(page, prefixe, nom)     eszOptions##page##prefixe##nom
#define GetMembre(page, prefixe, nom)  m_##prefixe##page##nom


// Constantes ksz*
#define dclKSZ(page)  const LPCTSTR GetKSZ(page) = _T("Options\\") _T(#page);
ManipulerPage(dclKSZ)
#undef  dclKSZ

// Constantes esz*
#define dclESZ(page, type, prefixe, nom, defaut) \
	const LPCTSTR GetESZ(page, prefixe, nom) = _T(#prefixe) _T(#nom);
ManipulerValeurComplet(fnManipulerMembres1, dclESZ)
ManipulerChaineComplet(fnManipulerMembres2, dclESZ)
dclESZ(Comp,    _, a, RmOption, _)
dclESZ(Cache,   _, a, Prev, _)
dclESZ(Cache,   _, o, Garder, _)
#undef  dclESZ

const LPCTSTR eszDossierType  = _T("Type%d");
const LPCTSTR eszDossierPerso = _T("Perso%d");


#endif
