// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// RechDate.h


#ifndef _RECHDATE_H_
#define _RECHDATE_H_
#if _MSC_VER>1000
#pragma once
#endif


class CRechDate
{
public:  // Fonctions
	
	CRechDate() { SetNow(); }
	CRechDate(bool fActive, CTempsDHS& dt1, CTempsDHS& dt2)
		: fActive(fActive), dt1(dt1), dt2(dt2) {}
	
	void Export(int& fActive,
		UINT& uJ1, UINT& uM1, UINT& uA1,
		UINT& uJ2, UINT& uM2, UINT& uA2);
	
	void Import(int fActive,
		UINT uJ1, UINT uM1, UINT uA1,
		UINT uJ2, UINT uM2, UINT uA2);
	
	// Remplir les deux dates avec la date actuelle
	inline void SetNow()
		{
			fActive = false;
			dt1.SetNow();
			dt2.SetNow();
		}
	
	// Indiquer si la date est valide
	inline bool PasValide() const
		{
			return fActive && (dt1.PasValide() || dt2.PasValide());
		}
	
	// Indiquer si la date donne corresond au critre
	inline bool Correspond(const FILETIME ft) const
		{
			const CTempsD dt = ft;
			return dt1<=dt && dt<=dt2;
		}
	
	
public:  // Donnes
	
	bool fActive;  // Prendre en compte la date dans la recherche
	CTempsD dt1;   // Date de dbut de la priode de validit
	CTempsD dt2;   // Date de fin de la priode de validit
};


void DDX_RechDate(CDataExchange* pDX, int nIDC, CRechDate& rd);
void DDV_RechDate(CDataExchange* pDX, int nIDC, CRechDate& rd);


#endif
