// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// ScriptDoc.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "Muzip2.h"
#include "ScriptDoc.h"

#include "MuzipDoc.h"
#include "MuzipView.h"
#include "MuzipArc.h"

#include "dlgArchivePlus.h"
#include "dlgMdp.h"
#include "dlgConfirm.h"

#include <FileBuf.h>
#include "IOFichier.h"
#include "FileDialogEx.h"


const DWORD idScript  = 'SZUM';  // MUZS


const BOOL    Defaut_fDemMdp   = FALSE;
const UINT    Defaut_uMaxSimil = 0;
const int     Defaut_simt      = CScriptDoc::simtCreation;
const BOOL    Defaut_fSimilMsg = FALSE;
const BOOL    Defaut_RacAuto   = FALSE;
#define       Defaut_decRac      oApp.m_dec
const LPCTSTR Defaut_sDestRac  = _T("");


IMPLEMENT_DYNCREATE(CScriptDoc, CDocument)
BEGIN_MESSAGE_MAP(CScriptDoc, CDocument)
	//{{AFX_MSG_MAP(CScriptDoc)
	ON_COMMAND(ID_SCRIPT_MODIFIER,      OnScriptModifier)
	ON_COMMAND(ID_SCRIPT_EXECUTER,      OnScriptExecuter)
	ON_COMMAND(ID_SCRIPT_OUVRIRARCHIVE, OnScriptOuvrirArchive)
	ON_COMMAND(ID_ARCHIVE_MDP,          OnArchiveMdp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// E/S
void CScriptDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring()) {
		// Enregistrement
		
		ar
			<< idScript
			<< m_verScript;
		
		
		//*** crire les donnes
		
		// Toutes versions
		ar << m_sArchive;
		
		// Version 3.0x
		// - Demande du mot de passe
		if (m_verScript>=verScript300) {
			ar << m_fDemMdp;
			
			// Version 4.00
			// - Suppression des archives similaires
			if (m_verScript>=verScript400) {
				ar
					<< m_uMaxSimil
					<< m_simt
					<< m_fSimilMsg;
				
				// Version 4.01
				// - Enregistrement du mot de passe
				if (m_verScript>=verScript401) {
					if (m_fDemMdp)
						ar << m_sMdp;
					
					// Version 4.02
					// - Raccourci de dcompression
					if (m_verScript>=verScript402) {
						ar
							<< m_fRacAuto
							<< m_sDestRac
							<< m_fRacOptions;
						ar.Write(&m_decRac, sizeof(m_decRac));
					}
				}
			}
		}
		
		
	}else{
		// Lecture
		
		// Vrifier l'ID
		DWORD id;
		ar >> id;
		if (id!=idScript)
			AfxThrowArchiveException(CArchiveException::badIndex);
		
		// Vrifier le numro de version
		ar >> m_verScript;
		if (m_verScript<verScript100 || m_verScript>verScriptMax)
			AfxThrowArchiveException(CArchiveException::badSchema);
		
		
		//*** Lire les donnes
		
		// Toutes versions
		ar >> m_sArchive;
		
		// Version 3.0x
		// - Demande du mot de passe
		if (m_verScript>=verScript300)
			ar >> m_fDemMdp;
		else
			m_fDemMdp = Defaut_fDemMdp;
		
		// Version 4.00
		// - Suppression des archives similaires
		if (m_verScript>=verScript400)
			ar
				>> m_uMaxSimil
				>> m_simt
				>> m_fSimilMsg;
		else{
			m_uMaxSimil = Defaut_uMaxSimil;
			m_simt      = Defaut_simt;
			m_fSimilMsg = Defaut_fSimilMsg;
		}
		
		// Version 4.01
		// - Enregistrement du mot de passe
		if (m_verScript>=verScript401 && m_fDemMdp)
			ar >> m_sMdp;
		
		// Version 4.02
		// - Raccourci de dcompression
		if (m_verScript>=verScript402) {
			ar
				>> m_fRacAuto
				>> m_sDestRac
				>> m_fRacOptions;
			ar.Read(&m_decRac, sizeof(m_decRac));
		}else{
			m_fRacAuto  = Defaut_RacAuto;
			m_decRac    = Defaut_decRac;
			m_sDestRac  = Defaut_sDestRac;
		}
	}
	
	// S'occuper de la requte de compression
	m_arPlus.Serialize(ar, m_verPI);
}


// Supprimer le contenu
void CScriptDoc::DeleteContents()
{
	m_verScript = verScript400;
	m_verPI     = verPlusItem3;
	
	m_fDemMdp   = Defaut_fDemMdp;
	m_uMaxSimil = Defaut_uMaxSimil;
	m_simt      = Defaut_simt;
	m_fSimilMsg = Defaut_fSimilMsg;
	m_fRacAuto  = Defaut_RacAuto;
	m_decRac    = Defaut_decRac;
	m_sDestRac  = Defaut_sDestRac;
	
	m_arPlus.DeleteAll();
}


// Enregistrer le document
// Grer la spcification du format dans le type du fichier
BOOL CScriptDoc::DoSave(LPCTSTR lpszPathName, BOOL bReplace)
{
	CString sPath = lpszPathName;
	
	if (sPath.IsEmpty()) {
		// Afficher la bote de dialogue "Enregistrer sous"
		
		CString sExt;
		VERIFY(GetDocTemplate()->GetDocString(sExt, CDocTemplate::filterExt));
		
		// Composer le nom par dfaut du document
		sPath = m_strPathName;
		if (bReplace && sPath.IsEmpty()) {
			// Pas de nom: prendre le titre du document
			
			sPath = m_strTitle;
			const int iBad = sPath.FindOneOf(_T(" #%;/\\"));
			if (iBad>=0)
				sPath.ReleaseBuffer(iBad);
			
			// Ajouter l'extension par dfaut
			sPath += sExt;
		}
		
		
		CFileDialogEx dlgFile(FALSE);
		
		CString sTitle(MAKEINTRESOURCE(
			(bReplace) ? AFX_IDS_SAVEFILE : AFX_IDS_SAVEFILECOPY));
		dlgFile.m_ofn.Flags      |= fdFlagsSave;
		dlgFile.m_ofn.lpstrDefExt = (LPCTSTR)sExt + 1;   // Sauter le '.' de l'extension
		
		// Composer le filtre
		// sListe contient la liste de tous les formats de Muzip,
		// avec les anciennes versions
		CString sFilter;
		CString sListe(MAKEINTRESOURCE(IDS_FILTRESCRIPT));
		CTokenize tok(sListe, '\n');
		while (tok.Next()) {
			sFilter += tok.GetToken();
			sFilter += _T("|*");
			sFilter += sExt;
			sFilter += '|';
		}
		
		// Ajouter le filtre "Tous les fichiers"
		sFilter += CStringRes(AFX_IDS_ALLFILTER);
		sFilter += _T("|*.*|");
		sFilter.Replace('|', 0);
		
		dlgFile.m_ofn.lpstrFilter = sFilter;
		dlgFile.m_ofn.lpstrTitle  = sTitle;
		dlgFile.m_ofn.lpstrFile   = sPath.GetBuffer(_MAX_PATH);
		
		
		static const WORD aVersion[] =
		{
			verScriptMax,   // Extension personnalise => dernier format
			verScriptMax,   // Dernier format
			verScript402,   // Muzip 4.0 bta
			verScript300,   // Muzip 3.0x
			verScriptMax,   // Tous les fichiers (*.*)
		};
		
		// Choisir le filtre correspondant au format courant
		for (dlgFile.m_ofn.nFilterIndex=1;
		     dlgFile.m_ofn.nFilterIndex<nbArray(aVersion);
		     dlgFile.m_ofn.nFilterIndex++)
			if (m_verScript==aVersion[dlgFile.m_ofn.nFilterIndex])
				break;
		if (dlgFile.m_ofn.nFilterIndex>nbArray(aVersion))
			dlgFile.m_ofn.nFilterIndex = 1;
		
		// Afficher la bote de dialogue
		const int nResult = dlgFile.DoModal();
		sPath.ReleaseBuffer();
		VERIF(nResult==IDOK);
		
		// Modifier le format selon le filtre choisi
		m_verScript = aVersion[dlgFile.m_ofn.nFilterIndex];
		m_verPI     = (m_verScript>=verScript402)
			? verPlusItem3 : verPlusItem2;
	}
	
	// Laisser  CDocument le soin de faire tout le reste  notre place
	return CDocument::DoSave(sPath, bReplace);
}


// Enregistrer le document
BOOL CScriptDoc::OnSaveDocument(LPCTSTR lpszPathName)
{
	// S'occuper du message de confirmation
	// en cas de perte d'informations si enregistrement
	// dans un ancien format
	if ((m_verScript<verScript300 && m_fDemMdp) ||
	    (m_verScript<verScript400 &&
	      (m_uMaxSimil!=Defaut_uMaxSimil ||
	       m_simt     !=Defaut_simt ||
	       m_fSimilMsg!=Defaut_fSimilMsg)) ||
	    (m_verScript<verScript401 && m_fDemMdp) ||
	    (m_verScript<verScript402 && m_fRacAuto))
		VERIF(CDlgConfirm::GetReponse(mcfScriptInfoPerdues, WAR_SCRIPTFORMAT));
	
	return CDocument::OnSaveDocument(lpszPathName);
}


// Modifier
void CScriptDoc::OnScriptModifier()
{
	if (CDlgArchivePlus(NULL, m_sArchive, m_arPlus, m_sMdp).DoModal()==IDOK)
		SetModifiedFlag();
}


// Excuter
void CScriptDoc::OnScriptExecuter()
{
	// Rcuprer le nom final de l'archive
	CString sFinal;
	EtendreSequences(sFinal, true);
	
	
	//*** Gestion des archives similaires
	//
	// On doit:
	// - Rcuprer la liste des archives similaires, trie selon
	//   le choix de l'utilisateur (pas de tri, date de cration,
	//   date de modification)
	// - En mode "pas de tri": afficher ventuellement un message  l'utilisateur
	// - En mode "tri selon la date de cration/modification":
	//   - On ne dsire garder que les archives  supprimer:
	//   - il faut donc ne garder que les archives les plus anciennes
	//   - Afficher ventuellement un message de confirmation,
	//   - Supprimer les archives du tableau
	
	bool fAnnuler = false;
	
	if (m_uMaxSimil>0) {
		// Rcuprer les archives similaires
		// pour supprimer celles qui sont en trop
		
		// Rcuprer la liste des archives similaires
		CSimil sim;
		UINT i;
		GetArchivesSimilaires(sFinal, sim);
		
		if (sim.GetNb()>=m_uMaxSimil) {
			// On doit supprimer des archives
			
			bool fPeutSupprimer = (m_simt!=simtRien);
			
			// Il faut supprimer les archives les plus anciennes:
			// on enlever de la liste les archives  conserver
			// Si on n'a pas le doit de supprimer les archives,
			// il faut par contre toutes les lister dans le message
			const UINT nbLister = (fPeutSupprimer)
				? sim.GetNb()+1 - m_uMaxSimil
				: sim.GetNb();
			
			// Afficher un message si cela est demand
			if (m_fSimilMsg) {
				
				// Lister les archives
				CString sListe;
				for (i=0; i<nbLister; i++) {
					sListe += '\n';
					sListe += sim[i].sArchive;
				}
				
				UINT idMsg, nType;
				
				if (fPeutSupprimer) {
					// Une suppression est possible: on demande confirmation
					
					idMsg = IDS_SIMIL_SUPPRIMER;
					nType = MB_YESNOCANCEL | MB_ICONQUESTION;
					
				}else{
					// Pas de suppression: on ne fait qu'informer
					
					idMsg = IDS_SIMIL_LISTE;
					nType = MB_OK | MB_ICONINFORMATION;
				}
				
				// Formatter et afficher le message
				AfxFormatString1(e_sMsg, idMsg, sListe);
				switch (AfxMessageBox(e_sMsg, nType)) {
					
					case IDCANCEL:
						fAnnuler       = true;
					
					case IDNO:
						fPeutSupprimer = false;
						break;
				}
			}
			
			if (fPeutSupprimer) {
				// Supprimer les archives en trop
				
				for (i=0; i<nbLister; i++)
					FichierSupprimer(sim[i].sArchive, false);
			}
		}
	}
	
	if (fAnnuler)
		return;
	
	// Crer l'archive si ncessaire
	if (!FichierCreer(sFinal))
		return;
	
	// Ouvrir l'archive, y compresser les fichiers, et la refermer
	bool fOK = false;
	CMuzipArc *const pArc = OpenArchive(sFinal);
	if (pArc) {
		if (pArc->IsLectureSeule())
			AfxMessageBox(ERR_LECTURESEULE);
		else if (!m_fDemMdp || CDlgMdp(m_sMdp).DoModal()==IDOK) {
			pArc->m_sMdp = m_sMdp;
			
			fOK = pArc->ArchivePlus(m_arPlus) && pArc->Reconstruire();
			
			if (fOK && m_fRacAuto) {
				// La sauvegarde a russi:
				// crer le raccourci de dcompression
				
				// Rcuprer le nom du raccourci (le mme que celui de l'archive,
				//  l'extension prs)
				CString sLink = pArc->GetPath();
				PathRenameExtension(sLink.GetBuffer(MAX_PATH), _T(".lnk"));
				sLink.ReleaseBuffer();
				
				// Crer le raccourci
				CString sOptions;
				m_decRac.ToOptions(sOptions);
				CreateArchiveShortcut(pArc->GetPath(), sLink,
					m_sDestRac, sOptions, ToBool(m_fRacOptions), false);
			}
		}
		pArc->Release(false);
	}
	
	if (!fOK)
		DeleteFile(sFinal);
	
	// Mettre  jour la vue ( cause des numros uniques)
	UpdateAllViews(NULL, 0,0);
}

// Ouvrir l'archive
void CScriptDoc::OnScriptOuvrirArchive()
{
	CString sFinal;
	EtendreSequences(sFinal, false);
	
	// Rcuprer la liste des archives similaires
	// si l'archive finale courante n'existe pas
	if (!PathFileExists(sFinal)) {
		CSimil sim;
		GetArchivesSimilaires(sFinal, sim);
		
		// Prendre l'archive la plus rcente
		if (sim.GetNb()>0)
			sFinal = sim[sim.GetNb()-1].sArchive;
	}
	
	// Ouvrir l'archive trouve
	if (!sFinal.IsEmpty())
		pApp->OpenDocumentFile(sFinal);
}


// Mot de passe
void CScriptDoc::OnArchiveMdp()
{
	CDlgMdp(m_sMdp).DoModal();
}


// tend les squences d'un chemin d'accs
// Retourner TRUE si le nom rsultant est correct
// fPeutNumero indique s'il faut remplacer les %chiffre
// par un numro unique (utilis rcursivement par la fonction)
void CScriptDoc::EtendreSequences(CString& sOut, bool fNumeroSuivant, bool fPeutNumero) const
{
	int aSequence[256];
	GetSequence(aSequence);
	
	// Rcuprer la date et l'heure une fois pour toutes
	CTempsDHS dhs;
	dhs.SetNow();
	
	// Remplacer les squences (%lettre) par leur valeur dans le nom de l'archive
	sOut.Empty();
	for (const TCHAR *pcIn=m_sArchive; *pcIn; pcIn++) {
		TCHAR c = *pcIn;
		
		if (c!='%') {
			// Caractre normal
			sOut += c;
			continue;
		}
		
		// Caractre '%'
		c = *++pcIn;
#ifdef UNICODE
		if (c>=0 && c<nbArray(aSequence) && aSequence[c]>=0) {
#else
		if (aSequence[c]>=0) {
#endif
			// Squence trouve !
			
			const int seq = aSequence[c];
			
			CString sPlus;
			
			if (seq<=seqNumero4) {
				// Numro unique
				
				int i;
				
				const int nbChiffre = seq + 2;
				UINT maxNumero = 1;
				for (i=0; i<nbChiffre; i++)
					maxNumero *= 10;
				
				if (fPeutNumero) {
					// Il faut trouver le majorant des numros des autres fichiers
					
					// Lister les fichiers similaires
					// en ignorant les numros uniques
					// (pas de rcursivit  l'infini)
					CString sFinal;
					EtendreSequences(sFinal, fNumeroSuivant, false);
					CSimil sim;
					GetArchivesSimilaires(sFinal, sim);
					
					// Trouver le plus grand numro dans les archives similaires
					UINT iPlusGrand = 0;
					for (UINT i=0; i<sim.GetNb(); i++) {
						
						// Rcuprer le numro
						TCHAR pszNumero[5];
						lstrcpyn(pszNumero,
							(LPCTSTR)sim[i].sArchive + (pcIn-(LPCTSTR)m_sArchive - 1),
							nbChiffre+1);
						
						// Prendre le plus grand numro
						// Comme on caste en UINT, vrifier qu'on n'a pas eu
						// d'entier ngatif
						const UINT iNumero = (UINT)StrToInt(pszNumero);
						if (iPlusGrand<iNumero && iNumero<maxNumero)
							iPlusGrand = iNumero;
					}
					
					// Composer le numro final trouv !
					if (fNumeroSuivant)
						iPlusGrand++;
					sPlus.Format(_T("%0*u"), nbChiffre, iPlusGrand);
					
				}else
					
					// On ne doit pas ajouter de numro
					// Insrer des '?'  la place des chiffres
					for (i=0; i<nbChiffre; i++)
						sPlus += '?';
				
			}else{
				// Date/heure
				
				static const LPCTSTR apszFormat[] =
				{
					_T("dd'-'MM'-'yyyy"),   // Date complte
					_T("HH'h'mm'"),         // Heure complte
					
					_T("dd"),               // Jour
					_T("MM"),               // Mois en deux chiffres
					_T("MMM"),              // Mois en trois lettres
					_T("yyyy"),             // Anne sur quatre chiffres
					_T("yy"),               // Anne sur deux chiffres
					
					_T("HH"),               // Heures
					_T("mm"),               // Minutes
					_T("ss"),               // Secondes
				};
				
				if (seq<seqHeure && seq!=seqHeureComplete)
					// Date
					sPlus = dhs.FormatD(apszFormat[seq - 3]);
				else
					// Heure
					sPlus = dhs.FormatHS(apszFormat[seq - 3]);
			}
			
			sOut += sPlus;
			
		}else{
			// Il y avait bien un '%', mais le caractre qui suivait
			// n'tait pas une squence
			// Cas spcial: '%%' doit donner un seul '%'
			
			sOut += '%';
			if (c!='%')
				sOut += c;
		}
	}
}


// Rcupre la liste des archives similaires  l'archive cible du script
// Par "similaire" on entend "ayant le mme nom aux squences spciales prs"
// Ainsi les archives "Sauvegarde 12-03-2002" et "Sauvegarde 00-11-2222"
// sont similaires  "Sauvegarde %D"
// La liste retourne est trie selon l'ordre dfini par l'utilisateur
// (dans m_simt), la premire archive tant la plus ancienne
void CScriptDoc::GetArchivesSimilaires(LPCTSTR pszFinal, CSimil& sim) const
{
	// On doit rechercher tous les fichiers du rpertoire de l'archive
	CString sRech = pszFinal;
	CString sDossier;
	sRech.GetBuffer(MAX_PATH);
	PathRemoveFileSpec((STRING)sRech);
	sDossier = (STRING)sRech;
	PathAppend((STRING)sRech, _T("*.*"));
	sRech.ReleaseBuffer();
	
	int aSequence[256];
	GetSequence(aSequence);
	
	// Remplacer les '%lettre' par le nombre correspondant
	// de chiffres/lettres
	// '?' signale un chiffre, '*' indique une lettre
	CString sComp;
	for (const TCHAR *pcIn=PathFindFileName(m_sArchive); *pcIn; pcIn++) {
		TCHAR c = *pcIn;
		
		if (c!='%') {
			// Caractre normal
			sComp += c;
			continue;
		}
		
		// Caractre '%'
		c = *++pcIn;
#ifdef UNICODE
		if (c>=0 && c<nbArray(aSequence) && aSequence[c]>=0) {
#else
		if (aSequence[c]>=0) {
#endif
			// Squence trouve !
			
			static const LPCTSTR apszFormat[] =
			{
				_T("\?\?"),                 // Numro unique sur 2 chiffres
				_T("\?\?\?"),               // Numro unique sur 3 chiffres
				_T("\?\?\?\?"),              // Numro unique sur 4 chiffres
				
				_T("\?\?-\?\?-\?\?\?\?"),   // Date complte
				_T("\?\?h\?\?"),            // Heure complte
				
				_T("\?\?"),                 // Jour
				_T("\?\?"),                 // Mois en deux chiffres
				_T("***"),                  // Mois en trois lettres
				_T("\?\?\?\?"),             // Anne sur quatre chiffres
				_T("\?\?"),                 // Anne sur deux chiffres
				
				_T("\?\?"),                 // Heures
				_T("\?\?"),                 // Minutes
				_T("\?\?"),                 // Secondes
			};
			
			sComp += apszFormat[aSequence[c]];
			
		}else{
			// Il y avait bien un '%', mais le caractre qui suivait
			// n'tait pas une squence
			// Cas spcial: '%%' doit donner un seul '%'
			
			sComp += '%';
			if (c!='%')
				sComp += c;
		}
	}
	
	CLstSimil lstSimil;
	
	// Effectuer la recherche
	for (CMyFindFile ff(sRech); ff.Next();) {
		
		// On ne veut que les fichiers
		if (ff.m_wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			continue;
		
		// Comparer ff.m_wfd.cFileName et sComp
		for (int i=0; i<sComp.GetLength(); i++) {
			const TCHAR cComp   = sComp[i];
			const TCHAR cTrouve = ff.m_wfd.cFileName[i];
			if (!cComp)
				goto Different;
			
			switch (cComp) {
				
				// Chiffre
				case '?':
					if (!(IsCharAlphaNumeric(cTrouve) &&
					     !IsCharAlpha       (cTrouve)))
						goto Different;
					break;
				
				// Lettre
				case '*':
					if (!IsCharAlpha(cTrouve))
						goto Different;
					break;
				
				// Tout autre caractre
				default:
					if (cComp!=cTrouve)
						goto Different;
					break;
			}
		}
		
		// La comparaison a russi !
		{
			SIMIL *const pSimil = new SIMIL;
			
			// Composer le chemin complet de l'archive
			PathCombine(pSimil->sArchive.GetBuffer(MAX_PATH),
				sDossier, ff.m_wfd.cFileName);
			pSimil->sArchive.ReleaseBuffer();
			
			// Si l'archive trouve est identique  l'archive cible,
			// l'ignorer dans le dcompte des archives similaires
			if (!lstrcmpi(pSimil->sArchive, pszFinal)) {
				delete pSimil;
				continue;
			}
			
			// Conserver les dates de cration et de modification
			pSimil->ftCreation = ff.m_wfd.ftCreationTime;
			pSimil->ftModif    = ff.m_wfd.ftLastWriteTime;
			
			// Ajouter le tout  la liste !
			lstSimil.AddFin(pSimil);
		}
		
	Different:
		;
	}
	
	
	// Stocker la liste des archives similaires dans un tableau
	sim.m_nbSimil = lstSimil.GetNb();
	sim.m_aSimil = new SIMIL*[sim.m_nbSimil];
	POS pos = lstSimil.GetPosDeb();
	for (UINT i=0; pos; i++)
		sim.m_aSimil[i] = lstSimil.GetSuiv(pos);
	
	// Trier les archives en utilisant la fonction de tri
	// choisie par l'utilisateur
	// Si aucun tri n'a t choisi, on prend la date de cration
	qsort(sim.m_aSimil, sim.m_nbSimil, sizeof(sim.m_aSimil[0]),
		(int(*)(const void* p1, const void* p2))
			((m_simt==simtModif)
				? ComparerSimilModif
				: ComparerSimilCreation));
}

// Nettoyer un tableau d'archives similaires
CSimil::~CSimil()
{
	for (UINT i=0; i<m_nbSimil; i++)
		delete m_aSimil[i];
	delete [] m_aSimil;
}


// Rcupre la liste des squences
// aSequence: tableau de 256 index
// index < 0 si pas de squence associe au caractre
// sinon index rfre  un seq* (voir le 'enum')
void CScriptDoc::GetSequence(int aSequence[])
{
	// <0 = pas de squence associe au caractre
	for (int i=0; i<256; i++)
		aSequence[i] = -1;
	
	CTokenize tok(IDS_SEQUENCE, '\n');
	while (tok.Next())
		aSequence[tok.GetToken()[tok.GetToken().GetLength()-1]] = tok.GetIndex();
}


// Comparer deux archives similaires selon leur date de cration
int CScriptDoc::ComparerSimilCreation(const SIMIL** ppsim1, const SIMIL** ppsim2)
{
	return (int)CompareFileTime(&(*ppsim1)->ftCreation, &(*ppsim2)->ftCreation);
}

// Comparer deux archives similaires selon leur date de modification
int CScriptDoc::ComparerSimilModif(const SIMIL** ppsim1, const SIMIL** ppsim2)
{
	return (int)CompareFileTime(&(*ppsim1)->ftModif, &(*ppsim2)->ftModif);
}
