// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// ScriptDoc.h


#ifndef _SCRIPTDOC_H_
#define _SCRIPTDOC_H_
#if _MSC_VER>1000
#pragma once
#endif

#include "Muzip.h"

#include "PlusItem.h"
const WORD verScript100 = 0x0100;
const WORD verScript110 = 0x0110;
const WORD verScript300 = 0x0300;
const WORD verScript400 = 0x0400;
const WORD verScript401 = 0x0401;
const WORD verScript402 = 0x0402;
const WORD verScript403 = 0x0403;
const WORD verScriptMax = verScript403;


enum
{
	seqNumero2,
	seqNumero3,
	seqNumero4,
	seqDateComplete,
	seqHeureComplete,
	seqJour,
	seqMoisChiffre,
	seqMoisLettre,
	seqAnnee4,
	seqAnnee2,
	seqHeure,
	seqMinute,
	seqSeconde,
};


struct SIMIL;
class CSimil;


class CScriptDoc : public CDocument
{
	DECLARE_DYNCREATE(CScriptDoc)
	
public:  // Donnes
	
	// Critres de suppression des archives similaires
	enum
	{
		simtRien,       // Ne rien supprimer
		simtCreation,   // Supprimer selon la date de cration
		simtModif,      // Supprimer selon la date de modification
	};
	
	
	WORD         m_verScript;   // Version du script
	WORD         m_verPI;       // Version des CPlusItem
	
	CString      m_sArchive;    // Archive  modifier
	UINT         m_uMaxSimil;   // Maximum d'archives similaires
	int          m_simt;        // Critre de suppression des archives similaires
	BOOL         m_fSimilMsg;   // Afficher un message de confirmation
	                            // si dpassement du maximum d'archives similaires
	
	BOOL         m_fRacAuto;    // Crer raccourci de dcompression
	DECOMP       m_decRac;      // Paramtres de dcompression du raccourci
	CString      m_sDestRac;    // Dossier destination du raccourci
	BOOL         m_fRacOptions; // TRUE pour forcer la demande des options
	
	BOOL         m_fDemMdp;     // Demander le mot de passe
	
	CArchivePlus m_arPlus;      // Options
	CString      m_sMdp;        // Mot de passe
	
	bool         m_fDemVer;     // Demander la version d'enregistrement
	
	
public:  // Fonctions
	
	
	void EtendreSequences(CString& sOut, bool fNumeroSuivant, bool fPeutNumero=true) const;
	void GetArchivesSimilaires(LPCTSTR pszFinal, CSimil& sim) const;
	
	
protected:  // Interne
	
	static void GetSequence(int aSequence[]);
	
	static int ComparerSimilCreation(const SIMIL** ppsim1, const SIMIL** ppsim2);
	static int ComparerSimilModif   (const SIMIL** ppsim1, const SIMIL** ppsim2);
	
	
protected:  // Hritage
	
	//{{AFX_VIRTUAL(CScriptDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual BOOL DoSave(LPCTSTR lpszPathName, BOOL bReplace=TRUE);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL
	
	
public:  // Messages
	
	//{{AFX_MSG(CScriptDoc)
	afx_msg void OnScriptRaccourci();
	afx_msg void OnScriptModifier();
	afx_msg void OnScriptExecuter();
	afx_msg void OnScriptOuvrirArchive();
	afx_msg void OnArchiveMdp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



struct SIMIL
{
	CString  sArchive;     // Chemin complet de l'archive
	FILETIME ftCreation;   // Sa date de cration
	FILETIME ftModif;      // Sa date de modification
};
typedef CListePtr2<SIMIL*> CLstSimil;


class CSimil
{
	friend void CScriptDoc::GetArchivesSimilaires(LPCTSTR pszFinal, CSimil& sim) const;
	
public:  // Fonctions
	
	CSimil() : m_nbSimil(), m_aSimil(NULL) {}
	~CSimil();
	
	UINT GetNb() const { return m_nbSimil; }
	
	const SIMIL& operator [] (UINT i) const { return *m_aSimil[i]; }
	
	
protected:  // Donnes
	
	UINT    m_nbSimil;
	SIMIL **m_aSimil;
};

//{{AFX_INSERT_LOCATION}}
#endif
