// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// ScriptView.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Muzip.h"
#include "ScriptView.h"

#include "ScriptDoc.h"
#include "DlgFrame.h"

#include "dlgSimil.h"
#include "dlgRaccourci.h"

#include "FileDialogEx.h"


IMPLEMENT_DYNCREATE(CScriptView, CFormView)
BEGIN_MESSAGE_MAP(CScriptView, CFormView)
	//{{AFX_MSG_MAP(CScriptView)
	ON_WM_DROPFILES()
	ON_EN_CHANGE (IDCTXT_ARCHIVE,   OnTxtArchiveChange)
	ON_BN_CLICKED(IDCCHK_DEMMDP,    OnChkDemMdp)
	ON_COMMAND   (IDCCMD_PARCOURIR, OnParcourir)
	ON_COMMAND   (IDCCMD_SIMIL,     OnSimil)
	ON_BN_CLICKED(IDCCHK_RACAUTO,   OnChkRacAuto)
	ON_COMMAND   (IDCCMD_RACAUTO,   OnRacAuto)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ID_SEQUENCE,ID_SEQUENCE+100, OnSequence)
END_MESSAGE_MAP()


// Contrles
void CScriptView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CScriptView)
	DDX_Control(pDX, IDCTXT_ARCHIVE,  m_txtArchive);
	DDX_Control(pDX, IDCCMD_SEQUENCE, m_cmdSequence);
	//}}AFX_DATA_MAP
}


// Initialisation
void CScriptView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	
	((CDlgFrame*)GetParent())->Init();
	
	// Initialiser la bote de dialogue
	CScriptDoc* const pDoc = GetDocument();
	m_txtArchive.SetWindowText(pDoc->m_sArchive);
	CheckDlgButton(IDCCHK_DEMMDP,   pDoc->m_fDemMdp);
	CheckDlgButton(IDCCHK_RACAUTO,  pDoc->m_fRacAuto);
	OnChkRacAuto();
	
	// Accepter le glisser-dplacer de fichiers
	// (pour copier directement le nom d'une archive)
	DragAcceptFiles();
	
	// Donner une icne au bouton Parcourir
	oApp.SetIconeParcourir(this, IDCCMD_PARCOURIR);
	
	
	// Crer le menu des squences et l'affecter au bouton
	const CString sSequence(MAKEINTRESOURCE(IDS_SEQUENCE));
	m_mnuSequence.CreatePopupMenu();
	for (int i=0;; i++) {
		CString sItem;
		if (!AfxExtractSubString(sItem, sSequence, i, '\n'))
			break;
		
		m_mnuSequence.AppendMenu(MF_STRING, ID_SEQUENCE+i, sItem);
	}
	m_cmdSequence.SetMenu(&m_mnuSequence);
}


// Mettre  jour
void CScriptView::OnUpdate(CView*, LPARAM, CObject*)
{
	CString sArchive;
	m_txtArchive.GetWindowText(sArchive);
	
	if (!sArchive.IsEmpty())
		OnTxtArchiveChange();
}


// Glisser-dplacer
void CScriptView::OnDropFiles(HDROP hDropInfo)
{
	TCHAR pszArchive[MAX_PATH];
	if (DragQueryFile(hDropInfo, 0, pszArchive,nbArray(pszArchive))) {
		// Glisser-dplacer d'une archive
		m_txtArchive.SetWindowText(pszArchive);
		DragFinish(hDropInfo);
	}else
		CFormView::OnDropFiles(hDropInfo);
}


// Nom de l'archive - changement
void CScriptView::OnTxtArchiveChange()
{
	CScriptDoc *const pDoc = GetDocument();
	
	// Conserver la valeur
	CString sArchive;
	m_txtArchive.GetWindowText(sArchive);
	if (pDoc->m_sArchive!=sArchive) {
		pDoc->m_sArchive = sArchive;
		pDoc->SetModifiedFlag();
	}
	
	// Afficher le rsultat aprs analyse des squences
	CString sFinal;
	pDoc->EtendreSequences(sFinal, true);
	SetDlgItemText(IDCLBL_FINAL, sFinal);
}

// Demande du mot de passe
void CScriptView::OnChkDemMdp()
{
	GetDocument()->m_fDemMdp = IsDlgButtonChecked(IDCCHK_DEMMDP);
	GetDocument()->SetModifiedFlag();
}


// Squence
void CScriptView::OnSequence(UINT nID)
{
	// Rcuprer l'intitul de l'item
	// La squence est  la fin, juste aprs un '\t'
	CString sItem;
	m_mnuSequence.GetMenuString(nID, sItem, MF_BYCOMMAND);
	
	// Mettre la squence  l'endroit de la slection
	m_txtArchive.ReplaceSel((LPCTSTR)sItem + (1+sItem.Find('\t')));
	m_txtArchive.SetFocus();
}


// Parcourir
void CScriptView::OnParcourir()
{
	CFileDialogEx dlg(TRUE, pszExtDefaut, GetDocument()->m_sArchive,
		fdFlagsCommon, NULL, this);
	if (oApp.ShowFileOpenDialog(dlg, sfodPasScript | sfodPasLectureSeule)) {
		m_txtArchive.SetWindowText(dlg.GetPathName());
		delete [] dlg.m_ofn.lpstrFile;
	}
}


// Gestion des archives similaires
void CScriptView::OnSimil()
{
	CDlgSimil(GetDocument()).DoModal();
}


// Raccourci de dcompression
void CScriptView::OnChkRacAuto()
{
	GetDlgItem(IDCCMD_RACAUTO)->EnableWindow(
		GetDocument()->m_fRacAuto = IsDlgButtonChecked(IDCCHK_RACAUTO));
}

// Paramtres du raccourci de dcompression
void CScriptView::OnRacAuto()
{
	CScriptDoc *const pDoc = GetDocument();
	
	// Demander les options
	CDlgRaccourci dlgRaccourci(-1);
	dlgRaccourci.m_dec              = pDoc->m_decRac;
	dlgRaccourci.m_fDemanderOptions = pDoc->m_fRacOptions;
	if (dlgRaccourci.DoModal()==IDOK) {
		pDoc->m_decRac      = dlgRaccourci.m_dec;
		pDoc->m_fRacOptions = dlgRaccourci.m_fDemanderOptions;
	}
}
