// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// lstMuzip.cpp


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include <afxPriv.h>
#include "Muzip.h"
#include "lstMuzip.h"

#include "MuzipArc.h"

#include "Interf.h"
#include "Options.h"

#include "MuzipDrop.h"
#include "MuzipDll/MuzipExt.h"

#include "dlgConfirm.h"
#include "dlgProprietes.h"

#include <Pidl.h>


BEGIN_MESSAGE_MAP(CLstMuzip, CListCtrl)
	//{{AFX_MSG_MAP(CLstMuzip)
	ON_NOTIFY_REFLECT   (LVN_GETDISPINFO,       OnGetDispInfo)
	ON_NOTIFY_REFLECT   (NM_RCLICK,             OnRClick)
	ON_NOTIFY_REFLECT   (LVN_BEGINDRAG,         OnBeginDrag)
	ON_NOTIFY_REFLECT   (LVN_KEYDOWN,           OnKeyDown)
	ON_NOTIFY_REFLECT   (LVN_COLUMNCLICK,       OnColumnClick)
	ON_NOTIFY_REFLECT   (LVN_ITEMACTIVATE,      OnItemActivate)
	ON_NOTIFY_REFLECT   (NM_CLICK,              OnClick)
	ON_COMMAND          (ID_ARCHIVE_MOINS,      OnArchiveMoins)
	ON_COMMAND          (ID_ARCHIVE_DECOMP,     OnArchiveDecomp)
	ON_COMMAND          (ID_ARCHIVE_RENOMMER,   OnArchiveRenommer)
	ON_COMMAND          (ID_ARCHIVE_PROPRIETES, OnArchiveProprietes)
	ON_COMMAND          (ID_ARCHIVE_RECOMP,     OnArchiveRecomp)
	ON_COMMAND          (ID_ARCHIVE_CACHER,     OnArchiveCacher)
	ON_COMMAND          (ID_ARCHIVE_TESTER,     OnArchiveTester)
	ON_COMMAND          (ID_ARCHIVE_LOCALISER,  OnArchiveLocaliser)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_DECOMP,     OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_MOINS,      OnUpdateFautSelModif)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_RENOMMER,   OnUpdateArchiveRenommer)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_PROPRIETES, OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_RECOMP,     OnUpdateFautSelModif)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_CACHER,     OnUpdateFautSel)
	ON_UPDATE_COMMAND_UI(ID_ARCHIVE_TESTER,     OnUpdateFautUnFichier)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CImageList CLstMuzip::s_imlHdr;



// Constructeur
CLstMuzip::CLstMuzip()
	: m_fDansArchive(false), m_fPasEdit(true), m_fPeutDrag(false)
{
	m_sm.SetWnd(this);
}

// Initialiser
void CLstMuzip::Init(int nContextMenu)
{
	m_nContextMenu = nContextMenu;
	
	// Tri initial
	m_nTriColonne = 0;
	m_fTriSens    = 0;
	Trier();
}


// Messages
LRESULT CLstMuzip::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	OnWindowProc(uMsg, wParam, lParam);
	
	LRESULT lResult;
	return (m_sm.WindowProc(uMsg, wParam, lParam, &lResult))
		? lResult
		: CListCtrl::WindowProc(uMsg, wParam, lParam);
}


// Demande d'informations
void CLstMuzip::OnGetDispInfo(NMHDR* pNMHDR, LRESULT*)
{
	LVITEM &item = ((NMLVDISPINFO*)pNMHDR)->item;
	
	if (item.mask & LVIF_TEXT)
		((const CFichier*)item.lParam)->GetSubItemText(
			item.iSubItem,
			item.pszText,
			item.cchTextMax);
}


// Clic droit
#pragma warning (disable: 4706)
void CLstMuzip::OnRClick(NMHDR*, LRESULT*)
{
	m_sm.Nettoyer();
	
	const UINT nb = GetSelectedCount();
	if (!nb)
		return;
	CPoint pt;
	GetCursorPos(&pt);
	
	// Crer le menu contextuel des fichiers
	CMenu mnu;
	mnu.LoadMenu(IDM_CONTEXT);
	m_sm.SetMenu(mnu.GetSubMenu(m_nContextMenu));
	
	m_pArc->PrepareDecomp();
	TCHAR pszDossierTemp[MAX_PATH];
	
	// Indiquer  la DLL d'extension que le menu est affich  partir de Muzip
	// Il ne faudra donc pas ajouter les items de Muzip au menu
	e_hMenuContextuel = *m_sm.GetMenu();
	
	// Rcuprer le dossier de dcompression et son interface
	IShellFolder *psf;
	if (e_opt.GetDossier(repTemp, pszDossierTemp) &&
	    (psf = e_pidlManager.GetFolder(pszDossierTemp))) {
		
		// Dcompresser les fichiers et rcuprer leur PIDL
		LPITEMIDLIST *const apidl = new LPITEMIDLIST[GetSelectedCount()];
		UINT nbSel = 0;
		POSITION pos = GetFirstSelectedItemPosition();
		while (pos) {
			
			// Dcompresser
			LPTSTR pszDest;
			CFichier *const pFichier = (CFichier*)GetItemData(GetNextSelectedItem(pos));
			if (!pFichier->ArchiveDecompSuite(pszDossierTemp,
			    &pszDest, &e_decEcraseToujours))
				break;
			new CSurvDecomp(NULL, pszDest, pFichier, m_pArc);
			
			// Rcuprer le PIDL
			const LPITEMIDLIST pidl = e_pidlManager.GetFile(psf,
				PathFindFileName(pszDest));
			if (pidl)
				apidl[nbSel++] = pidl;
			
			// On n'a plus besoin du nom
			delete [] pszDest;
		}
		oApp.m_fMsg = true;
		
		m_sm.InitFiles(psf, nbSel, apidl);
		
		// Dtruire les PIDL
		while (nbSel)
			e_pidlManager.Free(apidl[--nbSel]);
		delete [] apidl;
		
		// Nettoyer le dossier
		psf->Release();
	}
	
	e_hMenuContextuel = NULL;
	
	// Afficher le menu
	m_sm.GetMenu()->TrackPopupMenu(
		TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pt.x,pt.y, this);
}
#pragma warning (default: 4706)


// Glisser-dplacer
void CLstMuzip::OnBeginDrag(NMHDR* pNMHDR, LRESULT*)
{
	if (!m_fPeutDrag)
		return;
	
	// Construire la source de donnes OLE
	CMuzipDataSource mds;
	GetLstFichierSel(mds.m_lstFichier);
	mds.DelayRenderData(CF_HDROP);
	mds.Init(m_pArc);
	
	// Effectuer le glisser-dplacer
	if (mds.DoDragDrop()==DROPEFFECT_MOVE) {
		SetSelectionMark(((const NMLISTVIEW*)pNMHDR)->iItem);
		oApp.m_nConfirm--;
		OnArchiveMoins();
		oApp.m_nConfirm++;
	}
}


// Remplir une liste avec les fichiers slectionns
void CLstMuzip::GetLstFichierSel(CLstFichier& lstFichier)
{
	POSITION pos = GetFirstSelectedItemPosition();
	while (pos)
		lstFichier.AddFin((CFichier*)GetItemData(GetNextSelectedItem(pos)));
}

// Retourner le fichier slectionn, ou NULL s'il n'y a pas de slection
// L'item slectionn doit avoir la marque du focus ET tre slectionn
CFichier* CLstMuzip::GetFichierSel()
{
	// Bug de Windows: on ne peut pas utiliser GetSelectionMark()
	// pendant un LVN_ITEMCHANGED
	POSITION pos = GetFirstSelectedItemPosition();
	while (pos) {
		const int nItem = GetNextSelectedItem(pos);
		if (GetItemState(nItem, LVIS_FOCUSED))
			return (CFichier*)GetItemData(nItem);
	}
	
	return NULL;
}


// Supprimer
void CLstMuzip::OnArchiveMoins()
{
	if (!CDlgConfirm::GetReponse(mcfArchiveMoins, DEM_ARCHIVEMOINS))
		return;
	
	CLstFichier lstSel;
	GetLstFichierSel(lstSel);
	SetRedraw(FALSE);
	DeleteAllItems();
	m_pArc->ArchiveMoins(lstSel);
	m_pArc->m_pi->UpdateView(true);
	SetRedraw(TRUE);
	Invalidate();
}


// Touche enfonce
void CLstMuzip::OnKeyDown(NMHDR* pNMHDR, LRESULT*)
{
	if (((const NMLVKEYDOWN*)pNMHDR)->wVKey==VK_DELETE)
		OnArchiveMoins();
}


// Decompresser
void CLstMuzip::OnArchiveDecomp()
{
	CLstFichier lstSel;
	GetLstFichierSel(lstSel);
	m_pArc->ArchiveDecomp(lstSel, NULL, &oApp.m_dec);
}


// Renommer
void CLstMuzip::OnArchiveRenommer()
{
	EditLabel(GetSelectionMark());
}
void CLstMuzip::OnUpdateArchiveRenommer(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fDansArchive && m_fPasEdit && GetSelectedCount() &&
		!m_pArc->IsLectureSeule());
}


// Proprits
void CLstMuzip::OnArchiveProprietes()
{
	CDlgProprietes dlgProprietes(NULL, this);
	GetLstFichierSel(dlgProprietes.m_lstFichier);
	dlgProprietes.DoModal();
}

// Recompresser
void CLstMuzip::OnArchiveRecomp()
{
	CLstFichier lstFichier;
	GetLstFichierSel(lstFichier);
	m_pArc->ArchiveRecomp(lstFichier);
}


// Mettre en cache
void CLstMuzip::OnArchiveCacher()
{
	CLstFichier lstFichier;
	GetLstFichierSel(lstFichier);
	m_pArc->CacheAddRef(lstFichier);
}


// Tester
void CLstMuzip::OnArchiveTester()
{
	CLstFichier lstSel;
	GetLstFichierSel(lstSel);
	if (!lstSel.GetNb())
		m_pArc->ListerFichier(lstSel);
	m_pArc->ArchiveTester(lstSel);
	SetFocus();
}


// Localiser dans l'archive
void CLstMuzip::OnArchiveLocaliser()
{
	// Slectionner le fichier
	m_pArc->m_pi->SelFichier(((CFichier*)GetItemData(GetSelectionMark())));
}


// Clic sur une colonne
void CLstMuzip::OnColumnClick(NMHDR* pNMHDR, LRESULT*)
{
	const int iSubItem = ((const NMLISTVIEW*)pNMHDR)->iSubItem;
	
	// Trier les items selon la colonne clique
	if (m_nTriColonne==iSubItem)  m_fTriSens    = !m_fTriSens;
	else                          m_nTriColonne = iSubItem;
	Trier();
}


// Double-clic
void CLstMuzip::OnItemActivate(NMHDR*, LRESULT*)
{
	// Rcuprer le dossier temporaire
	TCHAR pszDossierTemp[MAX_PATH];
	if (!e_opt.GetDossier(repTemp, pszDossierTemp))
		return;
	
	// Mettre en cache et excuter les fichiers slectionns
	POSITION pos = GetFirstSelectedItemPosition();
	while (pos) {
		CFichier *const pFichier = (CFichier*)GetItemData(GetNextSelectedItem(pos));
		
		// Mettre le fichier en cache
		CString sDir, sFile;
		pFichier->m_pDossier->GetCacheDir(sDir);
		if (!pFichier->CacheAddRef(sFile))
			break;
		
		// L'excuter
		pFichier->SurvExecuter(sFile, sDir);
	}
	oApp.m_fMsg = true;
}


// - Si les pointeurs p1 et p2 sont nuls, impossible de trier
// - Si le tri est dcroissant, changer p1 et p2
//   pour inverser le rsultat de la comparaison,
//   et rendre lParamSort positif pour qu'il contienne
//   le numro de la colonne  trier  partir de 1

// Trier le contenu d'un dossier
int CALLBACK CLstMuzip::prcTriDossier(CFichier* p1, CFichier* p2, LPARAM nColonne)
{
	if (!p1 || !p2)
		return 0;
	
	// changer les deux lments  comparer
	// si on doit trier dans l'autre sens (colonne ngative)
	if (nColonne<0) {
		nColonne = -nColonne;
		CFichier *const p3 = p1;
		p1 = p2;
		p2 = p3;
	}
	
	switch (nColonne) {
		
		case 1:
			// Nom
			return lstrcmpi(p1->m_pszNom, p2->m_pszNom);
		
		case 2:
			// Type
			
			// Rcuprer le type des fichiers
			SHFILEINFO shfi1;
			SHGetFileInfo(p1->m_pszNom, FILE_ATTRIBUTE_NORMAL,
				&shfi1, sizeof(shfi1), SHGFI_USEFILEATTRIBUTES | SHGFI_TYPENAME);
			SHFILEINFO shfi2;
			SHGetFileInfo(p2->m_pszNom, FILE_ATTRIBUTE_NORMAL,
				&shfi2, sizeof(shfi2), SHGFI_USEFILEATTRIBUTES | SHGFI_TYPENAME);
			return lstrcmpi(shfi1.szTypeName, shfi2.szTypeName);
		
		case 3:
			// Taille
			return p1->m_dwTailleN - p2->m_dwTailleN;
		
		case 4:
			// Compress
			return p1->m_dwTailleC - p2->m_dwTailleC;
		
		case 5:
			// %
			return p1->m_nPC - p2->m_nPC;
		
		case 6:
			// Modifi
			return (int)(p1->m_dtM - p2->m_dtM).GetTotalSeconde();
		
		case 7:
			// Attributs
			return lstrcmp(p1->m_pszAttr, p2->m_pszAttr);
		
		case 8:
			// Chemin d'accs
			return lstrcmpi(p1->m_pDossier->m_pszPath, p2->m_pDossier->m_pszPath);
		
		default:
			return 0;
	}
}

// Trier selon une colonne prcise
// Si inewTriSens n'est pas prcis, inverse le sens du tri
// Si inewTriSens>0, tri croissant; Si inewTriSens<0, tri dcroissant
// Si rien n'est spcifi, met  jour le tri
void CLstMuzip::Trier()
{
	CHeaderCtrl *const phdr = GetHeaderCtrl();
	const int nbItem = phdr->GetItemCount();
	
	// Placer l'image correspondant au sens du tri
	// sur la bonne colonne
	HDITEM hdi;
	for (int i=0; i<nbItem; i++) {
		hdi.mask     = HDI_FORMAT;
		phdr->GetItem(i, &hdi);
		if (i==m_nTriColonne) {
			hdi.mask   = HDI_FORMAT | HDI_IMAGE;
			hdi.fmt   |= HDF_IMAGE;
			hdi.iImage = m_fTriSens;
		}else{
			hdi.mask   = HDI_FORMAT;
			hdi.fmt   &= ~HDF_IMAGE;
		}
		phdr->SetItem(i, &hdi);
	}
	
	// Effectuer le tri
	SortItems((PFNLVCOMPARE)prcTriDossier, (m_nTriColonne+1) * ((m_fTriSens) ? -1 : 1));
}


// Options modifies
void CLstMuzip::OnOptionsChange()
{
	// Mettre  jour les styles tendus
	SetExtendedStyle(e_opt.m_nAffichageStyleEx);
	
	// Redessiner les items visibles
	const int nb    = GetItemCount();
	const int iHaut = GetTopIndex();
	const int iBas  = iHaut + GetCountPerPage()+1;
	RedrawItems(iHaut, (iBas<nb) ? iBas : nb-1);
	UpdateWindow();
}



// Initialiser une liste
void CLstMuzip::InitListCtrl(CListCtrl& lst)
{
	CHeaderCtrl *const phdr = lst.GetHeaderCtrl();
	
	// Styles
	lst.SetExtendedStyle(LVS_EX_HEADERDRAGDROP | e_opt.m_nAffichageStyleEx);
	phdr->ModifyStyle(0, HDS_FULLDRAG | HDS_DRAGDROP);
	
	// Liste d'images de l'en-tte des colonnes
	if (!s_imlHdr)
		s_imlHdr.Create(IDB_TRI, 16, 2, RGB(192,192,192));
	
	// Crer les colonnes
	static const LIST_HEADER alh[nbColonne] =
	{
		{ LVCFMT_LEFT,   150 },   // Nom
		{ LVCFMT_LEFT,   130 },   // Type
		{ LVCFMT_RIGHT,  100 },   // Taille
		{ LVCFMT_RIGHT,  100 },   // Compress
		{ LVCFMT_CENTER,  45 },   // %
		{ LVCFMT_CENTER, 120 },   // Modifi
		{ LVCFMT_LEFT,    50 },   // Attributs
		{ LVCFMT_LEFT,   100 },   // Chemin
	};
	FillListHeader(lst, IDS_COL_VIEW, alh);
	
	// Affecter la liste d'images systme  la liste,
	// et notre liste d'images  l'en-tte
	ListView_SetImageList(lst, oApp.m_himlSystem, LVSIL_SMALL);
	lst.GetHeaderCtrl()->SetImageList(&s_imlHdr);
}


// Barre d'tat
CString CLstMuzip::OnUpdateIndicatorEtat(UINT nID)
{
	// Faire la somme des tailles des fichiers
	LONGLONG ddwTailleN = 0;
	
	if (nID==ID_INDICATOR_SEL) {
		POSITION pos = GetFirstSelectedItemPosition();
		while (pos) {
			const CFichier *const pFichier = (CFichier*)GetItemData(GetNextSelectedItem(pos));
			ddwTailleN += pFichier->m_dwTailleN;
		}
	}else{
		LVITEM lvi;
		lvi.iItem = GetItemCount();
		lvi.mask  = LVIF_PARAM;
		while (--lvi.iItem>=0) {
			GetItem(&lvi);
			ddwTailleN += ((CFichier*)lvi.lParam)->m_dwTailleN;
		}
	}
	
	// Formatter
	WCHAR osz[128];
	StrFormatByteSizeW(ddwTailleN, osz, nbArray(osz));
	CString s;
	if (nID==ID_INDICATOR_SEL)
		s.Format(IDS_FMTSEL,   GetSelectedCount(), osz);
	else
		s.Format(IDS_FMTTOTAL, GetItemCount(),     osz);
	
	return s;
}


// Message
void CLstMuzip::OnWindowProc(UINT uMsg, WPARAM, LPARAM)
{
	if      (uMsg==WM_LBUTTONDOWN)  m_fPeutDrag = true;
	else if (uMsg==WM_LBUTTONUP)    m_fPeutDrag = false;
}


// Clic
void CLstMuzip::OnClick(NMHDR*, LRESULT*)
{
	m_fPeutDrag = false;
}


// MAJ: Un fichier au moins doit tre slectionn
void CLstMuzip::OnUpdateFautSel(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fPasEdit && GetSelectedCount());
}

// MAJ: Un fichier au moins doit tre slectionn,
// et l'archive doit tre modifiable
void CLstMuzip::OnUpdateFautSelModif(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fPasEdit && GetSelectedCount() &&
		!m_pArc->IsLectureSeule());
}

// MAJ: Il faut au moins un fichier dans la liste
void CLstMuzip::OnUpdateFautUnFichier(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fPasEdit && GetItemCount());
}


// Commande
BOOL CLstMuzip::OnCommand(WPARAM wParam, LPARAM lParam)
{
	return (IsWindowEnabled())
		? CListCtrl::OnCommand(wParam, lParam) : FALSE;
}
