// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// lstMuzip.h


#ifndef _LSTMUZIP_H_
#define _LSTMUZIP_H_
#if _MSC_VER>1000
#pragma once
#endif

#include <ShellMenu.h>

#include "Global.h"
class CMuzipArc;


class CLstMuzip : public CListCtrl
{
	friend class CMuzipView;
	
public:  // Fonctions
	
	CLstMuzip();
	
	void AttachArc(CMuzipArc* pArc) { m_pArc = pArc; }
	void Init(int nContextMenu);
	
	void GetLstFichierSel(CLstFichier& lstFichier);
	CFichier* GetFichierSel();
	
	void Trier();
	
	void OnOptionsChange();
	
	CString OnUpdateIndicatorEtat(UINT nID);
	
	void OnWindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	
	
public:  // Donnes
	
	bool m_fDansArchive;
	
	bool m_fPasEdit;     // FALSE si un item est en cours de renommage
	bool m_fPeutDrag;    // TRUE si glisser-dplacer possible
	
	CShellMenu m_sm;     // Gestion du menu contextuel du shell
	
	
	enum{ nbColonne = 8 };
	
	
protected:  // Interne
	
	CMuzipArc *m_pArc;
	
	int        m_nContextMenu;   // Index du menu contextuel
	
	int        m_nTriColonne;    // Colonne trie
	bool       m_fTriSens;       // Sens de tri
	
	static int CALLBACK prcTriDossier(CFichier* p1, CFichier* p2, LPARAM nColonne);
	
	static CImageList s_imlHdr;   // Liste d'images de sens du tri
	
	
public:  // Statique
	
	static void InitListCtrl(CListCtrl& lst);
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CLstMuzip)
	public:
	virtual LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
#ifdef _DEBUG
	// Beau bidouillage: CWnd::AssertValid() pose des problmes
	// avec notre histoire de m_hWnd identique pour CLstMuzip et CMuzipView
	virtual void AssertValid() const {}
#endif
	
	
protected:  // Messages
	
	//{{AFX_MSG(CLstMuzip)
	afx_msg void OnGetDispInfo (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRClick      (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBeginDrag   (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeyDown     (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnClick (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemActivate(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClick       (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnArchiveMoins();
	afx_msg void OnArchiveDecomp();
	afx_msg void OnArchiveRenommer();
	afx_msg void OnArchiveProprietes();
	afx_msg void OnArchiveRecomp();
	afx_msg void OnArchiveTester();
	afx_msg void OnArchiveLocaliser();
	afx_msg void OnUpdateFautSel        (CCmdUI* pCmdUI);
	afx_msg void OnUpdateFautSelModif   (CCmdUI* pCmdUI);
	afx_msg void OnUpdateFautUnFichier  (CCmdUI* pCmdUI);
	afx_msg void OnUpdateArchiveRenommer(CCmdUI* pCmdUI);
	afx_msg void OnArchiveCacher();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
#endif
