// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// ControlBarEx.h
//
// ControlBarEx - classe de base pour les barres d'outils avec effets 3D
//
// REQUIERT
// - ControlBarEx.cpp
// - Application MFC
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _CONTROLBAREX_H_
#define _CONTROLBAREX_H_
#if _MSC_VER>1000
#pragma once
#endif



#ifdef TOOLBAREX_LISTE

class CListeBaseBarEx
{
public:  // Fonctions
	
	CListeBaseBarEx() : m_nb(0), m_a(NULL) {}
	~CListeBaseBarEx() { ASSERT(!m_nb); delete [] m_a; }
	
	void Add(const CControlBar* pBar);
	void Del(const CControlBar* pBar);
	
	bool IsBaseBarEx(const CControlBar* pBar) const;
	
	
protected:  // Interne
	
	int m_nb;
	const CControlBar* *m_a;
};


extern CListeBaseBarEx e_lstBaseBarEx;

#define ISKINDOF_BASEBAREX(p)  e_lstBaseBarEx.IsBaseBarEx((CControlBar*)(p))

#else

#define ISKINDOF_BASEBAREX(p)  false

#endif


// Classe de base
class CBaseBarEx
{
public:  // Fonctions
	
#ifdef TOOLBAREX_REG
	
	// Entres/sorties avec le registre
	virtual void ToReg  (LPCTSTR pszKey) const = 0;
	virtual bool FromReg(LPCTSTR pszKey)       = 0;
	
#endif
};

#ifdef TOOLBAREX_REG

// On ne peut pas mettre ces fonctions dans la classe
//  cause de l'hritage virtuel impossible  mettre en oeuvre
// dans CToolBarEx (classe drive de CToolBar elle-mme drive
// de CControlBar)
void ToReg  (const CControlBar* pBar, LPCTSTR pszKey);
bool FromReg(      CControlBar* pBar, LPCTSTR pszKey);

#endif


#ifdef TOOLBAREX_MENU
void OnToolBarMenu(CFrameWnd* pFrame, CToolBar* ptlb=NULL);
#endif

#endif
