// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Gnew.h
//
// Les fonctions de Gnew quivalent  realloc, mais en utilisant
// exclusivement les oprateurs new et delete
// Elles retournent NULL en cas d'chec
// Si la nouvelle longueur est infrieure  l'ancienne,
// NULL est retourn
//
// REQUIERT
// - Gnew.cpp
// - Application Windows
// - Dans StdAfx.h:
//   #include <string.h>
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _GNEW_H_
#define _GNEW_H_
#if _MSC_VER>1000
#pragma once
#endif


LPSTR  renew(LPSTR  psz, size_t newlen);
LPWSTR renew(LPWSTR psz, size_t newlen);
template <class T>
T* renew(T* pt, size_t newlen, size_t oldlen);

LPSTR  newDup(LPCSTR  psz);
LPWSTR newDup(LPCWSTR psz);
template <class T>
T* newDup(const T* pt, size_t len);


// Equivalent de realloc avec new et pour tous les types de donnes
template <class T>
T* renew(T* pt, size_t newlen, size_t oldlen)
{
	// Vrifer la validit des longueurs
	if (newlen<oldlen)  return pt;
	
	// Crer le nouveau tampon
	T *const ptTemp = new T[newlen];
	memcpy(ptTemp, pt, oldlen*sizeof(T));
	
	// Y copier le tableau puis dtruire l'ancien
	delete [] pt;
	
	return ptTemp;
}


// Equivalent de strdup mais avec new et pour tous les types
template <class T>
T* newDup(const T* pt, size_t len)
{
	T *const ptNew = new T[len];
	memcpy(ptNew, pt, len*sizeof(T));
	return ptNew;
}


#endif
