// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Liste.h
//
// Classes de listes
// CListe1     - liste simplement chane
// CListe2     - liste doublement chane
// CListePtr1  - liste de pointeurs simplement chane
// CListePtr2  - liste de pointeurs doublement chane
// CListePtrA1 - liste de tableaux simplement chane
// CListePtrA2 - liste de tableaux doublement chane
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _LISTE_H_
#define _LISTE_H_
#if _MSC_VER>1000
#pragma once
#endif


#pragma warning (disable: 4701)
typedef void* POS;



// CListe1
// Liste simplement chane
template<class T> class CListe1
{
public:  // Construction/destruction
	
	// Constructeur
	CListe1()
		{
			m_nb  = 0;
			m_pelDeb = NULL;
		}
	
	// Destructeur
	~CListe1()
		{
			RemoveAll();
		}
	
	
public:  // Interface
	
	UINT GetNb() const { return m_nb; }
	
	POS ToPos(UINT nIndex)
		{
			ELEMENT *pel = m_pelDeb;
			while (nIndex) {
				pel = pel->pSuiv;
				nIndex--;
			}
			return (POS)pel;
		}
	
	
	UINT ToIndex(POS pos) const
		{
			ELEMENT *pel = m_pelDeb;
			UINT nIndex = 0;
			while (pel) {
				if ((ELEMENT*)pos==pel)  return nIndex;
				nIndex++;
				pel = pel->pSuiv;
			}
			return (UINT)-1;
		}
	
	
	POS GetPosDeb() const { return (POS)m_pelDeb; }
	POS GetPosFin() const
		{
			ELEMENT *pFin = m_pelDeb;
			while (pFin)  pFin = pFin->pSuiv;
			return (POS)pFin;
		}
	
	
public:  // Ajout/suppression
	
	void AddDeb(const T& t)
		{
			// Crer le nouvel lment
			ELEMENT *const pelNew = new ELEMENT;
			pelNew->t     = t;
			pelNew->pSuiv = m_pelDeb;
			m_nb++;
			
			// Le premier lment est le nouveau
			m_pelDeb = pelNew;
		}
	
	
	void AddFin(const T& t)
		{
			// Crer le nouvel lment
			ELEMENT *const pelNew = new ELEMENT;
			pelNew->t     = t;
			pelNew->pSuiv = NULL;
			m_nb++;
			
			if (m_pelDeb) {
				// Il faut atteindre le dernier lment
				ELEMENT *pFin = m_pelDeb;
				while (pFin->pSuiv)  pFin = pFin->pSuiv;
				pFin->pSuiv = pelNew;
			}else
				// La liste est vide: le premier lment est le nouveau
				m_pelDeb = pelNew;
		}
	
	
	void AddAvant(const T& t, POS pos)
		{
			// Atteindre l'lment spcifi
			ELEMENT *pel    = m_pelDeb;
			ELEMENT *pelOld = NULL;
			while (pel) {
				if ((ELEMENT*)pos==pel) {
					// Crer le nouvel lment
					ELEMENT *const pelNew = new ELEMENT;
					pelNew->t     = t;
					pelNew->pSuiv = pel;
					pelOld->pSuiv = pelNew;
					m_nb++;
					return;
				}
				pelOld = pel;
				pel = pel->pSuiv;
			}
		}
	
	
	void AddApres(const T& t, POS pos)
		{
			// Atteindre l'lment spcifi
			ELEMENT *pel = m_pelDeb;
			while (pel) {
				if ((ELEMENT*)pos==pel) {
					// Crer le nouvel lment
					ELEMENT *const pelNew = new ELEMENT;
					pelNew->t     = t;
					pelNew->pSuiv = pel->pSuiv;
					pel->pSuiv = pelNew;
					m_nb++;
					return;
				}
				pel = pel->pSuiv;
			}
		}
	
	
	void AddDeb(const CListe1<T>& lst)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			ELEMENT *pelSuiv = m_pelDeb;
			ELEMENT *pelPrec = NULL;
			
			ELEMENT *pelNew;
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew    = new ELEMENT;
				pelNew->t = lst.GetSuiv(posLst);
				if (pelPrec)  pelPrec->pSuiv = pelNew;
				else          m_pelDeb       = pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = pelSuiv;
			
			m_nb += lst.GetNb();
		}
	
	
	void AddFin(const CListe1<T>& lst)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			// Atteindre la fin de la liste
			ELEMENT *pelFin = m_pelDeb;
			if (pelFin) {
				while (pelFin->pSuiv)
					pelFin = pelFin->pSuiv;
			}
			
			ELEMENT *pelNew;
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew    = new ELEMENT;
				pelNew->t = lst.GetSuiv(posLst);
				if (pelFin)  pelFin->pSuiv = pelNew;
				else         m_pelDeb      = pelNew;
				
				pelFin = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = NULL;
			
			m_nb += lst.GetNb();
		}
	
	
	void AddAvant(const CListe1<T>& lst, POS pos)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			// Rechercher l'lment prcdent l'lment d'insertion
			ELEMENT *pelNew  = (ELEMENT*)m_pelDeb;
			ELEMENT *pelPrec = NULL;
			while (pelNew) {
				if ((ELEMENT*)pos==pelNew)  break;
				pelPrec = pelNew;
				pelNew = pelNew->pSuiv;
			}
			if (!pelNew)  return;
			
			// Ajouter les lments de la liste  insrer
			//  la suite de l'lment trouv
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew    = new ELEMENT;
				pelNew->t = lst.GetSuiv(posLst);
				if (pelPrec)  pelPrec->pSuiv = pelNew;
				else          m_pelDeb       = pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = (ELEMENT*)pos;
			
			m_nb += lst.GetNb();
		}
	
	
	void AddApres(const CListe1<T>& lst, POS pos)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			ELEMENT *pelPrec = (ELEMENT*)pos;
			ELEMENT *pelSuiv = pelPrec->pSuiv;
			ELEMENT *pelNew;
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew    = new ELEMENT;
				pelNew->t = lst.GetSuiv(posLst);
				if (pelPrec)  pelPrec->pSuiv = pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = pelSuiv;
			
			m_nb += lst.GetNb();
		}
	
	
	void RemoveAt(POS pos)
		{
			// Rechercher l'lment en gardant le prcdent
			ELEMENT *pelPrec = NULL;
			ELEMENT *pel     = m_pelDeb;
			while (pel) {
				if ((ELEMENT*)pos==pel)  break;
				pelPrec = pel;
				pel = pel->pSuiv;
			}
			if (!pel)  return;
			
			// Mettre  jour
			if (pelPrec)  pelPrec->pSuiv = pel->pSuiv;
			else          m_pelDeb       = pel->pSuiv;
			
			delete pel;
			m_nb--;
		}
	
	
	void RemoveAll()
		{
			ELEMENT *pel = m_pelDeb;
			ELEMENT *pelSuiv;
			while (pel) {
				pelSuiv = pel->pSuiv;
				delete pel;
				pel = pelSuiv;
			}
			m_pelDeb = NULL;
			m_nb = 0;
		}
		
		
public:  // Rcupration
	
	const T& GetAt(POS pos)     const { return *(const T*)pos; }
	      T& GetAt(POS pos)           { return *(      T*)pos; }
	const T& GetAt(UINT nIndex) const { return *(const T*)ToPos(nIndex); }
	      T& GetAt(UINT nIndex)       { return *(      T*)ToPos(nIndex); }
	
	void SetAt(POS  pos,    const T& t) { *((T*)pos)           = t; }
	void SetAt(UINT nIndex, const T& t) { *((T*)ToPos(nIndex)) = t; }
	
	const T& GetDeb() const { return GetAt(GetPosDeb()); };
	      T& GetDeb()       { return GetAt(GetPosDeb()); };
	const T& GetFin() const { return GetAt(GetPosFin()); };
	      T& GetFin()       { return GetAt(GetPosFin()); };
	
	POS GetPosSuiv(POS pos) const { return (POS)((ELEMENT*)pos)->pSuiv; }
	
	T& GetSuiv(POS& pos) const
		{
			ELEMENT *pelOld = (ELEMENT*)pos;
			pos = (POS)pelOld->pSuiv;
			return pelOld->t;
		}
	
	
	T& GetPrec(POS& pos) const
		{
			ELEMENT *pel    = m_pelDeb;
			ELEMENT *pelOld = NULL;
			while (pel) {
				if ((ELEMENT*)pos==pel) {
					pos = (POS)pelOld;
					return pelOld->t;
				}
			}
			return m_pelDeb->t;   // Il faut retourner une valeur
		}
	
	POS GetPosPrec(POS pos) const
		{
			ELEMENT *pel    = m_pelDeb;
			ELEMENT *pelOld = NULL;
			while (pel) {
				if ((ELEMENT*)pos==pel) {
					pos = (POS)pelOld;
					return (POS)pelOld;
				}
			}
			return NULL;
		}
	
	
public:  // Recherche
	
	POS Find(const T& t, POS posDeb=NULL) const
		{
			if (!posDeb)  posDeb = GetPosDeb();
			while (posDeb) {
				if (t==GetAt(posDeb))  return posDeb;
				posDeb = GetPosSuiv(posDeb);
			}
			return NULL;
		}
	
	
public: // Oprateurs
	
	const T& operator [] (POS pos)     const { return GetAt(pos); }
	const T& operator [] (UINT nIndex) const { return GetAt(nIndex); }
	      T& operator [] (POS pos)           { return GetAt(pos); }
	      T& operator [] (UINT nIndex)       { return GetAt(nIndex); }
	
	
protected:  // Donnes
	
	// Structure de stockage d'un lment
	struct ELEMENT
	{
		T        t;
		ELEMENT* pSuiv;
	};
	
	UINT     m_nb;      // Nombre d'lments dans la liste
	ELEMENT *m_pelDeb;  // Pointeur sur le premier lment
};



// CListe2
// Liste doublement chane
template<class T> class CListe2 : public CListe1<T>
{
public:  // Construction/destruction
	
	// Constructeur
	CListe2() : CListe1<T>()
		{
			m_pelFin = NULL;
		}
	
	// Destructeur
	~CListe2()
		{
			RemoveAll();
		}
	
	
public:  // Interface
	
	POS ToPos(UINT nIndex) const
		{
			ELEMENT *pel;
			if (nIndex<=m_nb/2) {
				// Il vaut mieux aller du dbut  la fin
				pel = (ELEMENT*)m_pelDeb;
				while (nIndex) {
					pel = pel->pSuiv;
					nIndex--;
				}
			}else{
				// Il vaut mieux aller de la fin au dbut
				pel = m_pelFin;
				nIndex = m_nb-nIndex-1;
				while (nIndex) {
					pel = pel->pPrec;
					nIndex--;
				}
			}
			
			return (POS)pel;
		}
	
	
	POS GetPosFin() const { return (POS)m_pelFin; }
	
	const T& GetFin() const { return GetAt(GetPosFin()); };
	      T& GetFin()       { return GetAt(GetPosFin()); };
	
	
public:  // Ajout/suppression
	
	void AddDeb(const T& t)
		{
			// Crer le nouvel lment
			ELEMENT *const pelNew = new ELEMENT;
			pelNew->t     = t;
			pelNew->pSuiv = (ELEMENT*)m_pelDeb;
			pelNew->pPrec = NULL;
			m_nb++;
			
			// Mettre  jour
			if (m_pelDeb)  ((ELEMENT*)m_pelDeb)->pPrec = pelNew;
			else           m_pelFin                    = pelNew;
			m_pelDeb = (CListe1<T>::ELEMENT*)pelNew;
		}
	
	
	void AddFin(const T& t)
		{
			// Crer le nouvel lment
			ELEMENT *const pelNew = new ELEMENT;
			pelNew->t     = t;
			pelNew->pSuiv = NULL;
			pelNew->pPrec = m_pelFin;
			m_nb++;
			
			// Mettre  jour
			if (m_pelFin)  m_pelFin->pSuiv =                       pelNew;
			else           m_pelDeb        = (CListe1<T>::ELEMENT*)pelNew;
			m_pelFin = pelNew;
		}
	
	
	void AddAvant(const T& t, POS pos)
		{
			#define pel  ((ELEMENT*)pos)
			
			// Crer le nouvel lment
			ELEMENT *const pelNew = new ELEMENT;
			pelNew->t     = t;
			pelNew->pSuiv = pel;
			pelNew->pPrec = pel->pPrec;
			m_nb++;
			if (pel->pPrec)
				pel->pPrec->pSuiv = pelNew;
			else
				m_pelDeb = pelNew;
			pel->pPrec = pelNew;
			
			#undef pel
		}
	
	
	void AddApres(const T& t, POS pos)
		{
			#define pel  ((ELEMENT*)pos)
			
			// Crer le nouvel lment
			ELEMENT *const pelNew = new ELEMENT;
			pelNew->t     = t;
			pelNew->pSuiv = pel->pSuiv;
			pelNew->pPrec = pel;
			m_nb++;
			if (pel->pSuiv)
				pel->pSuiv->pPrec = pelNew;
			else
				m_pelFin = pelNew;
			pel->pSuiv = pelNew;
			
			#undef pel
		}
	
	
	
	void AddDeb(const CListe1<T>& lst)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			ELEMENT *pelOldDeb = (ELEMENT*)m_pelDeb;
			ELEMENT *pelPrec   = NULL;
			ELEMENT *pelNew;
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew        = new ELEMENT;
				pelNew->t     = lst.GetSuiv(posLst);
				pelNew->pPrec = pelPrec;
				
				if (pelPrec)  pelPrec->pSuiv = pelNew;
				else          m_pelDeb = (CListe1<T>::ELEMENT*)pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = pelOldDeb;
			if (!m_nb)   m_pelFin = pelNew;
			
			m_nb += lst.GetNb();
		}
	
	
	void AddFin(const CListe1<T>& lst)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			ELEMENT *pelPrec   = m_pelFin;
			
			ELEMENT *pelNew;
			POS pos = lst.GetPosDeb();
			while (pos) {
				pelNew        = new ELEMENT;
				pelNew->t     = lst.GetSuiv(pos);
				pelNew->pPrec = pelPrec;
				
				if      (pelPrec)  pelPrec->pSuiv = pelNew;
				else if (!m_nb)    m_pelDeb = (CListe1<T>::ELEMENT*)pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			m_pelFin = pelNew;
			pelNew->pSuiv = NULL;
			
			m_nb += lst.GetNb();
		}
	
	
	void AddAvant(const CListe1<T>& lst, POS pos)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			ELEMENT *pelPrec = ((ELEMENT*)pos)->pPrec;
			ELEMENT *pelNew;
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew    = new ELEMENT;
				pelNew->t = lst.GetSuiv(posLst);
				if (pelPrec)  pelPrec->pSuiv = pelNew;
				else          m_pelDeb = (CListe1<T>::ELEMENT*)pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = (ELEMENT*)pos;
			
			m_nb += lst.GetNb();
		}
	
	
	void AddApres(const CListe1<T>& lst, POS pos)
		{
			// Si la liste  ajouter est vide, ne rien faire
			if (!lst.GetNb())  return;
			
			ELEMENT *pelPrec = (ELEMENT*)pos;
			ELEMENT *pelSuiv = pelPrec->pSuiv;
			ELEMENT *pelNew;
			POS posLst = lst.GetPosDeb();
			while (posLst) {
				pelNew        = new ELEMENT;
				pelNew->t     = lst.GetSuiv(posLst);
				pelNew->pPrec = pelPrec;
				if (pelPrec)  pelPrec->pSuiv = pelNew;
				
				pelPrec = pelNew;
			}
			
			// Mettre  jour
			pelNew->pSuiv = pelSuiv;
			if (!pelSuiv)  m_pelFin = pelNew;
			
			m_nb += lst.GetNb();
		}
	
	
	
	void RemoveAt(POS pos)
		{
			#define pel  ((ELEMENT*)pos)
			
			if (pel->pPrec)  pel->pPrec->pSuiv = pel->pSuiv;
			else             m_pelDeb = (CListe1<T>::ELEMENT*)pel->pSuiv;
			
			if (pel->pSuiv)  pel->pSuiv->pPrec = pel->pPrec;
			else             m_pelFin          = pel->pPrec;
			
			delete pel;
			m_nb--;
			
			#undef pel
		}
	
	
	void RemoveAll()
		{
			ELEMENT *pel = (ELEMENT*)m_pelDeb;
			ELEMENT *pelSuiv;
			while (pel) {
				pelSuiv = pel->pSuiv;
				delete pel;
				pel = pelSuiv;
			}
			m_pelDeb = NULL;
			m_pelFin = NULL;
			m_nb = 0;
		}
	
	
public:  // Rcupration
	
	T& GetPrec(POS& pos) const
		{
			ELEMENT *const pelOld = (ELEMENT*)pos;
			pos = (POS)pelOld->pPrec;
			return pelOld->t;
		}
	
	POS GetPosPrec(POS pos) const
		{
			return (POS)((ELEMENT*)pos)->pPrec;
		}
	
	
protected:  // Donnes
	
	// Structure de stockage d'un lment
	struct ELEMENT
	{
		T        t;
		ELEMENT* pSuiv;
		ELEMENT* pPrec;
	};
	
	ELEMENT *m_pelFin;  // Pointeur sur le dernier lment
};


// CListePtr1
// Liste de pointeurs simplement chane
template<class T> class CListePtr1 : public CListe1<T>
{
public:  // Manipulation
	
	CListePtr1(bool fAutoDel=false) : m_fAutoDel(fAutoDel) {}
	
	
	~CListePtr1()
		{
			if (m_fAutoDel)  DeleteAll();
			else             RemoveAll();
		}
	
	
	void DeleteAt(POS pos)
		{
			// Rechercher l'lment en gardant le prcdent
			ELEMENT *pelPrec = NULL;
			ELEMENT *pel     = m_pelDeb;
			while (pel) {
				if ((ELEMENT*)pos==pel)  break;
				pelPrec = pel;
				pel = pel->pSuiv;
			}
			
			// Mettre  jour
			if (pelPrec)  pelPrec->pSuiv = pel->pSuiv;
			else          m_pelDeb       = pel->pSuiv;
			
			delete pel->t;
			delete pel;
			m_nb--;
		}
	
	
	void DeleteAll()
		{
			ELEMENT *pel = m_pelDeb;
			ELEMENT *pelSuiv;
			while (pel) {
				pelSuiv = pel->pSuiv;
				delete pel->t;
				delete pel;
				pel = pelSuiv;
			}
			m_pelDeb = NULL;
			m_nb = 0;
		}
	
	
public:  // Donnes
	
	bool m_fAutoDel;
};


// CListePtr2
// Liste de pointeurs doublement chane
template<class T> class CListePtr2 : public CListe2<T>
{
public:  // Manipulation
	
	CListePtr2(bool fAutoDel=false) : m_fAutoDel(fAutoDel) {}
	
	
	~CListePtr2()
		{
			if (m_fAutoDel)  DeleteAll();
			else             RemoveAll();
		}
	
	
	void DeleteAt(POS pos)
		{
			#define pel  ((ELEMENT*)pos)
			
			if (pel->pPrec)  pel->pPrec->pSuiv = pel->pSuiv;
			else             m_pelDeb = (CListe1<T>::ELEMENT*)pel->pSuiv;
			
			if (pel->pSuiv)  pel->pSuiv->pPrec = pel->pPrec;
			else             m_pelFin          = pel->pPrec;
			
			delete pel->t;
			delete pel;
			m_nb--;
			
			#undef pel
		}
	
	
	void DeleteAll()
		{
			ELEMENT *pel = (ELEMENT*)m_pelDeb;
			ELEMENT *pelSuiv;
			while (pel) {
				pelSuiv = pel->pSuiv;
				delete pel->t;
				delete pel;
				pel = pelSuiv;
			}
			m_pelDeb = NULL;
			m_pelFin = NULL;
			m_nb = 0;
		}
	
	
public:  // Donnes
	
	bool m_fAutoDel;
};


// CListePtrA1
// Liste de tableaux simplement chane
template<class T> class CListePtrA1 : public CListePtr1<T>
{
public:  // Manipulation
	
	CListePtrA1(bool fAutoDel=false) : CListePtr1<T>(fAutoDel) {}
	
	
	void DeleteAt(POS pos)
		{
			// Rechercher l'lment en gardant le prcdent
			ELEMENT *pelPrec = NULL;
			ELEMENT *pel     = m_pelDeb;
			while (pel) {
				if ((ELEMENT*)pos==pel)  break;
				pelPrec = pel;
				pel = pel->pSuiv;
			}
			// Mettre  jour
			if (pelPrec)  pelPrec->pSuiv = pel->pSuiv;
			else          m_pelDeb       = pel->pSuiv;
			
			delete [] pel->t;
			delete    pel;
			m_nb--;
		}
	
	
	void DeleteAll()
		{
			ELEMENT *pel = m_pelDeb;
			ELEMENT *pelSuiv;
			while (pel) {
				pelSuiv = pel->pSuiv;
				delete [] pel->t;
				delete    pel;
				pel = pelSuiv;
			}
			m_pelDeb = NULL;
			m_nb = 0;
		}
};


// CListePtrA2
// Liste de tableaux doublement chane
template<class T> class CListePtrA2 : public CListePtr2<T>
{
public:  // Manipulation
	
	CListePtrA2(bool fAutoDel=false) : CListePtr2<T>(fAutoDel) {}
	
	
	void DeleteAt(POS pos)
		{
			#define pel  ((ELEMENT*)pos)
			
			if (pel->pPrec)  pel->pPrec->pSuiv = pel->pSuiv;
			else             m_pelDeb = (CListe1<T>::ELEMENT*)pel->pSuiv;
			
			if (pel->pSuiv)  pel->pSuiv->pPrec = pel->pPrec;
			else             m_pelFin          = pel->pPrec;
			
			delete [] pel->t;
			delete    pel;
			m_nb--;
			
			#undef pel
		}
	
	
	void DeleteAll()
		{
			ELEMENT *pel = (ELEMENT*)m_pelDeb;
			ELEMENT *pelSuiv;
			while (pel) {
				pelSuiv = pel->pSuiv;
				delete [] pel->t;
				delete    pel;
				pel = pelSuiv;
			}
			m_pelDeb = NULL;
			m_pelFin = NULL;
			m_nb = 0;
		}
};


typedef CListePtrA1<LPTSTR>  CLstStr1;
typedef CListePtrA2<LPTSTR>  CLstStr2;
typedef CListePtrA1<LPSTR>   CLstAStr1;
typedef CListePtrA2<LPSTR>   CLstAStr2;
#ifdef MFCOK
typedef CListe1    <CString> CLstCString1;
typedef CListe2    <CString> CLstCString2;
#endif


#pragma warning (default: 4701)
#endif
