// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// MemDC.h
//
// Copyright (C) 1997, 1998 par Joerg Koenig
//
// CMemDC - Gre un DC en mmoire pour viter le scintillement  l'cran
//
// REQUIERT
// - Application MFC
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _MEMDC_H_
#define _MEMDC_H_


class CMemDC : public CDC
{
public:  // Fonctions
	
	// Constructeur
	CMemDC(CDC* pDC)
		{
			ASSERT_VALID(pDC);
			
			m_oldBitmap = NULL;
			m_pDC = pDC;
			
			m_fMemDC = !pDC->IsPrinting();
			
			if (m_fMemDC) {
				// Crer un DC mmoire
				CreateCompatibleDC(pDC);
				pDC->GetClipBox(&m_rc);
				m_bitmap.CreateCompatibleBitmap(pDC, m_rc.Width(), m_rc.Height());
				m_oldBitmap = SelectObject(&m_bitmap);
				SetWindowOrg(m_rc.left, m_rc.top);
			}else{
				// Faire une copie du DC courant pour l'impression
				m_bPrinting = pDC->m_bPrinting;
				m_hDC       = pDC->m_hDC;
				m_hAttribDC = pDC->m_hAttribDC;
			}
		}
	
	// Destructeur
	~CMemDC()
		{
			if (m_fMemDC) {
				// Copier la bitmap hors-cran  l'cran
				m_pDC->BitBlt(
					      m_rc.left, m_rc.top, m_rc.Width(), m_rc.Height(),
					this, m_rc.left, m_rc.top, SRCCOPY);
				// Reprendre la bitmap originale
				SelectObject(m_oldBitmap);
			}else
				// Tout ce dont on a besoin est de remplacer le DC
				// par une valeur invalide
				// Cela empche la destruction du DC
				m_hDC = m_hAttribDC = NULL;
		}
	
	
protected:  // Donnes
	
	CBitmap  m_bitmap;      // Bitmap hors cran
	CBitmap *m_oldBitmap;   // Ancienne bitmap du DC
	CDC     *m_pDC;         // DC pass au constructeur
	CRect    m_rc;          // Zone de dessin
	bool     m_fMemDC;      // TRUE si m_pDC est rellement un DC mmoire
};


#endif
