// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Pidl.h
//
// CPidlManager - aide  la gestion des PIDL et des interfaces IShellFolder
//
// Une seule instance suffit pour cette classe,
// elle est dj cre sous le nom de e_pidlManager
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _PIDL_H_
#define _PIDL_H_
#if _MSC_VER>1000
#pragma once
#endif


#include <ShlObj.h>


class CPidlManager
{
public:  // Fonctions
	
	CPidlManager()
		{
			SHGetMalloc       (&m_pMalloc);
			SHGetDesktopFolder(&m_psfDesktop);
		}
	
	~CPidlManager()
		{
			m_pMalloc   ->Release();
			m_psfDesktop->Release();
		}
	
	
	void         Free   (void*         pv) { m_pMalloc->Free(pv); }
	ULONG        GetLen (LPCITEMIDLIST pidl);
	LPITEMIDLIST GetLast(LPCITEMIDLIST pidl);
	LPITEMIDLIST Concat (LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2);
	
	LPITEMIDLIST  GetFile  (LPCTSTR pszFichier);
	LPITEMIDLIST  GetFile  (IShellFolder* psf, LPCTSTR pszFichier);
	IShellFolder* GetFolder(LPCTSTR pszDossier);
	
	operator IMalloc* () { return m_pMalloc; }
	
	IShellFolder* GetDesktop() { return m_psfDesktop; }
	
	
protected:  // Donnes
	
	IMalloc      *m_pMalloc;
	IShellFolder *m_psfDesktop;
};


extern CPidlManager e_pidlManager;


//{{AFX_INSERT_LOCATION}}
#endif
