// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// ShellMenu.h
//
// CShellMenu - permet de crer des menus ayant le mme contenu
// que le menu contextuel affich par le shell lorsqu'on clique
// droit sur un/des fichier(s) ou un dossier
//
// REQUIERT
// - ShellMenu.cpp
// - Application MFC
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _SHELLMENU_H_
#define _SHELLMENU_H_
#if _MSC_VER>1000
#pragma once
#endif


#include <ShlObj.h>

interface IContextMenu3;


class CShellMenu
{
public:  // Fonctions
	
	CShellMenu() : m_pMenu(NULL), m_pcm(NULL) {}
	~CShellMenu() { Nettoyer(); }
	
	void Nettoyer();
	
	void  SetWnd(CWnd* pWnd) { m_pWnd = pWnd; }
	CWnd* GetWnd() { return m_pWnd; }
	
	void   SetMenu(CMenu* pMenu) { m_pMenu = pMenu; }
	CMenu* GetMenu() { return m_pMenu; }
	
	void InitFolder(IShellFolder* psf);
	void InitFiles(IShellFolder* psf, int nb, const LPCITEMIDLIST* apidl);
	
	bool WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT* plResult);
	
	
protected:  // Interne
	
	CWnd          *m_pWnd;      // Fentre grant le menu
	
	int            m_ncm;       // Numro de version (1, 2, ou 3)
	IContextMenu3 *m_pcm;       // Interface du menu courant
	CMenu         *m_pMenu;     // Menu
};


#endif
