// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Temps.inl
//
// Fonctions inline de Temps.h
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _TEMPS_INL_
#define _TEMPS_INL_
#if _MSC_VER>1000
#pragma once
#endif


//*** CTemps

inline CTempsSpan CTemps::operator - (CTemps tps) const
{
	return CTempsSpan(m_tps - tps.m_tps);
}

inline CTemps  CTemps::operator +  (CTempsSpan ts) const
{
	return m_tps + ts.GetTotalSeconde();
}
inline CTemps  CTemps::operator -  (CTempsSpan ts) const
{
	return (long)m_tps - ts.GetTotalSeconde();
}

inline CTemps& CTemps::operator += (CTempsSpan ts)
{
	m_tps += ts.GetTotalSeconde();
	return *this;
}
inline CTemps& CTemps::operator -= (CTempsSpan ts)
{
	m_tps -= ts.GetTotalSeconde();
	return *this;
}

inline bool CTemps::operator == (CTemps tps) const { return m_tps==tps.m_tps; }
inline bool CTemps::operator != (CTemps tps) const { return m_tps!=tps.m_tps; }
inline bool CTemps::operator <  (CTemps tps) const { return m_tps< tps.m_tps; }
inline bool CTemps::operator >  (CTemps tps) const { return m_tps> tps.m_tps; }
inline bool CTemps::operator <= (CTemps tps) const { return m_tps<=tps.m_tps; }
inline bool CTemps::operator >= (CTemps tps) const { return m_tps>=tps.m_tps; }

inline CTemps::operator TEMPS() const { return m_tps; }



//*** CTempsX


#ifdef MFCOK

// CTempsX::operator CTime() const
#define dclD(type)   inline CTemps##type::operator CTime() const {
#define dclF         ; }
#define ret(uJour, uMois, uAn, uHeure, uMinute, uSeconde) \
	return CTime((int)uAn, (int)uMois, (int)uJour, (int)uHeure, (int)uMinute, (int)uSeconde)
dclD(D  )  ret(m_uJour, m_uMois,  m_uAn,        0,         0,          0)  dclF
dclD( H )  ret(    1,         1,   2000, m_uHeure, m_uMinute,          0)  dclF
dclD(DH )  ret(m_uJour, m_uMois,  m_uAn, m_uHeure, m_uMinute,          0)  dclF
dclD( HS)  ret(    1,         1,   2000, m_uHeure, m_uMinute, m_uSeconde)  dclF
dclD(DHS)  ret(m_uJour, m_uMois,  m_uAn, m_uHeure, m_uMinute, m_uSeconde)  dclF
#undef ret
#undef dclD
#undef dclF

#endif // MFCOK


#endif
