// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// TrvExplore.h
//
// CTrvExplore - arborescence
//
// Cette classe gre entirement une arborescence comme celle
// affiche par SHBrowseForFolder()
//
// REQUIERT
// - TrvExplore.cpp, ShellMenu.cpp, Pidl.cpp
// - Application MFC
// - Dans StdAfx.h:
//   #pragma include_alias("AppResource.h", "../RpertoireProjet/Resource.h")
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#ifndef _TRVEXPLORE_H_
#define _TRVEXPLORE_H_
#if _MSC_VER>1000
#pragma once
#endif


#include <ShlObj.h>

#include <ShellMenu.h>


class CTrvExplore : public CTreeCtrl
{
public:  // Fonctions
	
	CTrvExplore() : m_pidlMyComputer(NULL) { m_sm.SetWnd(this); }
	
	
	void Init();
	
	CString GetPath() const;
	void    GetPath(LPTSTR  pszPath) const;
	bool    SetPath(LPCTSTR pszPath);
	
	HTREEITEM PathToItem(LPCTSTR pszPath);
	
	void NouveauDossier();
	
	void UpdateItem(HTREEITEM hti);
	
	
protected:  // Donnes
	
	// Donnes attaches  chaque item
	struct ITEMDATA
	{
		HTREEITEM     hti;       // Item
		LPITEMIDLIST  pidl;      // PIDL du dossier
		IShellFolder *psf;       // Interface IShellFolder
		
		bool GetPath(LPTSTR psz);
	};
	
	bool m_fFautPasEditLabel;   // TRUE s'il faut enlever le style TVS_EDITLABELS
	
	LPITEMIDLIST  m_pidlMyComputer;
	HTREEITEM     m_htiMyComputer;
	IShellFolder *m_psfMyComputer;
	
	CShellMenu m_sm;   // Gestion du menu du shell
	
	
protected:  // Fonctions internes
	
	void CleanItem     (HTREEITEM hti);
	void CleanChildItem(HTREEITEM hti);
	
	void Lister(ITEMDATA* pid, HTREEITEM htiParent);
	
	
public:  // Hritage
	
	//{{AFX_VIRTUAL(CTrvExplore)
	protected:
	virtual LPARAM WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
	
	
protected:  // Messages
	
	//{{AFX_MSG(CTrvExplore)
	afx_msg void OnDestroy();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRClick       (NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemExpanding(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndLabelEdit (NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


void AFXAPI DDX_TrvExplore(CDataExchange* pDX, int nIDC, CTrvExplore& rtre);
void AFXAPI DDX_TrvExplore(CDataExchange* pDX, int nIDC, CTrvExplore& rtre, LPCTSTR pszPathInit);


//{{AFX_INSERT_LOCATION}}
#endif
