// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Gnew.cpp
//
// Les fonctions de Gnew quivalent  realloc, mais en utilisant
// exclusivement les oprateurs new et delete
// Elles retournent NULL en cas d'chec
// Si la nouvelle longueur est infrieure  l'ancienne,
// NULL est retourn
//
// REQUIERT
// - Application Windows
// - Dans StdAfx.h:
//   #include <string.h>
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Gnew.h"


// Equivalent de realloc avec new et pour les chanes
LPSTR renew(LPSTR asz, size_t newlen)
{
	// Vrifer la validit des longueurs
	if (strlen(asz)+1>newlen)  return asz;
	
	// Crer le nouveau tampon
	LPSTR aszTemp = new char[newlen];
	if (!aszTemp)  return NULL;
	
	// Y copier la chane puis dtruire l'ancienne
	strcpy(aszTemp, asz);
	delete [] asz;
	return aszTemp;
}
LPWSTR renew(LPWSTR wsz, size_t newlen)
{
	// Vrifer la validit des longueurs
	if (wcslen(wsz)+1>newlen)  return wsz;
	
	// Crer le nouveau tampon
	LPWSTR wszTemp = new WCHAR[newlen];
	if (!wszTemp)  return NULL;
	
	// Y copier la chane puis dtruire l'ancienne
	wcscpy(wszTemp, wsz);
	delete [] wsz;
	return wszTemp;
}


// Equivalent de strdup mais avec new
LPSTR newDup(LPCSTR asz)
{
	const LPSTR aszNew = new char[strlen(asz)+1];
	if (aszNew)  strcpy(aszNew, asz);
	return aszNew;
}
LPWSTR newDup(LPCWSTR wsz)
{
	const LPWSTR wszNew = new WCHAR[wcslen(wsz)+1];
	if (wszNew)  wcscpy(wszNew, wsz);
	return wszNew;
}
