// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// Pidl.cpp
//
// CPidlManager - aide  la gestion des PIDL et des interfaces IShellFolder
//
// Une seule instance suffit pour cette classe,
// elle est dj cre sous le nom de e_pidlManager
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Pidl.h"

#include <GUnicode.h>


CPidlManager e_pidlManager;


// Retourner la taille totale d'un PIDL
ULONG CPidlManager::GetLen(LPCITEMIDLIST pidl)
{
	ULONG lenTotal = sizeof(ITEMIDLIST);   // Zro final
	
	while (pidl->mkid.cb) {
		lenTotal += pidl->mkid.cb;
		pidl = (LPCITEMIDLIST)(((BYTE*)pidl)+pidl->mkid.cb);
	}
	
	return lenTotal;
}

// Rcuprer la dernire partie du PIDL
LPITEMIDLIST CPidlManager::GetLast(LPCITEMIDLIST pidl)
{
	LPITEMIDLIST pidlLast = NULL;
	
	while (pidl->mkid.cb) {
		pidlLast = (LPITEMIDLIST)pidl;
		pidl = (LPCITEMIDLIST)(((BYTE*)pidl)+pidl->mkid.cb);
	}
	
	return pidlLast;
}

// Concatner deux PIDL
LPITEMIDLIST CPidlManager::Concat(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2)
{
	const ULONG len1 = GetLen(pidl1) - sizeof(ITEMIDLIST);
	const ULONG len2 = GetLen(pidl2);
	
	const LPITEMIDLIST pidl = (LPITEMIDLIST)m_pMalloc->Alloc(len1+len2);
	memcpy(pidl, pidl1, len1);
	memcpy(((BYTE*)pidl)+len1, pidl2, len2);
	return pidl;
}


// Rcuprer le PIDL d'un fichier  partir de son chemin d'accs
LPITEMIDLIST CPidlManager::GetFile(LPCTSTR pszFichier)
{
	// Rcuprer le PIDL  partir du bureau
	inittoWC(oszFichier, pszFichier, MAX_PATH);
	ULONG len;
	LPITEMIDLIST pidl;
	return (SUCCEEDED(m_psfDesktop->ParseDisplayName(NULL, NULL,
			(LPWSTR)oszFichier, &len, &pidl, NULL)))
		? pidl : NULL;
}

// Rcuprer le PIDL d'un fichier  partir d'un dossier
// et de son chemin d'accs relatif
LPITEMIDLIST CPidlManager::GetFile(IShellFolder* psf, LPCTSTR pszFichier)
{
	// Rcuprer le PIDL  partir du bureau
	inittoWC(oszFichier, pszFichier, MAX_PATH);
	ULONG len;
	LPITEMIDLIST pidl;
	return (SUCCEEDED(psf->ParseDisplayName(NULL, NULL,
			(LPWSTR)oszFichier, &len, &pidl, NULL)))
		? pidl : NULL;
}

// Rcuprer d'un dossier  partir de son chemin d'accs
IShellFolder* CPidlManager::GetFolder(LPCTSTR pszDossier)
{
	// Rcuprer le PIDL du dossier  partir du bureau
	inittoWC(oszDossier, pszDossier, MAX_PATH);
	ULONG len;
	LPITEMIDLIST pidl;
	if (FAILED(m_psfDesktop->ParseDisplayName(NULL, NULL,
			(LPWSTR)oszDossier, &len, &pidl, NULL)))
		return NULL;
	
	// Rcuprer l'interface du dossier  partir du bureau et du pidl
	IShellFolder *psf;
	if (FAILED(m_psfDesktop->BindToObject(pidl, NULL,
			IID_IShellFolder, (void**)&psf)))
		psf = NULL;
	
	Free(pidl);
	
	return psf;
}
