// Muzip 4.03
// 11 fvrier 2005
//
//
// Copyright (C) 2005 Guillaume Ryder
// gryder@club-internet.fr
// http://utilfr42.free.fr/muzip/
//
// Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
// le modifier conformment aux dispositions de la Licence Publique Gnrale
// GNU, telle que publie par la Free Software Foundation ; version 2 de la
// licence, ou encore ( votre choix) toute version ultrieure.
//
// Ce programme est distribu dans l'espoir qu'il sera utile, mais
// SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
// ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
// voir la Licence Publique Gnrale GNU.
//
// Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU
// en mme temps que ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.


// SysObject.cpp
//
// CSysObject - maintenance des couleurs systmes
//
// Cette classe partage les objets GDI et les couleurs systmes
// entre toutes les barres d'outils, afin d'viter de les stocker
// pour chaque contrle qui les utilise.
//  la rception de WM_SYSCOLORCHANGE, la fonction MAJ()
// doit tre appele
//
// REQUIERT
// - Application MFC
//
// Guillaume Ryder, gryder@netcourrier.com, http://utilfr42.free.fr/


#include "StdAfx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIFILE
static char THIFILE[] = __FILE__;
#endif
#include "SysObject.h"


CSysObject CSysObject::s_sysObject;
CFont      CSysObject::fntGui;
COLORREF   CSysObject::clBtnFace;
COLORREF   CSysObject::clBtnHilight;
COLORREF   CSysObject::clBtnShadow;
COLORREF   CSysObject::clBtnLight;
COLORREF   CSysObject::clMenu;
CBrush     CSysObject::brBtnFace;
CBrush     CSysObject::brBtnHilight;
CBrush     CSysObject::brBtnShadow;
CBrush     CSysObject::brBtnLight;


// Rcuprer les couleurs systmes
void CSysObject::MAJ()
{
	// Crer la police utilise pour les boutons  texte
	CFont fnt;
	bool fAncien = false;
	if (!fnt.CreateStockObject(DEFAULT_GUI_FONT)) {
		// Les anciennes versions de Windows (NT 3.51 par exemple)
		// n'acceptent pas DEFAULT_GUI_FONT
		VERIFY(fnt.CreateStockObject(SYSTEM_FONT));
		fAncien = true;
	}
	
	LOGFONT lf;
	fnt.GetLogFont(&lf);
	if (fAncien) {
		lf.lfWeight = 400;
		lstrcpy(lf.lfFaceName, _T("MS Sans Serif"));
	}
	lf.lfHeight = 6;
	lf.lfWidth  = 0;  // Laisser Windows calculer
	fntGui.DeleteObject();
	VERIFY(fntGui.CreateFontIndirect(&lf));
	
	clBtnFace    = ::GetSysColor(COLOR_BTNFACE);
	clBtnHilight = ::GetSysColor(COLOR_BTNHILIGHT);
	clBtnShadow  = ::GetSysColor(COLOR_BTNSHADOW);
	clBtnLight   = ::GetSysColor(COLOR_3DLIGHT);
	clMenu       = ::GetSysColor(COLOR_MENU);
	brBtnFace   .DeleteObject();
	brBtnHilight.DeleteObject();
	brBtnShadow .DeleteObject();
	brBtnFace   .CreateSysColorBrush(COLOR_BTNFACE);
	brBtnHilight.CreateSysColorBrush(COLOR_BTNHILIGHT);
	brBtnShadow .CreateSysColorBrush(COLOR_BTNSHADOW);
	
	// Certains systmes ne font pas la diffrence
	// entre COLOR_BTNFACE et COLOR_3DLIGHT
	brBtnLight.DeleteObject();
	if (clBtnFace==clBtnLight) {
		clBtnLight = clBtnHilight;
		brBtnLight.CreateSysColorBrush(COLOR_BTNHILIGHT);
	}else
		brBtnLight.CreateSysColorBrush(COLOR_3DLIGHT);
}
